// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/accessapproval/v1/accessapproval.proto
// Original file comments:
// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faccessapproval_2fv1_2faccessapproval_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faccessapproval_2fv1_2faccessapproval_2eproto__INCLUDED

#include "google/cloud/accessapproval/v1/accessapproval.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace accessapproval {
namespace v1 {

// This API allows a customer to manage accesses to cloud resources by
// Google personnel. It defines the following resource model:
//
// - The API has a collection of
//   [ApprovalRequest][google.cloud.accessapproval.v1.ApprovalRequest]
//   resources, named `approvalRequests/{approval_request}`
// - The API has top-level settings per Project/Folder/Organization, named
//   `accessApprovalSettings`
//
// The service also periodically emails a list of recipients, defined at the
// Project/Folder/Organization level in the accessApprovalSettings, when there
// is a pending ApprovalRequest for them to act on. The ApprovalRequests can
// also optionally be published to a Pub/Sub topic owned by the customer
// (contact support if you would like to enable Pub/Sub notifications).
//
// ApprovalRequests can be approved or dismissed. Google personnel can only
// access the indicated resource or resources if the request is approved
// (subject to some exclusions:
// https://cloud.google.com/access-approval/docs/overview#exclusions).
//
// Note: Using Access Approval functionality will mean that Google may not be
// able to meet the SLAs for your chosen products, as any support response times
// may be dramatically increased. As such the SLAs do not apply to any service
// disruption to the extent impacted by Customer's use of Access Approval. Do
// not enable Access Approval for projects where you may require high service
// availability and rapid response by Google Cloud Support.
//
// After a request is approved or dismissed, no further action may be taken on
// it. Requests with the requested_expiration in the past or with no activity
// for 14 days are considered dismissed. When an approval expires, the request
// is considered dismissed.
//
// If a request is not approved or dismissed, we call it pending.
class AccessApproval final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.accessapproval.v1.AccessApproval";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists approval requests associated with a project, folder, or organization.
    // Approval requests can be filtered by state (pending, active, dismissed).
    // The order is reverse chronological.
    virtual ::grpc::Status ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>> AsyncListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>>(AsyncListApprovalRequestsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>> PrepareAsyncListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>>(PrepareAsyncListApprovalRequestsRaw(context, request, cq));
    }
    // Gets an approval request. Returns NOT_FOUND if the request does not exist.
    virtual ::grpc::Status GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncGetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncGetApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncGetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncGetApprovalRequestRaw(context, request, cq));
    }
    // Approves a request and returns the updated ApprovalRequest.
    //
    // Returns NOT_FOUND if the request does not exist. Returns
    // FAILED_PRECONDITION if the request exists but is not in a pending state.
    virtual ::grpc::Status ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncApproveApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncApproveApprovalRequestRaw(context, request, cq));
    }
    // Dismisses a request. Returns the updated ApprovalRequest.
    //
    // NOTE: This does not deny access to the resource if another request has been
    // made and approved. It is equivalent in effect to ignoring the request
    // altogether.
    //
    // Returns NOT_FOUND if the request does not exist.
    //
    // Returns FAILED_PRECONDITION if the request exists but is not in a pending
    // state.
    virtual ::grpc::Status DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncDismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncDismissApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncDismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncDismissApprovalRequestRaw(context, request, cq));
    }
    // Invalidates an existing ApprovalRequest. Returns the updated
    // ApprovalRequest.
    //
    // NOTE: This does not deny access to the resource if another request has been
    // made and approved. It only invalidates a single approval.
    //
    // Returns FAILED_PRECONDITION if the request exists but is not in an approved
    // state.
    virtual ::grpc::Status InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncInvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncInvalidateApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncInvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncInvalidateApprovalRequestRaw(context, request, cq));
    }
    // Gets the settings associated with a project, folder, or organization.
    virtual ::grpc::Status GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> AsyncGetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(AsyncGetAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> PrepareAsyncGetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(PrepareAsyncGetAccessApprovalSettingsRaw(context, request, cq));
    }
    // Updates the settings associated with a project, folder, or organization.
    // Settings to update are determined by the value of field_mask.
    virtual ::grpc::Status UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> AsyncUpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(AsyncUpdateAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> PrepareAsyncUpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(PrepareAsyncUpdateAccessApprovalSettingsRaw(context, request, cq));
    }
    // Deletes the settings associated with a project, folder, or organization.
    // This will have the effect of disabling Access Approval for the project,
    // folder, or organization, but only if all ancestors also have Access
    // Approval disabled. If Access Approval is enabled at a higher level of the
    // hierarchy, then Access Approval will still be enabled at this level as
    // the settings are inherited.
    virtual ::grpc::Status DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteAccessApprovalSettingsRaw(context, request, cq));
    }
    // Retrieves the service account that is used by Access Approval to access KMS
    // keys for signing approved approval requests.
    virtual ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>> AsyncGetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>>(AsyncGetAccessApprovalServiceAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>> PrepareAsyncGetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>>(PrepareAsyncGetAccessApprovalServiceAccountRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists approval requests associated with a project, folder, or organization.
      // Approval requests can be filtered by state (pending, active, dismissed).
      // The order is reverse chronological.
      virtual void ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an approval request. Returns NOT_FOUND if the request does not exist.
      virtual void GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Approves a request and returns the updated ApprovalRequest.
      //
      // Returns NOT_FOUND if the request does not exist. Returns
      // FAILED_PRECONDITION if the request exists but is not in a pending state.
      virtual void ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Dismisses a request. Returns the updated ApprovalRequest.
      //
      // NOTE: This does not deny access to the resource if another request has been
      // made and approved. It is equivalent in effect to ignoring the request
      // altogether.
      //
      // Returns NOT_FOUND if the request does not exist.
      //
      // Returns FAILED_PRECONDITION if the request exists but is not in a pending
      // state.
      virtual void DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Invalidates an existing ApprovalRequest. Returns the updated
      // ApprovalRequest.
      //
      // NOTE: This does not deny access to the resource if another request has been
      // made and approved. It only invalidates a single approval.
      //
      // Returns FAILED_PRECONDITION if the request exists but is not in an approved
      // state.
      virtual void InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) = 0;
      virtual void InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the settings associated with a project, folder, or organization.
      virtual void GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the settings associated with a project, folder, or organization.
      // Settings to update are determined by the value of field_mask.
      virtual void UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the settings associated with a project, folder, or organization.
      // This will have the effect of disabling Access Approval for the project,
      // folder, or organization, but only if all ancestors also have Access
      // Approval disabled. If Access Approval is enabled at a higher level of the
      // hierarchy, then Access Approval will still be enabled at this level as
      // the settings are inherited.
      virtual void DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the service account that is used by Access Approval to access KMS
      // keys for signing approved approval requests.
      virtual void GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* AsyncListApprovalRequestsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* PrepareAsyncListApprovalRequestsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncGetApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncGetApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncApproveApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncApproveApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncDismissApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncDismissApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncInvalidateApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncInvalidateApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* AsyncGetAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* PrepareAsyncGetAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* AsyncUpdateAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* PrepareAsyncUpdateAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* AsyncGetAccessApprovalServiceAccountRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* PrepareAsyncGetAccessApprovalServiceAccountRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>> AsyncListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>>(AsyncListApprovalRequestsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>> PrepareAsyncListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>>(PrepareAsyncListApprovalRequestsRaw(context, request, cq));
    }
    ::grpc::Status GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncGetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncGetApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncGetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncGetApprovalRequestRaw(context, request, cq));
    }
    ::grpc::Status ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncApproveApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncApproveApprovalRequestRaw(context, request, cq));
    }
    ::grpc::Status DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncDismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncDismissApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncDismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncDismissApprovalRequestRaw(context, request, cq));
    }
    ::grpc::Status InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> AsyncInvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(AsyncInvalidateApprovalRequestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>> PrepareAsyncInvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>>(PrepareAsyncInvalidateApprovalRequestRaw(context, request, cq));
    }
    ::grpc::Status GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> AsyncGetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(AsyncGetAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> PrepareAsyncGetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(PrepareAsyncGetAccessApprovalSettingsRaw(context, request, cq));
    }
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> AsyncUpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(AsyncUpdateAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>> PrepareAsyncUpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>>(PrepareAsyncUpdateAccessApprovalSettingsRaw(context, request, cq));
    }
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteAccessApprovalSettingsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteAccessApprovalSettingsRaw(context, request, cq));
    }
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>> AsyncGetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>>(AsyncGetAccessApprovalServiceAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>> PrepareAsyncGetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>>(PrepareAsyncGetAccessApprovalServiceAccountRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListApprovalRequests(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) override;
      void GetApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) override;
      void ApproveApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) override;
      void DismissApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) override;
      void InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, std::function<void(::grpc::Status)>) override;
      void InvalidateApprovalRequest(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, std::function<void(::grpc::Status)>) override;
      void GetAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, std::function<void(::grpc::Status)>) override;
      void UpdateAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteAccessApprovalSettings(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response, std::function<void(::grpc::Status)>) override;
      void GetAccessApprovalServiceAccount(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* AsyncListApprovalRequestsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* PrepareAsyncListApprovalRequestsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncGetApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncGetApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncApproveApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncApproveApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncDismissApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncDismissApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* AsyncInvalidateApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::ApprovalRequest>* PrepareAsyncInvalidateApprovalRequestRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* AsyncGetAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* PrepareAsyncGetAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* AsyncUpdateAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* PrepareAsyncUpdateAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteAccessApprovalSettingsRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* AsyncGetAccessApprovalServiceAccountRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* PrepareAsyncGetAccessApprovalServiceAccountRaw(::grpc::ClientContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListApprovalRequests_;
    const ::grpc::internal::RpcMethod rpcmethod_GetApprovalRequest_;
    const ::grpc::internal::RpcMethod rpcmethod_ApproveApprovalRequest_;
    const ::grpc::internal::RpcMethod rpcmethod_DismissApprovalRequest_;
    const ::grpc::internal::RpcMethod rpcmethod_InvalidateApprovalRequest_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAccessApprovalSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateAccessApprovalSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAccessApprovalSettings_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAccessApprovalServiceAccount_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists approval requests associated with a project, folder, or organization.
    // Approval requests can be filtered by state (pending, active, dismissed).
    // The order is reverse chronological.
    virtual ::grpc::Status ListApprovalRequests(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response);
    // Gets an approval request. Returns NOT_FOUND if the request does not exist.
    virtual ::grpc::Status GetApprovalRequest(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response);
    // Approves a request and returns the updated ApprovalRequest.
    //
    // Returns NOT_FOUND if the request does not exist. Returns
    // FAILED_PRECONDITION if the request exists but is not in a pending state.
    virtual ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response);
    // Dismisses a request. Returns the updated ApprovalRequest.
    //
    // NOTE: This does not deny access to the resource if another request has been
    // made and approved. It is equivalent in effect to ignoring the request
    // altogether.
    //
    // Returns NOT_FOUND if the request does not exist.
    //
    // Returns FAILED_PRECONDITION if the request exists but is not in a pending
    // state.
    virtual ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response);
    // Invalidates an existing ApprovalRequest. Returns the updated
    // ApprovalRequest.
    //
    // NOTE: This does not deny access to the resource if another request has been
    // made and approved. It only invalidates a single approval.
    //
    // Returns FAILED_PRECONDITION if the request exists but is not in an approved
    // state.
    virtual ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response);
    // Gets the settings associated with a project, folder, or organization.
    virtual ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response);
    // Updates the settings associated with a project, folder, or organization.
    // Settings to update are determined by the value of field_mask.
    virtual ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response);
    // Deletes the settings associated with a project, folder, or organization.
    // This will have the effect of disabling Access Approval for the project,
    // folder, or organization, but only if all ancestors also have Access
    // Approval disabled. If Access Approval is enabled at a higher level of the
    // hierarchy, then Access Approval will still be enabled at this level as
    // the settings are inherited.
    virtual ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response);
    // Retrieves the service account that is used by Access Approval to access KMS
    // keys for signing approved approval requests.
    virtual ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListApprovalRequests(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetApprovalRequest(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::ApprovalRequest>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveApprovalRequest(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::ApprovalRequest>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDismissApprovalRequest(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::ApprovalRequest>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInvalidateApprovalRequest(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::ApprovalRequest>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAccessApprovalSettings(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAccessApprovalSettings(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::AccessApprovalSettings>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAccessApprovalSettings(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAccessApprovalServiceAccount(::grpc::ServerContext* context, ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListApprovalRequests<WithAsyncMethod_GetApprovalRequest<WithAsyncMethod_ApproveApprovalRequest<WithAsyncMethod_DismissApprovalRequest<WithAsyncMethod_InvalidateApprovalRequest<WithAsyncMethod_GetAccessApprovalSettings<WithAsyncMethod_UpdateAccessApprovalSettings<WithAsyncMethod_DeleteAccessApprovalSettings<WithAsyncMethod_GetAccessApprovalServiceAccount<Service > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* request, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* response) { return this->ListApprovalRequests(context, request, response); }));}
    void SetMessageAllocatorFor_ListApprovalRequests(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListApprovalRequests(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) { return this->GetApprovalRequest(context, request, response); }));}
    void SetMessageAllocatorFor_GetApprovalRequest(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::GetApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) { return this->ApproveApprovalRequest(context, request, response); }));}
    void SetMessageAllocatorFor_ApproveApprovalRequest(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) { return this->DismissApprovalRequest(context, request, response); }));}
    void SetMessageAllocatorFor_DismissApprovalRequest(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DismissApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* request, ::google::cloud::accessapproval::v1::ApprovalRequest* response) { return this->InvalidateApprovalRequest(context, request, response); }));}
    void SetMessageAllocatorFor_InvalidateApprovalRequest(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InvalidateApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) { return this->GetAccessApprovalSettings(context, request, response); }));}
    void SetMessageAllocatorFor_GetAccessApprovalSettings(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalSettings* response) { return this->UpdateAccessApprovalSettings(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateAccessApprovalSettings(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* request, ::google::protobuf::Empty* response) { return this->DeleteAccessApprovalSettings(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAccessApprovalSettings(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* request, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* response) { return this->GetAccessApprovalServiceAccount(context, request, response); }));}
    void SetMessageAllocatorFor_GetAccessApprovalServiceAccount(
        ::grpc::MessageAllocator< ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAccessApprovalServiceAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListApprovalRequests<WithCallbackMethod_GetApprovalRequest<WithCallbackMethod_ApproveApprovalRequest<WithCallbackMethod_DismissApprovalRequest<WithCallbackMethod_InvalidateApprovalRequest<WithCallbackMethod_GetAccessApprovalSettings<WithCallbackMethod_UpdateAccessApprovalSettings<WithCallbackMethod_DeleteAccessApprovalSettings<WithCallbackMethod_GetAccessApprovalServiceAccount<Service > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListApprovalRequests(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetApprovalRequest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestApproveApprovalRequest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDismissApprovalRequest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestInvalidateApprovalRequest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAccessApprovalServiceAccount(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListApprovalRequests(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListApprovalRequests(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetApprovalRequest(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ApproveApprovalRequest(context, request, response); }));
    }
    ~WithRawCallbackMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ApproveApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DismissApprovalRequest(context, request, response); }));
    }
    ~WithRawCallbackMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DismissApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->InvalidateApprovalRequest(context, request, response); }));
    }
    ~WithRawCallbackMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* InvalidateApprovalRequest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAccessApprovalSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateAccessApprovalSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAccessApprovalSettings(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAccessApprovalSettings(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAccessApprovalServiceAccount(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAccessApprovalServiceAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListApprovalRequests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListApprovalRequests() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* streamer) {
                       return this->StreamedListApprovalRequests(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListApprovalRequests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListApprovalRequests(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage* /*request*/, ::google::cloud::accessapproval::v1::ListApprovalRequestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListApprovalRequests(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::ListApprovalRequestsMessage,::google::cloud::accessapproval::v1::ListApprovalRequestsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetApprovalRequest() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::GetApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::GetApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* streamer) {
                       return this->StreamedGetApprovalRequest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetApprovalRequest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::GetApprovalRequestMessage,::google::cloud::accessapproval::v1::ApprovalRequest>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ApproveApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ApproveApprovalRequest() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* streamer) {
                       return this->StreamedApproveApprovalRequest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ApproveApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ApproveApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedApproveApprovalRequest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::ApproveApprovalRequestMessage,::google::cloud::accessapproval::v1::ApprovalRequest>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DismissApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DismissApprovalRequest() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* streamer) {
                       return this->StreamedDismissApprovalRequest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DismissApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DismissApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDismissApprovalRequest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::DismissApprovalRequestMessage,::google::cloud::accessapproval::v1::ApprovalRequest>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_InvalidateApprovalRequest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_InvalidateApprovalRequest() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage, ::google::cloud::accessapproval::v1::ApprovalRequest>* streamer) {
                       return this->StreamedInvalidateApprovalRequest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_InvalidateApprovalRequest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status InvalidateApprovalRequest(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage* /*request*/, ::google::cloud::accessapproval::v1::ApprovalRequest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedInvalidateApprovalRequest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::InvalidateApprovalRequestMessage,::google::cloud::accessapproval::v1::ApprovalRequest>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAccessApprovalSettings() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>* streamer) {
                       return this->StreamedGetAccessApprovalSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::GetAccessApprovalSettingsMessage,::google::cloud::accessapproval::v1::AccessApprovalSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateAccessApprovalSettings() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage, ::google::cloud::accessapproval::v1::AccessApprovalSettings>* streamer) {
                       return this->StreamedUpdateAccessApprovalSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalSettings* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::UpdateAccessApprovalSettingsMessage,::google::cloud::accessapproval::v1::AccessApprovalSettings>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAccessApprovalSettings : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAccessApprovalSettings() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteAccessApprovalSettings(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAccessApprovalSettings() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAccessApprovalSettings(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAccessApprovalSettings(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::DeleteAccessApprovalSettingsMessage,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAccessApprovalServiceAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAccessApprovalServiceAccount() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* streamer) {
                       return this->StreamedGetAccessApprovalServiceAccount(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAccessApprovalServiceAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAccessApprovalServiceAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage* /*request*/, ::google::cloud::accessapproval::v1::AccessApprovalServiceAccount* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAccessApprovalServiceAccount(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::accessapproval::v1::GetAccessApprovalServiceAccountMessage,::google::cloud::accessapproval::v1::AccessApprovalServiceAccount>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListApprovalRequests<WithStreamedUnaryMethod_GetApprovalRequest<WithStreamedUnaryMethod_ApproveApprovalRequest<WithStreamedUnaryMethod_DismissApprovalRequest<WithStreamedUnaryMethod_InvalidateApprovalRequest<WithStreamedUnaryMethod_GetAccessApprovalSettings<WithStreamedUnaryMethod_UpdateAccessApprovalSettings<WithStreamedUnaryMethod_DeleteAccessApprovalSettings<WithStreamedUnaryMethod_GetAccessApprovalServiceAccount<Service > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListApprovalRequests<WithStreamedUnaryMethod_GetApprovalRequest<WithStreamedUnaryMethod_ApproveApprovalRequest<WithStreamedUnaryMethod_DismissApprovalRequest<WithStreamedUnaryMethod_InvalidateApprovalRequest<WithStreamedUnaryMethod_GetAccessApprovalSettings<WithStreamedUnaryMethod_UpdateAccessApprovalSettings<WithStreamedUnaryMethod_DeleteAccessApprovalSettings<WithStreamedUnaryMethod_GetAccessApprovalServiceAccount<Service > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace accessapproval
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2faccessapproval_2fv1_2faccessapproval_2eproto__INCLUDED
