// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/prediction_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fprediction_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fprediction_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/prediction_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// A service for online predictions and explanations.
class PredictionService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.PredictionService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Perform an online prediction.
    virtual ::grpc::Status Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::google::cloud::aiplatform::v1::PredictResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>> AsyncPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>>(AsyncPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>> PrepareAsyncPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>>(PrepareAsyncPredictRaw(context, request, cq));
    }
    // Perform an online prediction with an arbitrary HTTP payload.
    //
    // The response includes the following HTTP headers:
    //
    // * `X-Vertex-AI-Endpoint-Id`: ID of the
    // [Endpoint][google.cloud.aiplatform.v1.Endpoint] that served this
    // prediction.
    //
    // * `X-Vertex-AI-Deployed-Model-Id`: ID of the Endpoint's
    // [DeployedModel][google.cloud.aiplatform.v1.DeployedModel] that served this
    // prediction.
    virtual ::grpc::Status RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::google::api::HttpBody* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>> AsyncRawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>>(AsyncRawPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>> PrepareAsyncRawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>>(PrepareAsyncRawPredictRaw(context, request, cq));
    }
    // Perform a server-side streaming online prediction request for Vertex
    // LLM streaming.
    std::unique_ptr< ::grpc::ClientReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> ServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request) {
      return std::unique_ptr< ::grpc::ClientReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(ServerStreamingPredictRaw(context, request));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> AsyncServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(AsyncServerStreamingPredictRaw(context, request, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> PrepareAsyncServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(PrepareAsyncServerStreamingPredictRaw(context, request, cq));
    }
    // Perform an online explanation.
    //
    // If
    // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
    // is specified, the corresponding DeployModel must have
    // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
    // populated. If
    // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
    // is not specified, all DeployedModels must have
    // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
    // populated.
    virtual ::grpc::Status Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::google::cloud::aiplatform::v1::ExplainResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>> AsyncExplain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>>(AsyncExplainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>> PrepareAsyncExplain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>>(PrepareAsyncExplainRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Perform an online prediction.
      virtual void Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Perform an online prediction with an arbitrary HTTP payload.
      //
      // The response includes the following HTTP headers:
      //
      // * `X-Vertex-AI-Endpoint-Id`: ID of the
      // [Endpoint][google.cloud.aiplatform.v1.Endpoint] that served this
      // prediction.
      //
      // * `X-Vertex-AI-Deployed-Model-Id`: ID of the Endpoint's
      // [DeployedModel][google.cloud.aiplatform.v1.DeployedModel] that served this
      // prediction.
      virtual void RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Perform a server-side streaming online prediction request for Vertex
      // LLM streaming.
      virtual void ServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* request, ::grpc::ClientReadReactor< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* reactor) = 0;
      // Perform an online explanation.
      //
      // If
      // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
      // is specified, the corresponding DeployModel must have
      // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
      // populated. If
      // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
      // is not specified, all DeployedModels must have
      // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
      // populated.
      virtual void Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>* AsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::PredictResponse>* PrepareAsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>* AsyncRawPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>* PrepareAsyncRawPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* ServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request) = 0;
    virtual ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* AsyncServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq, void* tag) = 0;
    virtual ::grpc::ClientAsyncReaderInterface< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* PrepareAsyncServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>* AsyncExplainRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ExplainResponse>* PrepareAsyncExplainRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::google::cloud::aiplatform::v1::PredictResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>> AsyncPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>>(AsyncPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>> PrepareAsyncPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>>(PrepareAsyncPredictRaw(context, request, cq));
    }
    ::grpc::Status RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::google::api::HttpBody* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>> AsyncRawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>>(AsyncRawPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>> PrepareAsyncRawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>>(PrepareAsyncRawPredictRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> ServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request) {
      return std::unique_ptr< ::grpc::ClientReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(ServerStreamingPredictRaw(context, request));
    }
    std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> AsyncServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq, void* tag) {
      return std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(AsyncServerStreamingPredictRaw(context, request, cq, tag));
    }
    std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>> PrepareAsyncServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>>(PrepareAsyncServerStreamingPredictRaw(context, request, cq));
    }
    ::grpc::Status Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::google::cloud::aiplatform::v1::ExplainResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>> AsyncExplain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>>(AsyncExplainRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>> PrepareAsyncExplain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>>(PrepareAsyncExplainRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response, std::function<void(::grpc::Status)>) override;
      void Predict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response, std::function<void(::grpc::Status)>) override;
      void RawPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ServerStreamingPredict(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* request, ::grpc::ClientReadReactor< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* reactor) override;
      void Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response, std::function<void(::grpc::Status)>) override;
      void Explain(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>* AsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::PredictResponse>* PrepareAsyncPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::PredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>* AsyncRawPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>* PrepareAsyncRawPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* ServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request) override;
    ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* AsyncServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq, void* tag) override;
    ::grpc::ClientAsyncReader< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* PrepareAsyncServerStreamingPredictRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>* AsyncExplainRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ExplainResponse>* PrepareAsyncExplainRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_Predict_;
    const ::grpc::internal::RpcMethod rpcmethod_RawPredict_;
    const ::grpc::internal::RpcMethod rpcmethod_ServerStreamingPredict_;
    const ::grpc::internal::RpcMethod rpcmethod_Explain_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Perform an online prediction.
    virtual ::grpc::Status Predict(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response);
    // Perform an online prediction with an arbitrary HTTP payload.
    //
    // The response includes the following HTTP headers:
    //
    // * `X-Vertex-AI-Endpoint-Id`: ID of the
    // [Endpoint][google.cloud.aiplatform.v1.Endpoint] that served this
    // prediction.
    //
    // * `X-Vertex-AI-Deployed-Model-Id`: ID of the Endpoint's
    // [DeployedModel][google.cloud.aiplatform.v1.DeployedModel] that served this
    // prediction.
    virtual ::grpc::Status RawPredict(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response);
    // Perform a server-side streaming online prediction request for Vertex
    // LLM streaming.
    virtual ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* request, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* writer);
    // Perform an online explanation.
    //
    // If
    // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
    // is specified, the corresponding DeployModel must have
    // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
    // populated. If
    // [deployed_model_id][google.cloud.aiplatform.v1.ExplainRequest.deployed_model_id]
    // is not specified, all DeployedModels must have
    // [explanation_spec][google.cloud.aiplatform.v1.DeployedModel.explanation_spec]
    // populated.
    virtual ::grpc::Status Explain(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Predict() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPredict(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::PredictRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::PredictResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RawPredict() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawPredict(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::HttpBody>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestServerStreamingPredict(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::StreamingPredictRequest* request, ::grpc::ServerAsyncWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* writer, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncServerStreaming(2, context, request, writer, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_Explain() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExplain(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ExplainRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ExplainResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_Predict<WithAsyncMethod_RawPredict<WithAsyncMethod_ServerStreamingPredict<WithAsyncMethod_Explain<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Predict() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::PredictRequest, ::google::cloud::aiplatform::v1::PredictResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::PredictRequest* request, ::google::cloud::aiplatform::v1::PredictResponse* response) { return this->Predict(context, request, response); }));}
    void SetMessageAllocatorFor_Predict(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::PredictRequest, ::google::cloud::aiplatform::v1::PredictResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::PredictRequest, ::google::cloud::aiplatform::v1::PredictResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Predict(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RawPredict() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::RawPredictRequest, ::google::api::HttpBody>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::RawPredictRequest* request, ::google::api::HttpBody* response) { return this->RawPredict(context, request, response); }));}
    void SetMessageAllocatorFor_RawPredict(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::RawPredictRequest, ::google::api::HttpBody>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::RawPredictRequest, ::google::api::HttpBody>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackServerStreamingHandler< ::google::cloud::aiplatform::v1::StreamingPredictRequest, ::google::cloud::aiplatform::v1::StreamingPredictResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* request) { return this->ServerStreamingPredict(context, request); }));
    }
    ~WithCallbackMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerWriteReactor< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* ServerStreamingPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_Explain() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ExplainRequest, ::google::cloud::aiplatform::v1::ExplainResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ExplainRequest* request, ::google::cloud::aiplatform::v1::ExplainResponse* response) { return this->Explain(context, request, response); }));}
    void SetMessageAllocatorFor_Explain(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ExplainRequest, ::google::cloud::aiplatform::v1::ExplainResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ExplainRequest, ::google::cloud::aiplatform::v1::ExplainResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Explain(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_Predict<WithCallbackMethod_RawPredict<WithCallbackMethod_ServerStreamingPredict<WithCallbackMethod_Explain<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Predict() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RawPredict() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_Explain() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Predict() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPredict(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RawPredict() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRawPredict(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestServerStreamingPredict(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncWriter< ::grpc::ByteBuffer>* writer, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncServerStreaming(2, context, request, writer, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_Explain() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExplain(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Predict() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Predict(context, request, response); }));
    }
    ~WithRawCallbackMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Predict(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RawPredict() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RawPredict(context, request, response); }));
    }
    ~WithRawCallbackMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RawPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackServerStreamingHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const::grpc::ByteBuffer* request) { return this->ServerStreamingPredict(context, request); }));
    }
    ~WithRawCallbackMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerWriteReactor< ::grpc::ByteBuffer>* ServerStreamingPredict(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_Explain() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->Explain(context, request, response); }));
    }
    ~WithRawCallbackMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* Explain(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Predict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Predict() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::PredictRequest, ::google::cloud::aiplatform::v1::PredictResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::PredictRequest, ::google::cloud::aiplatform::v1::PredictResponse>* streamer) {
                       return this->StreamedPredict(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Predict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Predict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::PredictRequest* /*request*/, ::google::cloud::aiplatform::v1::PredictResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPredict(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::PredictRequest,::google::cloud::aiplatform::v1::PredictResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RawPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RawPredict() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::RawPredictRequest, ::google::api::HttpBody>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::RawPredictRequest, ::google::api::HttpBody>* streamer) {
                       return this->StreamedRawPredict(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RawPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RawPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::RawPredictRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRawPredict(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::RawPredictRequest,::google::api::HttpBody>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_Explain : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_Explain() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ExplainRequest, ::google::cloud::aiplatform::v1::ExplainResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ExplainRequest, ::google::cloud::aiplatform::v1::ExplainResponse>* streamer) {
                       return this->StreamedExplain(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_Explain() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status Explain(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ExplainRequest* /*request*/, ::google::cloud::aiplatform::v1::ExplainResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExplain(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ExplainRequest,::google::cloud::aiplatform::v1::ExplainResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_Predict<WithStreamedUnaryMethod_RawPredict<WithStreamedUnaryMethod_Explain<Service > > > StreamedUnaryService;
  template <class BaseClass>
  class WithSplitStreamingMethod_ServerStreamingPredict : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithSplitStreamingMethod_ServerStreamingPredict() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::SplitServerStreamingHandler<
          ::google::cloud::aiplatform::v1::StreamingPredictRequest, ::google::cloud::aiplatform::v1::StreamingPredictResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerSplitStreamer<
                     ::google::cloud::aiplatform::v1::StreamingPredictRequest, ::google::cloud::aiplatform::v1::StreamingPredictResponse>* streamer) {
                       return this->StreamedServerStreamingPredict(context,
                         streamer);
                  }));
    }
    ~WithSplitStreamingMethod_ServerStreamingPredict() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ServerStreamingPredict(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StreamingPredictRequest* /*request*/, ::grpc::ServerWriter< ::google::cloud::aiplatform::v1::StreamingPredictResponse>* /*writer*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with split streamed
    virtual ::grpc::Status StreamedServerStreamingPredict(::grpc::ServerContext* context, ::grpc::ServerSplitStreamer< ::google::cloud::aiplatform::v1::StreamingPredictRequest,::google::cloud::aiplatform::v1::StreamingPredictResponse>* server_split_streamer) = 0;
  };
  typedef WithSplitStreamingMethod_ServerStreamingPredict<Service > SplitStreamedService;
  typedef WithStreamedUnaryMethod_Predict<WithStreamedUnaryMethod_RawPredict<WithSplitStreamingMethod_ServerStreamingPredict<WithStreamedUnaryMethod_Explain<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fprediction_5fservice_2eproto__INCLUDED
