// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/datacatalog/v1/policytagmanagerserialization.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanagerserialization_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanagerserialization_2eproto__INCLUDED

#include "google/cloud/datacatalog/v1/policytagmanagerserialization.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace datacatalog {
namespace v1 {

// Policy Tag Manager Serialization API service allows you to manipulate
// your policy tags and taxonomies in a serialized format.
//
// Taxonomy is a hierarchical group of policy tags.
class PolicyTagManagerSerialization final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.datacatalog.v1.PolicyTagManagerSerialization";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Replaces (updates) a taxonomy and all its policy tags.
    //
    // The taxonomy and its entire hierarchy of policy tags must be
    // represented literally by `SerializedTaxonomy` and the nested
    // `SerializedPolicyTag` messages.
    //
    // This operation automatically does the following:
    //
    // - Deletes the existing policy tags that are missing from the
    //   `SerializedPolicyTag`.
    // - Creates policy tags that don't have resource names. They are considered
    //   new.
    // - Updates policy tags with valid resources names accordingly.
    virtual ::grpc::Status ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncReplaceTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncReplaceTaxonomyRaw(context, request, cq));
    }
    // Creates new taxonomies (including their policy tags) in a given project
    // by importing from inlined or cross-regional sources.
    //
    // For a cross-regional source, new taxonomies are created by copying
    // from a source in another region.
    //
    // For an inlined source, taxonomies and policy tags are created in bulk using
    // nested protocol buffer structures.
    virtual ::grpc::Status ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>> AsyncImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>>(AsyncImportTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>> PrepareAsyncImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>>(PrepareAsyncImportTaxonomiesRaw(context, request, cq));
    }
    // Exports taxonomies in the requested type and returns them,
    // including their policy tags. The requested taxonomies must belong to the
    // same project.
    //
    // This method generates `SerializedTaxonomy` protocol buffers with nested
    // policy tags that can be used as input for `ImportTaxonomies` calls.
    virtual ::grpc::Status ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>> AsyncExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>>(AsyncExportTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>> PrepareAsyncExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>>(PrepareAsyncExportTaxonomiesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Replaces (updates) a taxonomy and all its policy tags.
      //
      // The taxonomy and its entire hierarchy of policy tags must be
      // represented literally by `SerializedTaxonomy` and the nested
      // `SerializedPolicyTag` messages.
      //
      // This operation automatically does the following:
      //
      // - Deletes the existing policy tags that are missing from the
      //   `SerializedPolicyTag`.
      // - Creates policy tags that don't have resource names. They are considered
      //   new.
      // - Updates policy tags with valid resources names accordingly.
      virtual void ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates new taxonomies (including their policy tags) in a given project
      // by importing from inlined or cross-regional sources.
      //
      // For a cross-regional source, new taxonomies are created by copying
      // from a source in another region.
      //
      // For an inlined source, taxonomies and policy tags are created in bulk using
      // nested protocol buffer structures.
      virtual void ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Exports taxonomies in the requested type and returns them,
      // including their policy tags. The requested taxonomies must belong to the
      // same project.
      //
      // This method generates `SerializedTaxonomy` protocol buffers with nested
      // policy tags that can be used as input for `ImportTaxonomies` calls.
      virtual void ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncReplaceTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncReplaceTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* AsyncImportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* PrepareAsyncImportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* AsyncExportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* PrepareAsyncExportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::google::cloud::datacatalog::v1::Taxonomy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> AsyncReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(AsyncReplaceTaxonomyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>> PrepareAsyncReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>>(PrepareAsyncReplaceTaxonomyRaw(context, request, cq));
    }
    ::grpc::Status ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>> AsyncImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>>(AsyncImportTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>> PrepareAsyncImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>>(PrepareAsyncImportTaxonomiesRaw(context, request, cq));
    }
    ::grpc::Status ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>> AsyncExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>>(AsyncExportTaxonomiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>> PrepareAsyncExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>>(PrepareAsyncExportTaxonomiesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, std::function<void(::grpc::Status)>) override;
      void ReplaceTaxonomy(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response, std::function<void(::grpc::Status)>) override;
      void ImportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response, std::function<void(::grpc::Status)>) override;
      void ExportTaxonomies(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* AsyncReplaceTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Taxonomy>* PrepareAsyncReplaceTaxonomyRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* AsyncImportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* PrepareAsyncImportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* AsyncExportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* PrepareAsyncExportTaxonomiesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ReplaceTaxonomy_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportTaxonomies_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportTaxonomies_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Replaces (updates) a taxonomy and all its policy tags.
    //
    // The taxonomy and its entire hierarchy of policy tags must be
    // represented literally by `SerializedTaxonomy` and the nested
    // `SerializedPolicyTag` messages.
    //
    // This operation automatically does the following:
    //
    // - Deletes the existing policy tags that are missing from the
    //   `SerializedPolicyTag`.
    // - Creates policy tags that don't have resource names. They are considered
    //   new.
    // - Updates policy tags with valid resources names accordingly.
    virtual ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response);
    // Creates new taxonomies (including their policy tags) in a given project
    // by importing from inlined or cross-regional sources.
    //
    // For a cross-regional source, new taxonomies are created by copying
    // from a source in another region.
    //
    // For an inlined source, taxonomies and policy tags are created in bulk using
    // nested protocol buffer structures.
    virtual ::grpc::Status ImportTaxonomies(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response);
    // Exports taxonomies in the requested type and returns them,
    // including their policy tags. The requested taxonomies must belong to the
    // same project.
    //
    // This method generates `SerializedTaxonomy` protocol buffers with nested
    // policy tags that can be used as input for `ImportTaxonomies` calls.
    virtual ::grpc::Status ExportTaxonomies(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReplaceTaxonomy(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Taxonomy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportTaxonomies(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportTaxonomies(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ReplaceTaxonomy<WithAsyncMethod_ImportTaxonomies<WithAsyncMethod_ExportTaxonomies<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* request, ::google::cloud::datacatalog::v1::Taxonomy* response) { return this->ReplaceTaxonomy(context, request, response); }));}
    void SetMessageAllocatorFor_ReplaceTaxonomy(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReplaceTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* response) { return this->ImportTaxonomies(context, request, response); }));}
    void SetMessageAllocatorFor_ImportTaxonomies(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* request, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* response) { return this->ExportTaxonomies(context, request, response); }));}
    void SetMessageAllocatorFor_ExportTaxonomies(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ReplaceTaxonomy<WithCallbackMethod_ImportTaxonomies<WithCallbackMethod_ExportTaxonomies<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReplaceTaxonomy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportTaxonomies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportTaxonomies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReplaceTaxonomy(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReplaceTaxonomy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportTaxonomies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ExportTaxonomies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ExportTaxonomies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReplaceTaxonomy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReplaceTaxonomy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest, ::google::cloud::datacatalog::v1::Taxonomy>* streamer) {
                       return this->StreamedReplaceTaxonomy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReplaceTaxonomy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReplaceTaxonomy(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest* /*request*/, ::google::cloud::datacatalog::v1::Taxonomy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReplaceTaxonomy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ReplaceTaxonomyRequest,::google::cloud::datacatalog::v1::Taxonomy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportTaxonomies() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* streamer) {
                       return this->StreamedImportTaxonomies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ImportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportTaxonomies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ImportTaxonomiesRequest,::google::cloud::datacatalog::v1::ImportTaxonomiesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportTaxonomies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ExportTaxonomies() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* streamer) {
                       return this->StreamedExportTaxonomies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ExportTaxonomies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportTaxonomies(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest* /*request*/, ::google::cloud::datacatalog::v1::ExportTaxonomiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportTaxonomies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ExportTaxonomiesRequest,::google::cloud::datacatalog::v1::ExportTaxonomiesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ReplaceTaxonomy<WithStreamedUnaryMethod_ImportTaxonomies<WithStreamedUnaryMethod_ExportTaxonomies<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ReplaceTaxonomy<WithStreamedUnaryMethod_ImportTaxonomies<WithStreamedUnaryMethod_ExportTaxonomies<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace datacatalog
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdatacatalog_2fv1_2fpolicytagmanagerserialization_2eproto__INCLUDED
