// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/dialogflow/v2/agent.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_AGENTS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_AGENTS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/dialogflow/v2/agent.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace dialogflow_es {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class AgentsConnectionIdempotencyPolicy {
 public:
  virtual ~AgentsConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<AgentsConnectionIdempotencyPolicy> clone() const;

  virtual google::cloud::Idempotency GetAgent(
      google::cloud::dialogflow::v2::GetAgentRequest const& request);

  virtual google::cloud::Idempotency SetAgent(
      google::cloud::dialogflow::v2::SetAgentRequest const& request);

  virtual google::cloud::Idempotency DeleteAgent(
      google::cloud::dialogflow::v2::DeleteAgentRequest const& request);

  virtual google::cloud::Idempotency SearchAgents(
      google::cloud::dialogflow::v2::SearchAgentsRequest request);

  virtual google::cloud::Idempotency TrainAgent(
      google::cloud::dialogflow::v2::TrainAgentRequest const& request);

  virtual google::cloud::Idempotency ExportAgent(
      google::cloud::dialogflow::v2::ExportAgentRequest const& request);

  virtual google::cloud::Idempotency ImportAgent(
      google::cloud::dialogflow::v2::ImportAgentRequest const& request);

  virtual google::cloud::Idempotency RestoreAgent(
      google::cloud::dialogflow::v2::RestoreAgentRequest const& request);

  virtual google::cloud::Idempotency GetValidationResult(
      google::cloud::dialogflow::v2::GetValidationResultRequest const& request);
};

std::unique_ptr<AgentsConnectionIdempotencyPolicy>
MakeDefaultAgentsConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace dialogflow_es
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DIALOGFLOW_ES_AGENTS_CONNECTION_IDEMPOTENCY_POLICY_H
