// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/gkehub/v1/service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fgkehub_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fgkehub_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/gkehub/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace gkehub {
namespace v1 {

// The GKE Hub service handles the registration of many Kubernetes clusters to
// Google Cloud, and the management of multi-cluster features over those
// clusters.
//
// The GKE Hub service operates on the following resources:
//
// * [Membership][google.cloud.gkehub.v1.Membership]
// * [Feature][google.cloud.gkehub.v1.Feature]
//
// GKE Hub is currently available in the global region and all regions in
// https://cloud.google.com/compute/docs/regions-zones. Feature is only
// available in global region while membership is global region and all the
// regions.
//
// **Membership management may be non-trivial:** it is recommended to use one
// of the Google-provided client libraries or tools where possible when working
// with Membership resources.
class GkeHub final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.gkehub.v1.GkeHub";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists Memberships in a given project and location.
    virtual ::grpc::Status ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>> AsyncListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>>(AsyncListMembershipsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>> PrepareAsyncListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>>(PrepareAsyncListMembershipsRaw(context, request, cq));
    }
    // Lists Features in a given project and location.
    virtual ::grpc::Status ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>> AsyncListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>>(AsyncListFeaturesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>> PrepareAsyncListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>>(PrepareAsyncListFeaturesRaw(context, request, cq));
    }
    // Gets the details of a Membership.
    virtual ::grpc::Status GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::google::cloud::gkehub::v1::Membership* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>> AsyncGetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>>(AsyncGetMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>> PrepareAsyncGetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>>(PrepareAsyncGetMembershipRaw(context, request, cq));
    }
    // Gets details of a single Feature.
    virtual ::grpc::Status GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::google::cloud::gkehub::v1::Feature* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>> AsyncGetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>>(AsyncGetFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>> PrepareAsyncGetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>>(PrepareAsyncGetFeatureRaw(context, request, cq));
    }
    // Creates a new Membership.
    //
    // **This is currently only supported for GKE clusters on Google Cloud**.
    // To register other clusters, follow the instructions at
    // https://cloud.google.com/anthos/multicluster-management/connect/registering-a-cluster.
    virtual ::grpc::Status CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateMembershipRaw(context, request, cq));
    }
    // Adds a new Feature.
    virtual ::grpc::Status CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateFeatureRaw(context, request, cq));
    }
    // Removes a Membership.
    //
    // **This is currently only supported for GKE clusters on Google Cloud**.
    // To unregister other clusters, follow the instructions at
    // https://cloud.google.com/anthos/multicluster-management/connect/unregistering-a-cluster.
    virtual ::grpc::Status DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteMembershipRaw(context, request, cq));
    }
    // Removes a Feature.
    virtual ::grpc::Status DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteFeatureRaw(context, request, cq));
    }
    // Updates an existing Membership.
    virtual ::grpc::Status UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateMembershipRaw(context, request, cq));
    }
    // Updates an existing Feature.
    virtual ::grpc::Status UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateFeatureRaw(context, request, cq));
    }
    // Generates the manifest for deployment of the GKE connect agent.
    //
    // **This method is used internally by Google-provided libraries.**
    // Most clients should not need to call this method directly.
    virtual ::grpc::Status GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>> AsyncGenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>>(AsyncGenerateConnectManifestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>> PrepareAsyncGenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>>(PrepareAsyncGenerateConnectManifestRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists Memberships in a given project and location.
      virtual void ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists Features in a given project and location.
      virtual void ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a Membership.
      virtual void GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single Feature.
      virtual void GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Membership.
      //
      // **This is currently only supported for GKE clusters on Google Cloud**.
      // To register other clusters, follow the instructions at
      // https://cloud.google.com/anthos/multicluster-management/connect/registering-a-cluster.
      virtual void CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds a new Feature.
      virtual void CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes a Membership.
      //
      // **This is currently only supported for GKE clusters on Google Cloud**.
      // To unregister other clusters, follow the instructions at
      // https://cloud.google.com/anthos/multicluster-management/connect/unregistering-a-cluster.
      virtual void DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes a Feature.
      virtual void DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing Membership.
      virtual void UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing Feature.
      virtual void UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Generates the manifest for deployment of the GKE connect agent.
      //
      // **This method is used internally by Google-provided libraries.**
      // Most clients should not need to call this method directly.
      virtual void GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>* AsyncListMembershipsRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListMembershipsResponse>* PrepareAsyncListMembershipsRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>* AsyncListFeaturesRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::ListFeaturesResponse>* PrepareAsyncListFeaturesRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>* AsyncGetMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Membership>* PrepareAsyncGetMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>* AsyncGetFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::Feature>* PrepareAsyncGetFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* AsyncGenerateConnectManifestRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* PrepareAsyncGenerateConnectManifestRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>> AsyncListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>>(AsyncListMembershipsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>> PrepareAsyncListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>>(PrepareAsyncListMembershipsRaw(context, request, cq));
    }
    ::grpc::Status ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>> AsyncListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>>(AsyncListFeaturesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>> PrepareAsyncListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>>(PrepareAsyncListFeaturesRaw(context, request, cq));
    }
    ::grpc::Status GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::google::cloud::gkehub::v1::Membership* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>> AsyncGetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>>(AsyncGetMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>> PrepareAsyncGetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>>(PrepareAsyncGetMembershipRaw(context, request, cq));
    }
    ::grpc::Status GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::google::cloud::gkehub::v1::Feature* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>> AsyncGetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>>(AsyncGetFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>> PrepareAsyncGetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>>(PrepareAsyncGetFeatureRaw(context, request, cq));
    }
    ::grpc::Status CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateMembershipRaw(context, request, cq));
    }
    ::grpc::Status CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateFeatureRaw(context, request, cq));
    }
    ::grpc::Status DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteMembershipRaw(context, request, cq));
    }
    ::grpc::Status DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteFeatureRaw(context, request, cq));
    }
    ::grpc::Status UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateMembershipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateMembershipRaw(context, request, cq));
    }
    ::grpc::Status UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateFeatureRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateFeatureRaw(context, request, cq));
    }
    ::grpc::Status GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>> AsyncGenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>>(AsyncGenerateConnectManifestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>> PrepareAsyncGenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>>(PrepareAsyncGenerateConnectManifestRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListMemberships(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListFeatures(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response, std::function<void(::grpc::Status)>) override;
      void GetMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response, std::function<void(::grpc::Status)>) override;
      void GetFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateMembership(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateFeature(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response, std::function<void(::grpc::Status)>) override;
      void GenerateConnectManifest(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>* AsyncListMembershipsRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListMembershipsResponse>* PrepareAsyncListMembershipsRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>* AsyncListFeaturesRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::ListFeaturesResponse>* PrepareAsyncListFeaturesRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>* AsyncGetMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Membership>* PrepareAsyncGetMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>* AsyncGetFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::Feature>* PrepareAsyncGetFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateMembershipRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateFeatureRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* AsyncGenerateConnectManifestRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* PrepareAsyncGenerateConnectManifestRaw(::grpc::ClientContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListMemberships_;
    const ::grpc::internal::RpcMethod rpcmethod_ListFeatures_;
    const ::grpc::internal::RpcMethod rpcmethod_GetMembership_;
    const ::grpc::internal::RpcMethod rpcmethod_GetFeature_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateMembership_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateFeature_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteMembership_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteFeature_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateMembership_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateFeature_;
    const ::grpc::internal::RpcMethod rpcmethod_GenerateConnectManifest_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists Memberships in a given project and location.
    virtual ::grpc::Status ListMemberships(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response);
    // Lists Features in a given project and location.
    virtual ::grpc::Status ListFeatures(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response);
    // Gets the details of a Membership.
    virtual ::grpc::Status GetMembership(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response);
    // Gets details of a single Feature.
    virtual ::grpc::Status GetFeature(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response);
    // Creates a new Membership.
    //
    // **This is currently only supported for GKE clusters on Google Cloud**.
    // To register other clusters, follow the instructions at
    // https://cloud.google.com/anthos/multicluster-management/connect/registering-a-cluster.
    virtual ::grpc::Status CreateMembership(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response);
    // Adds a new Feature.
    virtual ::grpc::Status CreateFeature(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response);
    // Removes a Membership.
    //
    // **This is currently only supported for GKE clusters on Google Cloud**.
    // To unregister other clusters, follow the instructions at
    // https://cloud.google.com/anthos/multicluster-management/connect/unregistering-a-cluster.
    virtual ::grpc::Status DeleteMembership(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response);
    // Removes a Feature.
    virtual ::grpc::Status DeleteFeature(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response);
    // Updates an existing Membership.
    virtual ::grpc::Status UpdateMembership(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response);
    // Updates an existing Feature.
    virtual ::grpc::Status UpdateFeature(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response);
    // Generates the manifest for deployment of the GKE connect agent.
    //
    // **This method is used internally by Google-provided libraries.**
    // Most clients should not need to call this method directly.
    virtual ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListMemberships() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMemberships(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkehub::v1::ListMembershipsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListFeatures() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFeatures(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkehub::v1::ListFeaturesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetMembership() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMembership(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkehub::v1::Membership>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetFeature() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFeature(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkehub::v1::Feature>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateMembership() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMembership(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateFeature() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFeature(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteMembership(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFeature(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateMembership(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFeature(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateConnectManifest(::grpc::ServerContext* context, ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListMemberships<WithAsyncMethod_ListFeatures<WithAsyncMethod_GetMembership<WithAsyncMethod_GetFeature<WithAsyncMethod_CreateMembership<WithAsyncMethod_CreateFeature<WithAsyncMethod_DeleteMembership<WithAsyncMethod_DeleteFeature<WithAsyncMethod_UpdateMembership<WithAsyncMethod_UpdateFeature<WithAsyncMethod_GenerateConnectManifest<Service > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListMemberships() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::ListMembershipsRequest, ::google::cloud::gkehub::v1::ListMembershipsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::ListMembershipsRequest* request, ::google::cloud::gkehub::v1::ListMembershipsResponse* response) { return this->ListMemberships(context, request, response); }));}
    void SetMessageAllocatorFor_ListMemberships(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::ListMembershipsRequest, ::google::cloud::gkehub::v1::ListMembershipsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::ListMembershipsRequest, ::google::cloud::gkehub::v1::ListMembershipsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMemberships(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListFeatures() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::ListFeaturesRequest, ::google::cloud::gkehub::v1::ListFeaturesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::ListFeaturesRequest* request, ::google::cloud::gkehub::v1::ListFeaturesResponse* response) { return this->ListFeatures(context, request, response); }));}
    void SetMessageAllocatorFor_ListFeatures(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::ListFeaturesRequest, ::google::cloud::gkehub::v1::ListFeaturesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::ListFeaturesRequest, ::google::cloud::gkehub::v1::ListFeaturesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFeatures(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetMembership() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GetMembershipRequest, ::google::cloud::gkehub::v1::Membership>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::GetMembershipRequest* request, ::google::cloud::gkehub::v1::Membership* response) { return this->GetMembership(context, request, response); }));}
    void SetMessageAllocatorFor_GetMembership(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::GetMembershipRequest, ::google::cloud::gkehub::v1::Membership>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GetMembershipRequest, ::google::cloud::gkehub::v1::Membership>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetFeature() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GetFeatureRequest, ::google::cloud::gkehub::v1::Feature>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::GetFeatureRequest* request, ::google::cloud::gkehub::v1::Feature* response) { return this->GetFeature(context, request, response); }));}
    void SetMessageAllocatorFor_GetFeature(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::GetFeatureRequest, ::google::cloud::gkehub::v1::Feature>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GetFeatureRequest, ::google::cloud::gkehub::v1::Feature>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateMembership() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::CreateMembershipRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::CreateMembershipRequest* request, ::google::longrunning::Operation* response) { return this->CreateMembership(context, request, response); }));}
    void SetMessageAllocatorFor_CreateMembership(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::CreateMembershipRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::CreateMembershipRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateFeature() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::CreateFeatureRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::CreateFeatureRequest* request, ::google::longrunning::Operation* response) { return this->CreateFeature(context, request, response); }));}
    void SetMessageAllocatorFor_CreateFeature(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::CreateFeatureRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::CreateFeatureRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::DeleteMembershipRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* request, ::google::longrunning::Operation* response) { return this->DeleteMembership(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteMembership(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::DeleteMembershipRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::DeleteMembershipRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::DeleteFeatureRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* request, ::google::longrunning::Operation* response) { return this->DeleteFeature(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteFeature(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::DeleteFeatureRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::DeleteFeatureRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::UpdateMembershipRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* request, ::google::longrunning::Operation* response) { return this->UpdateMembership(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateMembership(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::UpdateMembershipRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::UpdateMembershipRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::UpdateFeatureRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* request, ::google::longrunning::Operation* response) { return this->UpdateFeature(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateFeature(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::UpdateFeatureRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::UpdateFeatureRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GenerateConnectManifestRequest, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* request, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* response) { return this->GenerateConnectManifest(context, request, response); }));}
    void SetMessageAllocatorFor_GenerateConnectManifest(
        ::grpc::MessageAllocator< ::google::cloud::gkehub::v1::GenerateConnectManifestRequest, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::gkehub::v1::GenerateConnectManifestRequest, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateConnectManifest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListMemberships<WithCallbackMethod_ListFeatures<WithCallbackMethod_GetMembership<WithCallbackMethod_GetFeature<WithCallbackMethod_CreateMembership<WithCallbackMethod_CreateFeature<WithCallbackMethod_DeleteMembership<WithCallbackMethod_DeleteFeature<WithCallbackMethod_UpdateMembership<WithCallbackMethod_UpdateFeature<WithCallbackMethod_GenerateConnectManifest<Service > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListMemberships() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListFeatures() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetMembership() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetFeature() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateMembership() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateFeature() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListMemberships() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListMemberships(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListFeatures() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListFeatures(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetMembership() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetMembership(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetFeature() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetFeature(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateMembership() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateMembership(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateFeature() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateFeature(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteMembership(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteFeature(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateMembership(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateFeature(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGenerateConnectManifest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListMemberships() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListMemberships(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListMemberships(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListFeatures() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListFeatures(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListFeatures(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetMembership() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetMembership(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetFeature() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetFeature(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateMembership() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateMembership(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateFeature() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateFeature(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteMembership(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteFeature(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateMembership(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateMembership(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateFeature(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateFeature(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GenerateConnectManifest(context, request, response); }));
    }
    ~WithRawCallbackMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GenerateConnectManifest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListMemberships : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListMemberships() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::ListMembershipsRequest, ::google::cloud::gkehub::v1::ListMembershipsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::ListMembershipsRequest, ::google::cloud::gkehub::v1::ListMembershipsResponse>* streamer) {
                       return this->StreamedListMemberships(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListMemberships() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListMemberships(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListMembershipsRequest* /*request*/, ::google::cloud::gkehub::v1::ListMembershipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListMemberships(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::ListMembershipsRequest,::google::cloud::gkehub::v1::ListMembershipsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListFeatures : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListFeatures() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::ListFeaturesRequest, ::google::cloud::gkehub::v1::ListFeaturesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::ListFeaturesRequest, ::google::cloud::gkehub::v1::ListFeaturesResponse>* streamer) {
                       return this->StreamedListFeatures(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListFeatures() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListFeatures(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::ListFeaturesRequest* /*request*/, ::google::cloud::gkehub::v1::ListFeaturesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListFeatures(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::ListFeaturesRequest,::google::cloud::gkehub::v1::ListFeaturesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetMembership() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::GetMembershipRequest, ::google::cloud::gkehub::v1::Membership>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::GetMembershipRequest, ::google::cloud::gkehub::v1::Membership>* streamer) {
                       return this->StreamedGetMembership(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetMembershipRequest* /*request*/, ::google::cloud::gkehub::v1::Membership* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetMembership(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::GetMembershipRequest,::google::cloud::gkehub::v1::Membership>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetFeature() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::GetFeatureRequest, ::google::cloud::gkehub::v1::Feature>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::GetFeatureRequest, ::google::cloud::gkehub::v1::Feature>* streamer) {
                       return this->StreamedGetFeature(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GetFeatureRequest* /*request*/, ::google::cloud::gkehub::v1::Feature* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetFeature(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::GetFeatureRequest,::google::cloud::gkehub::v1::Feature>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateMembership() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::CreateMembershipRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::CreateMembershipRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateMembership(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateMembership(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::CreateMembershipRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateFeature() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::CreateFeatureRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::CreateFeatureRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateFeature(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::CreateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateFeature(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::CreateFeatureRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteMembership() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::DeleteMembershipRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::DeleteMembershipRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteMembership(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteMembership(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::DeleteMembershipRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteFeature() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::DeleteFeatureRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::DeleteFeatureRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteFeature(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::DeleteFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteFeature(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::DeleteFeatureRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateMembership : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateMembership() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::UpdateMembershipRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::UpdateMembershipRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateMembership(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateMembership() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateMembership(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateMembershipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateMembership(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::UpdateMembershipRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateFeature : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateFeature() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::UpdateFeatureRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::UpdateFeatureRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateFeature(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateFeature() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateFeature(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::UpdateFeatureRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateFeature(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::UpdateFeatureRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GenerateConnectManifest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GenerateConnectManifest() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::gkehub::v1::GenerateConnectManifestRequest, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::gkehub::v1::GenerateConnectManifestRequest, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* streamer) {
                       return this->StreamedGenerateConnectManifest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GenerateConnectManifest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GenerateConnectManifest(::grpc::ServerContext* /*context*/, const ::google::cloud::gkehub::v1::GenerateConnectManifestRequest* /*request*/, ::google::cloud::gkehub::v1::GenerateConnectManifestResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGenerateConnectManifest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::gkehub::v1::GenerateConnectManifestRequest,::google::cloud::gkehub::v1::GenerateConnectManifestResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListMemberships<WithStreamedUnaryMethod_ListFeatures<WithStreamedUnaryMethod_GetMembership<WithStreamedUnaryMethod_GetFeature<WithStreamedUnaryMethod_CreateMembership<WithStreamedUnaryMethod_CreateFeature<WithStreamedUnaryMethod_DeleteMembership<WithStreamedUnaryMethod_DeleteFeature<WithStreamedUnaryMethod_UpdateMembership<WithStreamedUnaryMethod_UpdateFeature<WithStreamedUnaryMethod_GenerateConnectManifest<Service > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListMemberships<WithStreamedUnaryMethod_ListFeatures<WithStreamedUnaryMethod_GetMembership<WithStreamedUnaryMethod_GetFeature<WithStreamedUnaryMethod_CreateMembership<WithStreamedUnaryMethod_CreateFeature<WithStreamedUnaryMethod_DeleteMembership<WithStreamedUnaryMethod_DeleteFeature<WithStreamedUnaryMethod_UpdateMembership<WithStreamedUnaryMethod_UpdateFeature<WithStreamedUnaryMethod_GenerateConnectManifest<Service > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace gkehub
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fgkehub_2fv1_2fservice_2eproto__INCLUDED
