// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networkmanagement/v1/reachability.proto
// Original file comments:
// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2freachability_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2freachability_2eproto__INCLUDED

#include "google/cloud/networkmanagement/v1/reachability.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace networkmanagement {
namespace v1 {

// The Reachability service in Google Cloud Network Management API
//
// The Reachability service in the Google Cloud Network Management API provides
// services that analyze the reachability within a single Google Virtual Private
// Cloud (VPC) network, between peered VPC networks, between VPC and on-premises
// networks, or between VPC networks and internet hosts. A reachability analysis
// is based on Google Cloud network configurations.
//
// You can use the analysis results to verify these configurations and
// to troubleshoot connectivity issues.
class ReachabilityService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networkmanagement.v1.ReachabilityService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all Connectivity Tests owned by a project.
    virtual ::grpc::Status ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>> AsyncListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>>(AsyncListConnectivityTestsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>> PrepareAsyncListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>>(PrepareAsyncListConnectivityTestsRaw(context, request, cq));
    }
    // Gets the details of a specific Connectivity Test.
    virtual ::grpc::Status GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>> AsyncGetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>>(AsyncGetConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>> PrepareAsyncGetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>>(PrepareAsyncGetConnectivityTestRaw(context, request, cq));
    }
    // Creates a new Connectivity Test.
    // After you create a test, the reachability analysis is performed as part
    // of the long running operation, which completes when the analysis completes.
    //
    // If the endpoint specifications in `ConnectivityTest` are invalid
    // (for example, containing non-existent resources in the network, or you
    // don't have read permissions to the network configurations of listed
    // projects), then the reachability result returns a value of `UNKNOWN`.
    //
    // If the endpoint specifications in `ConnectivityTest` are
    // incomplete, the reachability result returns a value of
    // <code>AMBIGUOUS</code>. For more information,
    // see the Connectivity Test documentation.
    virtual ::grpc::Status CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateConnectivityTestRaw(context, request, cq));
    }
    // Updates the configuration of an existing `ConnectivityTest`.
    // After you update a test, the reachability analysis is performed as part
    // of the long running operation, which completes when the analysis completes.
    // The Reachability state in the test resource is updated with the new result.
    //
    // If the endpoint specifications in `ConnectivityTest` are invalid
    // (for example, they contain non-existent resources in the network, or the
    // user does not have read permissions to the network configurations of
    // listed projects), then the reachability result returns a value of
    // <code>UNKNOWN</code>.
    //
    // If the endpoint specifications in `ConnectivityTest` are incomplete, the
    // reachability result returns a value of `AMBIGUOUS`. See the documentation
    // in `ConnectivityTest` for for more details.
    virtual ::grpc::Status UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateConnectivityTestRaw(context, request, cq));
    }
    // Rerun an existing `ConnectivityTest`.
    // After the user triggers the rerun, the reachability analysis is performed
    // as part of the long running operation, which completes when the analysis
    // completes.
    //
    // Even though the test configuration remains the same, the reachability
    // result may change due to underlying network configuration changes.
    //
    // If the endpoint specifications in `ConnectivityTest` become invalid (for
    // example, specified resources are deleted in the network, or you lost
    // read permissions to the network configurations of listed projects), then
    // the reachability result returns a value of `UNKNOWN`.
    virtual ::grpc::Status RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRerunConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRerunConnectivityTestRaw(context, request, cq));
    }
    // Deletes a specific `ConnectivityTest`.
    virtual ::grpc::Status DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteConnectivityTestRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all Connectivity Tests owned by a project.
      virtual void ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific Connectivity Test.
      virtual void GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new Connectivity Test.
      // After you create a test, the reachability analysis is performed as part
      // of the long running operation, which completes when the analysis completes.
      //
      // If the endpoint specifications in `ConnectivityTest` are invalid
      // (for example, containing non-existent resources in the network, or you
      // don't have read permissions to the network configurations of listed
      // projects), then the reachability result returns a value of `UNKNOWN`.
      //
      // If the endpoint specifications in `ConnectivityTest` are
      // incomplete, the reachability result returns a value of
      // <code>AMBIGUOUS</code>. For more information,
      // see the Connectivity Test documentation.
      virtual void CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the configuration of an existing `ConnectivityTest`.
      // After you update a test, the reachability analysis is performed as part
      // of the long running operation, which completes when the analysis completes.
      // The Reachability state in the test resource is updated with the new result.
      //
      // If the endpoint specifications in `ConnectivityTest` are invalid
      // (for example, they contain non-existent resources in the network, or the
      // user does not have read permissions to the network configurations of
      // listed projects), then the reachability result returns a value of
      // <code>UNKNOWN</code>.
      //
      // If the endpoint specifications in `ConnectivityTest` are incomplete, the
      // reachability result returns a value of `AMBIGUOUS`. See the documentation
      // in `ConnectivityTest` for for more details.
      virtual void UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Rerun an existing `ConnectivityTest`.
      // After the user triggers the rerun, the reachability analysis is performed
      // as part of the long running operation, which completes when the analysis
      // completes.
      //
      // Even though the test configuration remains the same, the reachability
      // result may change due to underlying network configuration changes.
      //
      // If the endpoint specifications in `ConnectivityTest` become invalid (for
      // example, specified resources are deleted in the network, or you lost
      // read permissions to the network configurations of listed projects), then
      // the reachability result returns a value of `UNKNOWN`.
      virtual void RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific `ConnectivityTest`.
      virtual void DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* AsyncListConnectivityTestsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* PrepareAsyncListConnectivityTestsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>* AsyncGetConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ConnectivityTest>* PrepareAsyncGetConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRerunConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRerunConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>> AsyncListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>>(AsyncListConnectivityTestsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>> PrepareAsyncListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>>(PrepareAsyncListConnectivityTestsRaw(context, request, cq));
    }
    ::grpc::Status GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>> AsyncGetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>>(AsyncGetConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>> PrepareAsyncGetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>>(PrepareAsyncGetConnectivityTestRaw(context, request, cq));
    }
    ::grpc::Status CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateConnectivityTestRaw(context, request, cq));
    }
    ::grpc::Status UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateConnectivityTestRaw(context, request, cq));
    }
    ::grpc::Status RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRerunConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRerunConnectivityTestRaw(context, request, cq));
    }
    ::grpc::Status DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteConnectivityTestRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteConnectivityTestRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConnectivityTests(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response, std::function<void(::grpc::Status)>) override;
      void GetConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RerunConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteConnectivityTest(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* AsyncListConnectivityTestsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* PrepareAsyncListConnectivityTestsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>* AsyncGetConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ConnectivityTest>* PrepareAsyncGetConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRerunConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRerunConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteConnectivityTestRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListConnectivityTests_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConnectivityTest_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateConnectivityTest_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateConnectivityTest_;
    const ::grpc::internal::RpcMethod rpcmethod_RerunConnectivityTest_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteConnectivityTest_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all Connectivity Tests owned by a project.
    virtual ::grpc::Status ListConnectivityTests(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response);
    // Gets the details of a specific Connectivity Test.
    virtual ::grpc::Status GetConnectivityTest(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response);
    // Creates a new Connectivity Test.
    // After you create a test, the reachability analysis is performed as part
    // of the long running operation, which completes when the analysis completes.
    //
    // If the endpoint specifications in `ConnectivityTest` are invalid
    // (for example, containing non-existent resources in the network, or you
    // don't have read permissions to the network configurations of listed
    // projects), then the reachability result returns a value of `UNKNOWN`.
    //
    // If the endpoint specifications in `ConnectivityTest` are
    // incomplete, the reachability result returns a value of
    // <code>AMBIGUOUS</code>. For more information,
    // see the Connectivity Test documentation.
    virtual ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response);
    // Updates the configuration of an existing `ConnectivityTest`.
    // After you update a test, the reachability analysis is performed as part
    // of the long running operation, which completes when the analysis completes.
    // The Reachability state in the test resource is updated with the new result.
    //
    // If the endpoint specifications in `ConnectivityTest` are invalid
    // (for example, they contain non-existent resources in the network, or the
    // user does not have read permissions to the network configurations of
    // listed projects), then the reachability result returns a value of
    // <code>UNKNOWN</code>.
    //
    // If the endpoint specifications in `ConnectivityTest` are incomplete, the
    // reachability result returns a value of `AMBIGUOUS`. See the documentation
    // in `ConnectivityTest` for for more details.
    virtual ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response);
    // Rerun an existing `ConnectivityTest`.
    // After the user triggers the rerun, the reachability analysis is performed
    // as part of the long running operation, which completes when the analysis
    // completes.
    //
    // Even though the test configuration remains the same, the reachability
    // result may change due to underlying network configuration changes.
    //
    // If the endpoint specifications in `ConnectivityTest` become invalid (for
    // example, specified resources are deleted in the network, or you lost
    // read permissions to the network configurations of listed projects), then
    // the reachability result returns a value of `UNKNOWN`.
    virtual ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response);
    // Deletes a specific `ConnectivityTest`.
    virtual ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnectivityTests(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnectivityTest(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkmanagement::v1::ConnectivityTest>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnectivityTest(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateConnectivityTest(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRerunConnectivityTest(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnectivityTest(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListConnectivityTests<WithAsyncMethod_GetConnectivityTest<WithAsyncMethod_CreateConnectivityTest<WithAsyncMethod_UpdateConnectivityTest<WithAsyncMethod_RerunConnectivityTest<WithAsyncMethod_DeleteConnectivityTest<Service > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* request, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* response) { return this->ListConnectivityTests(context, request, response); }));}
    void SetMessageAllocatorFor_ListConnectivityTests(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnectivityTests(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest, ::google::cloud::networkmanagement::v1::ConnectivityTest>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* request, ::google::cloud::networkmanagement::v1::ConnectivityTest* response) { return this->GetConnectivityTest(context, request, response); }));}
    void SetMessageAllocatorFor_GetConnectivityTest(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest, ::google::cloud::networkmanagement::v1::ConnectivityTest>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest, ::google::cloud::networkmanagement::v1::ConnectivityTest>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* request, ::google::longrunning::Operation* response) { return this->CreateConnectivityTest(context, request, response); }));}
    void SetMessageAllocatorFor_CreateConnectivityTest(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* request, ::google::longrunning::Operation* response) { return this->UpdateConnectivityTest(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateConnectivityTest(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* request, ::google::longrunning::Operation* response) { return this->RerunConnectivityTest(context, request, response); }));}
    void SetMessageAllocatorFor_RerunConnectivityTest(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RerunConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* request, ::google::longrunning::Operation* response) { return this->DeleteConnectivityTest(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteConnectivityTest(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListConnectivityTests<WithCallbackMethod_GetConnectivityTest<WithCallbackMethod_CreateConnectivityTest<WithCallbackMethod_UpdateConnectivityTest<WithCallbackMethod_RerunConnectivityTest<WithCallbackMethod_DeleteConnectivityTest<Service > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConnectivityTests(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConnectivityTest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConnectivityTest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateConnectivityTest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRerunConnectivityTest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConnectivityTest(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConnectivityTests(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConnectivityTests(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConnectivityTest(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateConnectivityTest(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateConnectivityTest(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RerunConnectivityTest(context, request, response); }));
    }
    ~WithRawCallbackMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RerunConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteConnectivityTest(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConnectivityTest(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConnectivityTests : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConnectivityTests() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* streamer) {
                       return this->StreamedListConnectivityTests(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConnectivityTests() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConnectivityTests(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConnectivityTests(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::ListConnectivityTestsRequest,::google::cloud::networkmanagement::v1::ListConnectivityTestsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConnectivityTest() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest, ::google::cloud::networkmanagement::v1::ConnectivityTest>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest, ::google::cloud::networkmanagement::v1::ConnectivityTest>* streamer) {
                       return this->StreamedGetConnectivityTest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest* /*request*/, ::google::cloud::networkmanagement::v1::ConnectivityTest* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConnectivityTest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::GetConnectivityTestRequest,::google::cloud::networkmanagement::v1::ConnectivityTest>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateConnectivityTest() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateConnectivityTest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateConnectivityTest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::CreateConnectivityTestRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateConnectivityTest() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateConnectivityTest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateConnectivityTest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::UpdateConnectivityTestRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RerunConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RerunConnectivityTest() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRerunConnectivityTest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RerunConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RerunConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRerunConnectivityTest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::RerunConnectivityTestRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteConnectivityTest : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteConnectivityTest() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteConnectivityTest(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteConnectivityTest() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteConnectivityTest(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteConnectivityTest(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::DeleteConnectivityTestRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListConnectivityTests<WithStreamedUnaryMethod_GetConnectivityTest<WithStreamedUnaryMethod_CreateConnectivityTest<WithStreamedUnaryMethod_UpdateConnectivityTest<WithStreamedUnaryMethod_RerunConnectivityTest<WithStreamedUnaryMethod_DeleteConnectivityTest<Service > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListConnectivityTests<WithStreamedUnaryMethod_GetConnectivityTest<WithStreamedUnaryMethod_CreateConnectivityTest<WithStreamedUnaryMethod_UpdateConnectivityTest<WithStreamedUnaryMethod_RerunConnectivityTest<WithStreamedUnaryMethod_DeleteConnectivityTest<Service > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace networkmanagement
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2freachability_2eproto__INCLUDED
