// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/policysimulator/v1/simulator.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_POLICYSIMULATOR_V1_SIMULATOR_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_POLICYSIMULATOR_V1_SIMULATOR_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/policysimulator/v1/simulator.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace policysimulator_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class SimulatorConnectionIdempotencyPolicy {
 public:
  virtual ~SimulatorConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<SimulatorConnectionIdempotencyPolicy> clone() const;

  virtual google::cloud::Idempotency GetReplay(
      google::cloud::policysimulator::v1::GetReplayRequest const& request);

  virtual google::cloud::Idempotency CreateReplay(
      google::cloud::policysimulator::v1::CreateReplayRequest const& request);

  virtual google::cloud::Idempotency ListReplayResults(
      google::cloud::policysimulator::v1::ListReplayResultsRequest request);
};

std::unique_ptr<SimulatorConnectionIdempotencyPolicy>
MakeDefaultSimulatorConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace policysimulator_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_POLICYSIMULATOR_V1_SIMULATOR_CONNECTION_IDEMPOTENCY_POLICY_H
