// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/model_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_INTERNAL_MODEL_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_INTERNAL_MODEL_STUB_H

#include "google/cloud/completion_queue.h"
#include "google/cloud/future.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/retail/v2/model_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace retail_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ModelServiceStub {
 public:
  virtual ~ModelServiceStub() = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncCreateModel(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::retail::v2::CreateModelRequest const& request) = 0;

  virtual StatusOr<google::cloud::retail::v2::Model> GetModel(
      grpc::ClientContext& context,
      google::cloud::retail::v2::GetModelRequest const& request) = 0;

  virtual StatusOr<google::cloud::retail::v2::Model> PauseModel(
      grpc::ClientContext& context,
      google::cloud::retail::v2::PauseModelRequest const& request) = 0;

  virtual StatusOr<google::cloud::retail::v2::Model> ResumeModel(
      grpc::ClientContext& context,
      google::cloud::retail::v2::ResumeModelRequest const& request) = 0;

  virtual Status DeleteModel(
      grpc::ClientContext& context,
      google::cloud::retail::v2::DeleteModelRequest const& request) = 0;

  virtual StatusOr<google::cloud::retail::v2::ListModelsResponse> ListModels(
      grpc::ClientContext& context,
      google::cloud::retail::v2::ListModelsRequest const& request) = 0;

  virtual StatusOr<google::cloud::retail::v2::Model> UpdateModel(
      grpc::ClientContext& context,
      google::cloud::retail::v2::UpdateModelRequest const& request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncTuneModel(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::retail::v2::TuneModelRequest const& request) = 0;

  virtual future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultModelServiceStub : public ModelServiceStub {
 public:
  DefaultModelServiceStub(
      std::unique_ptr<google::cloud::retail::v2::ModelService::StubInterface>
          grpc_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations)
      : grpc_stub_(std::move(grpc_stub)), operations_(std::move(operations)) {}

  future<StatusOr<google::longrunning::Operation>> AsyncCreateModel(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::retail::v2::CreateModelRequest const& request) override;

  StatusOr<google::cloud::retail::v2::Model> GetModel(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::GetModelRequest const& request) override;

  StatusOr<google::cloud::retail::v2::Model> PauseModel(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::PauseModelRequest const& request) override;

  StatusOr<google::cloud::retail::v2::Model> ResumeModel(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::ResumeModelRequest const& request) override;

  Status DeleteModel(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::DeleteModelRequest const& request) override;

  StatusOr<google::cloud::retail::v2::ListModelsResponse> ListModels(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::ListModelsRequest const& request) override;

  StatusOr<google::cloud::retail::v2::Model> UpdateModel(
      grpc::ClientContext& client_context,
      google::cloud::retail::v2::UpdateModelRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncTuneModel(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::cloud::retail::v2::TuneModelRequest const& request) override;

  future<StatusOr<google::longrunning::Operation>> AsyncGetOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::GetOperationRequest const& request) override;

  future<Status> AsyncCancelOperation(
      google::cloud::CompletionQueue& cq,
      std::shared_ptr<grpc::ClientContext> context,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::retail::v2::ModelService::StubInterface>
      grpc_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface> operations_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_INTERNAL_MODEL_STUB_H
