// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/support/v2/case_service.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fsupport_2fv2_2fcase_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fsupport_2fv2_2fcase_5fservice_2eproto__INCLUDED

#include "google/cloud/support/v2/case_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace support {
namespace v2 {

// A service to manage Google Cloud support cases.
class CaseService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.support.v2.CaseService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Retrieve the specified case.
    virtual ::grpc::Status GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::google::cloud::support::v2::Case* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> AsyncGetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(AsyncGetCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> PrepareAsyncGetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(PrepareAsyncGetCaseRaw(context, request, cq));
    }
    // Retrieve all cases under the specified parent.
    //
    // Note: Listing cases under an Organization returns only the cases directly
    // parented by that organization. To retrieve all cases under an organization,
    // including cases parented by projects under that organization, use
    // `cases.search`.
    virtual ::grpc::Status ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::google::cloud::support::v2::ListCasesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>> AsyncListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>>(AsyncListCasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>> PrepareAsyncListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>>(PrepareAsyncListCasesRaw(context, request, cq));
    }
    // Search cases using the specified query.
    virtual ::grpc::Status SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::google::cloud::support::v2::SearchCasesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>> AsyncSearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>>(AsyncSearchCasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>> PrepareAsyncSearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>>(PrepareAsyncSearchCasesRaw(context, request, cq));
    }
    // Create a new case and associate it with the given Google Cloud Resource.
    // The case object must have the following fields set: `display_name`,
    // `description`, `classification`, and `priority`.
    virtual ::grpc::Status CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::google::cloud::support::v2::Case* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> AsyncCreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(AsyncCreateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> PrepareAsyncCreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(PrepareAsyncCreateCaseRaw(context, request, cq));
    }
    // Update the specified case. Only a subset of fields can be updated.
    virtual ::grpc::Status UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::google::cloud::support::v2::Case* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> AsyncUpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(AsyncUpdateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> PrepareAsyncUpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(PrepareAsyncUpdateCaseRaw(context, request, cq));
    }
    // Escalate a case. Escalating a case will initiate the Google Cloud Support
    // escalation management process.
    //
    // This operation is only available to certain Customer Care tiers. Go to
    // https://cloud.google.com/support and look for 'Technical support
    // escalations' in the feature list to find out which tiers are able to
    // perform escalations.
    virtual ::grpc::Status EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::google::cloud::support::v2::Case* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> AsyncEscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(AsyncEscalateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> PrepareAsyncEscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(PrepareAsyncEscalateCaseRaw(context, request, cq));
    }
    // Close the specified case.
    virtual ::grpc::Status CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::google::cloud::support::v2::Case* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> AsyncCloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(AsyncCloseCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>> PrepareAsyncCloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>>(PrepareAsyncCloseCaseRaw(context, request, cq));
    }
    // Retrieve valid classifications to be used when creating a support case.
    // The classications are hierarchical, with each classification containing
    // all levels of the hierarchy, separated by " > ". For example "Technical
    // Issue > Compute > Compute Engine".
    virtual ::grpc::Status SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>> AsyncSearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>>(AsyncSearchCaseClassificationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>> PrepareAsyncSearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>>(PrepareAsyncSearchCaseClassificationsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Retrieve the specified case.
      virtual void GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve all cases under the specified parent.
      //
      // Note: Listing cases under an Organization returns only the cases directly
      // parented by that organization. To retrieve all cases under an organization,
      // including cases parented by projects under that organization, use
      // `cases.search`.
      virtual void ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Search cases using the specified query.
      virtual void SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Create a new case and associate it with the given Google Cloud Resource.
      // The case object must have the following fields set: `display_name`,
      // `description`, `classification`, and `priority`.
      virtual void CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Update the specified case. Only a subset of fields can be updated.
      virtual void UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Escalate a case. Escalating a case will initiate the Google Cloud Support
      // escalation management process.
      //
      // This operation is only available to certain Customer Care tiers. Go to
      // https://cloud.google.com/support and look for 'Technical support
      // escalations' in the feature list to find out which tiers are able to
      // perform escalations.
      virtual void EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) = 0;
      virtual void EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Close the specified case.
      virtual void CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieve valid classifications to be used when creating a support case.
      // The classications are hierarchical, with each classification containing
      // all levels of the hierarchy, separated by " > ". For example "Technical
      // Issue > Compute > Compute Engine".
      virtual void SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* AsyncGetCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* PrepareAsyncGetCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>* AsyncListCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::ListCasesResponse>* PrepareAsyncListCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>* AsyncSearchCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCasesResponse>* PrepareAsyncSearchCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* AsyncCreateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* PrepareAsyncCreateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* AsyncUpdateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* PrepareAsyncUpdateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* AsyncEscalateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* PrepareAsyncEscalateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* AsyncCloseCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::Case>* PrepareAsyncCloseCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>* AsyncSearchCaseClassificationsRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::support::v2::SearchCaseClassificationsResponse>* PrepareAsyncSearchCaseClassificationsRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::google::cloud::support::v2::Case* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> AsyncGetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(AsyncGetCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> PrepareAsyncGetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(PrepareAsyncGetCaseRaw(context, request, cq));
    }
    ::grpc::Status ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::google::cloud::support::v2::ListCasesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>> AsyncListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>>(AsyncListCasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>> PrepareAsyncListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>>(PrepareAsyncListCasesRaw(context, request, cq));
    }
    ::grpc::Status SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::google::cloud::support::v2::SearchCasesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>> AsyncSearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>>(AsyncSearchCasesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>> PrepareAsyncSearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>>(PrepareAsyncSearchCasesRaw(context, request, cq));
    }
    ::grpc::Status CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::google::cloud::support::v2::Case* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> AsyncCreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(AsyncCreateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> PrepareAsyncCreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(PrepareAsyncCreateCaseRaw(context, request, cq));
    }
    ::grpc::Status UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::google::cloud::support::v2::Case* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> AsyncUpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(AsyncUpdateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> PrepareAsyncUpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(PrepareAsyncUpdateCaseRaw(context, request, cq));
    }
    ::grpc::Status EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::google::cloud::support::v2::Case* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> AsyncEscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(AsyncEscalateCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> PrepareAsyncEscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(PrepareAsyncEscalateCaseRaw(context, request, cq));
    }
    ::grpc::Status CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::google::cloud::support::v2::Case* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> AsyncCloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(AsyncCloseCaseRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>> PrepareAsyncCloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>>(PrepareAsyncCloseCaseRaw(context, request, cq));
    }
    ::grpc::Status SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>> AsyncSearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>>(AsyncSearchCaseClassificationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>> PrepareAsyncSearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>>(PrepareAsyncSearchCaseClassificationsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) override;
      void GetCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchCases(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) override;
      void CreateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) override;
      void UpdateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) override;
      void EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) override;
      void EscalateCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response, std::function<void(::grpc::Status)>) override;
      void CloseCase(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchCaseClassifications(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* AsyncGetCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* PrepareAsyncGetCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::GetCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>* AsyncListCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::ListCasesResponse>* PrepareAsyncListCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::ListCasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>* AsyncSearchCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCasesResponse>* PrepareAsyncSearchCasesRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCasesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* AsyncCreateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* PrepareAsyncCreateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CreateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* AsyncUpdateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* PrepareAsyncUpdateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::UpdateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* AsyncEscalateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* PrepareAsyncEscalateCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::EscalateCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* AsyncCloseCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::Case>* PrepareAsyncCloseCaseRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::CloseCaseRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>* AsyncSearchCaseClassificationsRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::support::v2::SearchCaseClassificationsResponse>* PrepareAsyncSearchCaseClassificationsRaw(::grpc::ClientContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetCase_;
    const ::grpc::internal::RpcMethod rpcmethod_ListCases_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchCases_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCase_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCase_;
    const ::grpc::internal::RpcMethod rpcmethod_EscalateCase_;
    const ::grpc::internal::RpcMethod rpcmethod_CloseCase_;
    const ::grpc::internal::RpcMethod rpcmethod_SearchCaseClassifications_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Retrieve the specified case.
    virtual ::grpc::Status GetCase(::grpc::ServerContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response);
    // Retrieve all cases under the specified parent.
    //
    // Note: Listing cases under an Organization returns only the cases directly
    // parented by that organization. To retrieve all cases under an organization,
    // including cases parented by projects under that organization, use
    // `cases.search`.
    virtual ::grpc::Status ListCases(::grpc::ServerContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response);
    // Search cases using the specified query.
    virtual ::grpc::Status SearchCases(::grpc::ServerContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response);
    // Create a new case and associate it with the given Google Cloud Resource.
    // The case object must have the following fields set: `display_name`,
    // `description`, `classification`, and `priority`.
    virtual ::grpc::Status CreateCase(::grpc::ServerContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response);
    // Update the specified case. Only a subset of fields can be updated.
    virtual ::grpc::Status UpdateCase(::grpc::ServerContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response);
    // Escalate a case. Escalating a case will initiate the Google Cloud Support
    // escalation management process.
    //
    // This operation is only available to certain Customer Care tiers. Go to
    // https://cloud.google.com/support and look for 'Technical support
    // escalations' in the feature list to find out which tiers are able to
    // perform escalations.
    virtual ::grpc::Status EscalateCase(::grpc::ServerContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response);
    // Close the specified case.
    virtual ::grpc::Status CloseCase(::grpc::ServerContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response);
    // Retrieve valid classifications to be used when creating a support case.
    // The classications are hierarchical, with each classification containing
    // all levels of the hierarchy, separated by " > ". For example "Technical
    // Issue > Compute > Compute Engine".
    virtual ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCase() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCase(::grpc::ServerContext* context, ::google::cloud::support::v2::GetCaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::Case>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListCases() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCases(::grpc::ServerContext* context, ::google::cloud::support::v2::ListCasesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::ListCasesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchCases() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCases(::grpc::ServerContext* context, ::google::cloud::support::v2::SearchCasesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::SearchCasesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCase() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCase(::grpc::ServerContext* context, ::google::cloud::support::v2::CreateCaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::Case>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCase() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCase(::grpc::ServerContext* context, ::google::cloud::support::v2::UpdateCaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::Case>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_EscalateCase() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEscalateCase(::grpc::ServerContext* context, ::google::cloud::support::v2::EscalateCaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::Case>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CloseCase() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCloseCase(::grpc::ServerContext* context, ::google::cloud::support::v2::CloseCaseRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::Case>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCaseClassifications(::grpc::ServerContext* context, ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::support::v2::SearchCaseClassificationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetCase<WithAsyncMethod_ListCases<WithAsyncMethod_SearchCases<WithAsyncMethod_CreateCase<WithAsyncMethod_UpdateCase<WithAsyncMethod_EscalateCase<WithAsyncMethod_CloseCase<WithAsyncMethod_SearchCaseClassifications<Service > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCase() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::GetCaseRequest, ::google::cloud::support::v2::Case>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::GetCaseRequest* request, ::google::cloud::support::v2::Case* response) { return this->GetCase(context, request, response); }));}
    void SetMessageAllocatorFor_GetCase(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::GetCaseRequest, ::google::cloud::support::v2::Case>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::GetCaseRequest, ::google::cloud::support::v2::Case>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListCases() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::ListCasesRequest, ::google::cloud::support::v2::ListCasesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::ListCasesRequest* request, ::google::cloud::support::v2::ListCasesResponse* response) { return this->ListCases(context, request, response); }));}
    void SetMessageAllocatorFor_ListCases(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::ListCasesRequest, ::google::cloud::support::v2::ListCasesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::ListCasesRequest, ::google::cloud::support::v2::ListCasesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCases(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchCases() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::SearchCasesRequest, ::google::cloud::support::v2::SearchCasesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::SearchCasesRequest* request, ::google::cloud::support::v2::SearchCasesResponse* response) { return this->SearchCases(context, request, response); }));}
    void SetMessageAllocatorFor_SearchCases(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::SearchCasesRequest, ::google::cloud::support::v2::SearchCasesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::SearchCasesRequest, ::google::cloud::support::v2::SearchCasesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCases(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCase() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::CreateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::CreateCaseRequest* request, ::google::cloud::support::v2::Case* response) { return this->CreateCase(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCase(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::CreateCaseRequest, ::google::cloud::support::v2::Case>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::CreateCaseRequest, ::google::cloud::support::v2::Case>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCase() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::UpdateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::UpdateCaseRequest* request, ::google::cloud::support::v2::Case* response) { return this->UpdateCase(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCase(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::UpdateCaseRequest, ::google::cloud::support::v2::Case>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::UpdateCaseRequest, ::google::cloud::support::v2::Case>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_EscalateCase() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::EscalateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::EscalateCaseRequest* request, ::google::cloud::support::v2::Case* response) { return this->EscalateCase(context, request, response); }));}
    void SetMessageAllocatorFor_EscalateCase(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::EscalateCaseRequest, ::google::cloud::support::v2::Case>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::EscalateCaseRequest, ::google::cloud::support::v2::Case>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EscalateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CloseCase() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::CloseCaseRequest, ::google::cloud::support::v2::Case>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::CloseCaseRequest* request, ::google::cloud::support::v2::Case* response) { return this->CloseCase(context, request, response); }));}
    void SetMessageAllocatorFor_CloseCase(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::CloseCaseRequest, ::google::cloud::support::v2::Case>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::CloseCaseRequest, ::google::cloud::support::v2::Case>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CloseCase(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::SearchCaseClassificationsRequest, ::google::cloud::support::v2::SearchCaseClassificationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* request, ::google::cloud::support::v2::SearchCaseClassificationsResponse* response) { return this->SearchCaseClassifications(context, request, response); }));}
    void SetMessageAllocatorFor_SearchCaseClassifications(
        ::grpc::MessageAllocator< ::google::cloud::support::v2::SearchCaseClassificationsRequest, ::google::cloud::support::v2::SearchCaseClassificationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::support::v2::SearchCaseClassificationsRequest, ::google::cloud::support::v2::SearchCaseClassificationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCaseClassifications(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetCase<WithCallbackMethod_ListCases<WithCallbackMethod_SearchCases<WithCallbackMethod_CreateCase<WithCallbackMethod_UpdateCase<WithCallbackMethod_EscalateCase<WithCallbackMethod_CloseCase<WithCallbackMethod_SearchCaseClassifications<Service > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCase() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListCases() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchCases() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCase() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCase() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_EscalateCase() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CloseCase() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCase() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListCases() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListCases(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchCases() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCases(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCase() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCase() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_EscalateCase() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestEscalateCase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CloseCase() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCloseCase(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCaseClassifications(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCase() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCase(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListCases() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListCases(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListCases(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchCases() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchCases(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCases(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCase() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCase(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCase() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCase(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_EscalateCase() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->EscalateCase(context, request, response); }));
    }
    ~WithRawCallbackMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* EscalateCase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CloseCase() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CloseCase(context, request, response); }));
    }
    ~WithRawCallbackMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CloseCase(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchCaseClassifications(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCaseClassifications(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCase() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::GetCaseRequest, ::google::cloud::support::v2::Case>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::GetCaseRequest, ::google::cloud::support::v2::Case>* streamer) {
                       return this->StreamedGetCase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::GetCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::GetCaseRequest,::google::cloud::support::v2::Case>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListCases() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::ListCasesRequest, ::google::cloud::support::v2::ListCasesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::ListCasesRequest, ::google::cloud::support::v2::ListCasesResponse>* streamer) {
                       return this->StreamedListCases(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::ListCasesRequest* /*request*/, ::google::cloud::support::v2::ListCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListCases(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::ListCasesRequest,::google::cloud::support::v2::ListCasesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchCases : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchCases() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::SearchCasesRequest, ::google::cloud::support::v2::SearchCasesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::SearchCasesRequest, ::google::cloud::support::v2::SearchCasesResponse>* streamer) {
                       return this->StreamedSearchCases(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchCases() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchCases(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCasesRequest* /*request*/, ::google::cloud::support::v2::SearchCasesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchCases(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::SearchCasesRequest,::google::cloud::support::v2::SearchCasesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCase() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::CreateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::CreateCaseRequest, ::google::cloud::support::v2::Case>* streamer) {
                       return this->StreamedCreateCase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CreateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::CreateCaseRequest,::google::cloud::support::v2::Case>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCase() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::UpdateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::UpdateCaseRequest, ::google::cloud::support::v2::Case>* streamer) {
                       return this->StreamedUpdateCase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::UpdateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::UpdateCaseRequest,::google::cloud::support::v2::Case>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_EscalateCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_EscalateCase() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::EscalateCaseRequest, ::google::cloud::support::v2::Case>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::EscalateCaseRequest, ::google::cloud::support::v2::Case>* streamer) {
                       return this->StreamedEscalateCase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_EscalateCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status EscalateCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::EscalateCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedEscalateCase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::EscalateCaseRequest,::google::cloud::support::v2::Case>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CloseCase : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CloseCase() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::CloseCaseRequest, ::google::cloud::support::v2::Case>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::CloseCaseRequest, ::google::cloud::support::v2::Case>* streamer) {
                       return this->StreamedCloseCase(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CloseCase() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CloseCase(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::CloseCaseRequest* /*request*/, ::google::cloud::support::v2::Case* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCloseCase(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::CloseCaseRequest,::google::cloud::support::v2::Case>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchCaseClassifications : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchCaseClassifications() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::support::v2::SearchCaseClassificationsRequest, ::google::cloud::support::v2::SearchCaseClassificationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::support::v2::SearchCaseClassificationsRequest, ::google::cloud::support::v2::SearchCaseClassificationsResponse>* streamer) {
                       return this->StreamedSearchCaseClassifications(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchCaseClassifications() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchCaseClassifications(::grpc::ServerContext* /*context*/, const ::google::cloud::support::v2::SearchCaseClassificationsRequest* /*request*/, ::google::cloud::support::v2::SearchCaseClassificationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchCaseClassifications(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::support::v2::SearchCaseClassificationsRequest,::google::cloud::support::v2::SearchCaseClassificationsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetCase<WithStreamedUnaryMethod_ListCases<WithStreamedUnaryMethod_SearchCases<WithStreamedUnaryMethod_CreateCase<WithStreamedUnaryMethod_UpdateCase<WithStreamedUnaryMethod_EscalateCase<WithStreamedUnaryMethod_CloseCase<WithStreamedUnaryMethod_SearchCaseClassifications<Service > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetCase<WithStreamedUnaryMethod_ListCases<WithStreamedUnaryMethod_SearchCases<WithStreamedUnaryMethod_CreateCase<WithStreamedUnaryMethod_UpdateCase<WithStreamedUnaryMethod_EscalateCase<WithStreamedUnaryMethod_CloseCase<WithStreamedUnaryMethod_SearchCaseClassifications<Service > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace support
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fsupport_2fv2_2fcase_5fservice_2eproto__INCLUDED
