// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/devtools/cloudprofiler/v2/profiler.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fdevtools_2fcloudprofiler_2fv2_2fprofiler_2eproto__INCLUDED
#define GRPC_google_2fdevtools_2fcloudprofiler_2fv2_2fprofiler_2eproto__INCLUDED

#include "google/devtools/cloudprofiler/v2/profiler.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace devtools {
namespace cloudprofiler {
namespace v2 {

// Manage the collection of continuous profiling data provided by profiling
// agents running in the cloud or by an offline provider of profiling data.
//
// General guidelines:
// * Profiles for a single deployment must be created in ascending time order.
// * Profiles can be created in either online or offline mode, see below.
class ProfilerService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.devtools.cloudprofiler.v2.ProfilerService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // CreateProfile creates a new profile resource in the online mode.
    //
    // The server ensures that the new profiles are created at a constant rate per
    // deployment, so the creation request may hang for some time until the next
    // profile session is available.
    //
    // The request may fail with ABORTED error if the creation is not available
    // within ~1m, the response will indicate the duration of the backoff the
    // client should take before attempting creating a profile again. The backoff
    // duration is returned in google.rpc.RetryInfo extension on the response
    // status. To a gRPC client, the extension will be return as a
    // binary-serialized proto in the trailing metadata item named
    // "google.rpc.retryinfo-bin".
    //
    virtual ::grpc::Status CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> AsyncCreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncCreateProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncCreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncCreateProfileRaw(context, request, cq));
    }
    // CreateOfflineProfile creates a new profile resource in the offline mode.
    // The client provides the profile to create along with the profile bytes, the
    // server records it.
    virtual ::grpc::Status CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> AsyncCreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncCreateOfflineProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncCreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncCreateOfflineProfileRaw(context, request, cq));
    }
    // UpdateProfile updates the profile bytes and labels on the profile resource
    // created in the online mode. Updating the bytes for profiles created in the
    // offline mode is currently not supported: the profile content must be
    // provided at the time of the profile creation.
    virtual ::grpc::Status UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> AsyncUpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncUpdateProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncUpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncUpdateProfileRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // CreateProfile creates a new profile resource in the online mode.
      //
      // The server ensures that the new profiles are created at a constant rate per
      // deployment, so the creation request may hang for some time until the next
      // profile session is available.
      //
      // The request may fail with ABORTED error if the creation is not available
      // within ~1m, the response will indicate the duration of the backoff the
      // client should take before attempting creating a profile again. The backoff
      // duration is returned in google.rpc.RetryInfo extension on the response
      // status. To a gRPC client, the extension will be return as a
      // binary-serialized proto in the trailing metadata item named
      // "google.rpc.retryinfo-bin".
      //
      virtual void CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // CreateOfflineProfile creates a new profile resource in the offline mode.
      // The client provides the profile to create along with the profile bytes, the
      // server records it.
      virtual void CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // UpdateProfile updates the profile bytes and labels on the profile resource
      // created in the online mode. Updating the bytes for profiles created in the
      // offline mode is currently not supported: the profile content must be
      // provided at the time of the profile creation.
      virtual void UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* AsyncCreateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncCreateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* AsyncCreateOfflineProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncCreateOfflineProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* AsyncUpdateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncUpdateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> AsyncCreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncCreateProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncCreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncCreateProfileRaw(context, request, cq));
    }
    ::grpc::Status CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> AsyncCreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncCreateOfflineProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncCreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncCreateOfflineProfileRaw(context, request, cq));
    }
    ::grpc::Status UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::google::devtools::cloudprofiler::v2::Profile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> AsyncUpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(AsyncUpdateProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>> PrepareAsyncUpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>>(PrepareAsyncUpdateProfileRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) override;
      void CreateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) override;
      void CreateOfflineProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, std::function<void(::grpc::Status)>) override;
      void UpdateProfile(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* AsyncCreateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncCreateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* AsyncCreateOfflineProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncCreateOfflineProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* AsyncUpdateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::devtools::cloudprofiler::v2::Profile>* PrepareAsyncUpdateProfileRaw(::grpc::ClientContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateOfflineProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProfile_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // CreateProfile creates a new profile resource in the online mode.
    //
    // The server ensures that the new profiles are created at a constant rate per
    // deployment, so the creation request may hang for some time until the next
    // profile session is available.
    //
    // The request may fail with ABORTED error if the creation is not available
    // within ~1m, the response will indicate the duration of the backoff the
    // client should take before attempting creating a profile again. The backoff
    // duration is returned in google.rpc.RetryInfo extension on the response
    // status. To a gRPC client, the extension will be return as a
    // binary-serialized proto in the trailing metadata item named
    // "google.rpc.retryinfo-bin".
    //
    virtual ::grpc::Status CreateProfile(::grpc::ServerContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response);
    // CreateOfflineProfile creates a new profile resource in the offline mode.
    // The client provides the profile to create along with the profile bytes, the
    // server records it.
    virtual ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response);
    // UpdateProfile updates the profile bytes and labels on the profile resource
    // created in the online mode. Updating the bytes for profiles created in the
    // offline mode is currently not supported: the profile content must be
    // provided at the time of the profile creation.
    virtual ::grpc::Status UpdateProfile(::grpc::ServerContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProfile() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProfile(::grpc::ServerContext* context, ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudprofiler::v2::Profile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOfflineProfile(::grpc::ServerContext* context, ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudprofiler::v2::Profile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProfile(::grpc::ServerContext* context, ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::devtools::cloudprofiler::v2::Profile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateProfile<WithAsyncMethod_CreateOfflineProfile<WithAsyncMethod_UpdateProfile<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProfile() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::CreateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response) { return this->CreateProfile(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProfile(
        ::grpc::MessageAllocator< ::google::devtools::cloudprofiler::v2::CreateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::CreateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response) { return this->CreateOfflineProfile(context, request, response); }));}
    void SetMessageAllocatorFor_CreateOfflineProfile(
        ::grpc::MessageAllocator< ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOfflineProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::UpdateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* request, ::google::devtools::cloudprofiler::v2::Profile* response) { return this->UpdateProfile(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProfile(
        ::grpc::MessageAllocator< ::google::devtools::cloudprofiler::v2::UpdateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::devtools::cloudprofiler::v2::UpdateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateProfile<WithCallbackMethod_CreateOfflineProfile<WithCallbackMethod_UpdateProfile<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProfile() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProfile() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOfflineProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProfile() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateOfflineProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOfflineProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProfile() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudprofiler::v2::CreateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudprofiler::v2::CreateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* streamer) {
                       return this->StreamedCreateProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudprofiler::v2::CreateProfileRequest,::google::devtools::cloudprofiler::v2::Profile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateOfflineProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateOfflineProfile() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* streamer) {
                       return this->StreamedCreateOfflineProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateOfflineProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateOfflineProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateOfflineProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudprofiler::v2::CreateOfflineProfileRequest,::google::devtools::cloudprofiler::v2::Profile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProfile() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::devtools::cloudprofiler::v2::UpdateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::devtools::cloudprofiler::v2::UpdateProfileRequest, ::google::devtools::cloudprofiler::v2::Profile>* streamer) {
                       return this->StreamedUpdateProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProfile(::grpc::ServerContext* /*context*/, const ::google::devtools::cloudprofiler::v2::UpdateProfileRequest* /*request*/, ::google::devtools::cloudprofiler::v2::Profile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::devtools::cloudprofiler::v2::UpdateProfileRequest,::google::devtools::cloudprofiler::v2::Profile>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateProfile<WithStreamedUnaryMethod_CreateOfflineProfile<WithStreamedUnaryMethod_UpdateProfile<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateProfile<WithStreamedUnaryMethod_CreateOfflineProfile<WithStreamedUnaryMethod_UpdateProfile<Service > > > StreamedService;
};

}  // namespace v2
}  // namespace cloudprofiler
}  // namespace devtools
}  // namespace google


#endif  // GRPC_google_2fdevtools_2fcloudprofiler_2fv2_2fprofiler_2eproto__INCLUDED
