// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: grafeas/v1/grafeas.proto
// Original file comments:
// Copyright 2019 The Grafeas Authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_grafeas_2fv1_2fgrafeas_2eproto__INCLUDED
#define GRPC_grafeas_2fv1_2fgrafeas_2eproto__INCLUDED

#include "grafeas/v1/grafeas.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace grafeas {
namespace v1 {

// [Grafeas](https://grafeas.io) API.
//
// Retrieves analysis results of Cloud components such as Docker container
// images.
//
// Analysis results are stored as a series of occurrences. An `Occurrence`
// contains information about a specific analysis instance on a resource. An
// occurrence refers to a `Note`. A note contains details describing the
// analysis and is generally stored in a separate project, called a `Provider`.
// Multiple occurrences can refer to the same note.
//
// For example, an SSL vulnerability could affect multiple images. In this case,
// there would be one note for the vulnerability and an occurrence for each
// image with the vulnerability referring to that note.
class Grafeas final {
 public:
  static constexpr char const* service_full_name() {
    return "grafeas.v1.Grafeas";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Gets the specified occurrence.
    virtual ::grpc::Status GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> AsyncGetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(AsyncGetOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> PrepareAsyncGetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(PrepareAsyncGetOccurrenceRaw(context, request, cq));
    }
    // Lists occurrences for the specified project.
    virtual ::grpc::Status ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grafeas::v1::ListOccurrencesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>> AsyncListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>>(AsyncListOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>> PrepareAsyncListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>>(PrepareAsyncListOccurrencesRaw(context, request, cq));
    }
    // Deletes the specified occurrence. For example, use this method to delete an
    // occurrence when the occurrence is no longer applicable for the given
    // resource.
    virtual ::grpc::Status DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteOccurrenceRaw(context, request, cq));
    }
    // Creates a new occurrence.
    virtual ::grpc::Status CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> AsyncCreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(AsyncCreateOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> PrepareAsyncCreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(PrepareAsyncCreateOccurrenceRaw(context, request, cq));
    }
    // Creates new occurrences in batch.
    virtual ::grpc::Status BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grafeas::v1::BatchCreateOccurrencesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>> AsyncBatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>>(AsyncBatchCreateOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>> PrepareAsyncBatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>>(PrepareAsyncBatchCreateOccurrencesRaw(context, request, cq));
    }
    // Updates the specified occurrence.
    virtual ::grpc::Status UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> AsyncUpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(AsyncUpdateOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>> PrepareAsyncUpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>>(PrepareAsyncUpdateOccurrenceRaw(context, request, cq));
    }
    // Gets the note attached to the specified occurrence. Consumer projects can
    // use this method to get a note that belongs to a provider project.
    virtual ::grpc::Status GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grafeas::v1::Note* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> AsyncGetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(AsyncGetOccurrenceNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> PrepareAsyncGetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(PrepareAsyncGetOccurrenceNoteRaw(context, request, cq));
    }
    // Gets the specified note.
    virtual ::grpc::Status GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grafeas::v1::Note* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> AsyncGetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(AsyncGetNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> PrepareAsyncGetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(PrepareAsyncGetNoteRaw(context, request, cq));
    }
    // Lists notes for the specified project.
    virtual ::grpc::Status ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grafeas::v1::ListNotesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>> AsyncListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>>(AsyncListNotesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>> PrepareAsyncListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>>(PrepareAsyncListNotesRaw(context, request, cq));
    }
    // Deletes the specified note.
    virtual ::grpc::Status DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteNoteRaw(context, request, cq));
    }
    // Creates a new note.
    virtual ::grpc::Status CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grafeas::v1::Note* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> AsyncCreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(AsyncCreateNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> PrepareAsyncCreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(PrepareAsyncCreateNoteRaw(context, request, cq));
    }
    // Creates new notes in batch.
    virtual ::grpc::Status BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grafeas::v1::BatchCreateNotesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>> AsyncBatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>>(AsyncBatchCreateNotesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>> PrepareAsyncBatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>>(PrepareAsyncBatchCreateNotesRaw(context, request, cq));
    }
    // Updates the specified note.
    virtual ::grpc::Status UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grafeas::v1::Note* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> AsyncUpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(AsyncUpdateNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>> PrepareAsyncUpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>>(PrepareAsyncUpdateNoteRaw(context, request, cq));
    }
    // Lists occurrences referencing the specified note. Provider projects can use
    // this method to get all occurrences across consumer projects referencing the
    // specified note.
    virtual ::grpc::Status ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grafeas::v1::ListNoteOccurrencesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>> AsyncListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>>(AsyncListNoteOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>> PrepareAsyncListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>>(PrepareAsyncListNoteOccurrencesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Gets the specified occurrence.
      virtual void GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists occurrences for the specified project.
      virtual void ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified occurrence. For example, use this method to delete an
      // occurrence when the occurrence is no longer applicable for the given
      // resource.
      virtual void DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new occurrence.
      virtual void CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates new occurrences in batch.
      virtual void BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified occurrence.
      virtual void UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the note attached to the specified occurrence. Consumer projects can
      // use this method to get a note that belongs to a provider project.
      virtual void GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the specified note.
      virtual void GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists notes for the specified project.
      virtual void ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified note.
      virtual void DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new note.
      virtual void CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates new notes in batch.
      virtual void BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified note.
      virtual void UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists occurrences referencing the specified note. Provider projects can use
      // this method to get all occurrences across consumer projects referencing the
      // specified note.
      virtual void ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* AsyncGetOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* PrepareAsyncGetOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>* AsyncListOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListOccurrencesResponse>* PrepareAsyncListOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* AsyncCreateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* PrepareAsyncCreateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>* AsyncBatchCreateOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateOccurrencesResponse>* PrepareAsyncBatchCreateOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* AsyncUpdateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Occurrence>* PrepareAsyncUpdateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* AsyncGetOccurrenceNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* PrepareAsyncGetOccurrenceNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* AsyncGetNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* PrepareAsyncGetNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>* AsyncListNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNotesResponse>* PrepareAsyncListNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* AsyncCreateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* PrepareAsyncCreateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>* AsyncBatchCreateNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::BatchCreateNotesResponse>* PrepareAsyncBatchCreateNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* AsyncUpdateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::Note>* PrepareAsyncUpdateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>* AsyncListNoteOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::grafeas::v1::ListNoteOccurrencesResponse>* PrepareAsyncListNoteOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> AsyncGetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(AsyncGetOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> PrepareAsyncGetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(PrepareAsyncGetOccurrenceRaw(context, request, cq));
    }
    ::grpc::Status ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grafeas::v1::ListOccurrencesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>> AsyncListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>>(AsyncListOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>> PrepareAsyncListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>>(PrepareAsyncListOccurrencesRaw(context, request, cq));
    }
    ::grpc::Status DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteOccurrenceRaw(context, request, cq));
    }
    ::grpc::Status CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> AsyncCreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(AsyncCreateOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> PrepareAsyncCreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(PrepareAsyncCreateOccurrenceRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grafeas::v1::BatchCreateOccurrencesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>> AsyncBatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>>(AsyncBatchCreateOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>> PrepareAsyncBatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>>(PrepareAsyncBatchCreateOccurrencesRaw(context, request, cq));
    }
    ::grpc::Status UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grafeas::v1::Occurrence* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> AsyncUpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(AsyncUpdateOccurrenceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>> PrepareAsyncUpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>>(PrepareAsyncUpdateOccurrenceRaw(context, request, cq));
    }
    ::grpc::Status GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grafeas::v1::Note* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> AsyncGetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(AsyncGetOccurrenceNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> PrepareAsyncGetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(PrepareAsyncGetOccurrenceNoteRaw(context, request, cq));
    }
    ::grpc::Status GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grafeas::v1::Note* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> AsyncGetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(AsyncGetNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> PrepareAsyncGetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(PrepareAsyncGetNoteRaw(context, request, cq));
    }
    ::grpc::Status ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grafeas::v1::ListNotesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>> AsyncListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>>(AsyncListNotesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>> PrepareAsyncListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>>(PrepareAsyncListNotesRaw(context, request, cq));
    }
    ::grpc::Status DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteNoteRaw(context, request, cq));
    }
    ::grpc::Status CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grafeas::v1::Note* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> AsyncCreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(AsyncCreateNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> PrepareAsyncCreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(PrepareAsyncCreateNoteRaw(context, request, cq));
    }
    ::grpc::Status BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grafeas::v1::BatchCreateNotesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>> AsyncBatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>>(AsyncBatchCreateNotesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>> PrepareAsyncBatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>>(PrepareAsyncBatchCreateNotesRaw(context, request, cq));
    }
    ::grpc::Status UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grafeas::v1::Note* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> AsyncUpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(AsyncUpdateNoteRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>> PrepareAsyncUpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>>(PrepareAsyncUpdateNoteRaw(context, request, cq));
    }
    ::grpc::Status ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grafeas::v1::ListNoteOccurrencesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>> AsyncListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>>(AsyncListNoteOccurrencesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>> PrepareAsyncListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>>(PrepareAsyncListNoteOccurrencesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) override;
      void GetOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) override;
      void CreateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, std::function<void(::grpc::Status)>) override;
      void UpdateOccurrence(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) override;
      void GetOccurrenceNote(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) override;
      void GetNote(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNotes(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteNote(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) override;
      void CreateNote(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response, std::function<void(::grpc::Status)>) override;
      void BatchCreateNotes(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response, std::function<void(::grpc::Status)>) override;
      void UpdateNote(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNoteOccurrences(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* AsyncGetOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* PrepareAsyncGetOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>* AsyncListOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListOccurrencesResponse>* PrepareAsyncListOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* AsyncCreateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* PrepareAsyncCreateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>* AsyncBatchCreateOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateOccurrencesResponse>* PrepareAsyncBatchCreateOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* AsyncUpdateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Occurrence>* PrepareAsyncUpdateOccurrenceRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateOccurrenceRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* AsyncGetOccurrenceNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* PrepareAsyncGetOccurrenceNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* AsyncGetNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* PrepareAsyncGetNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::GetNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>* AsyncListNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNotesResponse>* PrepareAsyncListNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNotesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::DeleteNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* AsyncCreateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* PrepareAsyncCreateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::CreateNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>* AsyncBatchCreateNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::BatchCreateNotesResponse>* PrepareAsyncBatchCreateNotesRaw(::grpc::ClientContext* context, const ::grafeas::v1::BatchCreateNotesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* AsyncUpdateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::Note>* PrepareAsyncUpdateNoteRaw(::grpc::ClientContext* context, const ::grafeas::v1::UpdateNoteRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>* AsyncListNoteOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::grafeas::v1::ListNoteOccurrencesResponse>* PrepareAsyncListNoteOccurrencesRaw(::grpc::ClientContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_GetOccurrence_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOccurrences_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteOccurrence_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateOccurrence_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateOccurrences_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateOccurrence_;
    const ::grpc::internal::RpcMethod rpcmethod_GetOccurrenceNote_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNote_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNotes_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNote_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNote_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchCreateNotes_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateNote_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNoteOccurrences_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Gets the specified occurrence.
    virtual ::grpc::Status GetOccurrence(::grpc::ServerContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response);
    // Lists occurrences for the specified project.
    virtual ::grpc::Status ListOccurrences(::grpc::ServerContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response);
    // Deletes the specified occurrence. For example, use this method to delete an
    // occurrence when the occurrence is no longer applicable for the given
    // resource.
    virtual ::grpc::Status DeleteOccurrence(::grpc::ServerContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response);
    // Creates a new occurrence.
    virtual ::grpc::Status CreateOccurrence(::grpc::ServerContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response);
    // Creates new occurrences in batch.
    virtual ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response);
    // Updates the specified occurrence.
    virtual ::grpc::Status UpdateOccurrence(::grpc::ServerContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response);
    // Gets the note attached to the specified occurrence. Consumer projects can
    // use this method to get a note that belongs to a provider project.
    virtual ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response);
    // Gets the specified note.
    virtual ::grpc::Status GetNote(::grpc::ServerContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response);
    // Lists notes for the specified project.
    virtual ::grpc::Status ListNotes(::grpc::ServerContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response);
    // Deletes the specified note.
    virtual ::grpc::Status DeleteNote(::grpc::ServerContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response);
    // Creates a new note.
    virtual ::grpc::Status CreateNote(::grpc::ServerContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response);
    // Creates new notes in batch.
    virtual ::grpc::Status BatchCreateNotes(::grpc::ServerContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response);
    // Updates the specified note.
    virtual ::grpc::Status UpdateNote(::grpc::ServerContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response);
    // Lists occurrences referencing the specified note. Provider projects can use
    // this method to get all occurrences across consumer projects referencing the
    // specified note.
    virtual ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOccurrence(::grpc::ServerContext* context, ::grafeas::v1::GetOccurrenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Occurrence>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOccurrences(::grpc::ServerContext* context, ::grafeas::v1::ListOccurrencesRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::ListOccurrencesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOccurrence(::grpc::ServerContext* context, ::grafeas::v1::DeleteOccurrenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOccurrence(::grpc::ServerContext* context, ::grafeas::v1::CreateOccurrenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Occurrence>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateOccurrences(::grpc::ServerContext* context, ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::BatchCreateOccurrencesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateOccurrence(::grpc::ServerContext* context, ::grafeas::v1::UpdateOccurrenceRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Occurrence>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOccurrenceNote(::grpc::ServerContext* context, ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Note>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNote() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNote(::grpc::ServerContext* context, ::grafeas::v1::GetNoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Note>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNotes() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNotes(::grpc::ServerContext* context, ::grafeas::v1::ListNotesRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::ListNotesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNote() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNote(::grpc::ServerContext* context, ::grafeas::v1::DeleteNoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNote() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNote(::grpc::ServerContext* context, ::grafeas::v1::CreateNoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Note>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateNotes(::grpc::ServerContext* context, ::grafeas::v1::BatchCreateNotesRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::BatchCreateNotesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateNote() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNote(::grpc::ServerContext* context, ::grafeas::v1::UpdateNoteRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::Note>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNoteOccurrences(::grpc::ServerContext* context, ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grpc::ServerAsyncResponseWriter< ::grafeas::v1::ListNoteOccurrencesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_GetOccurrence<WithAsyncMethod_ListOccurrences<WithAsyncMethod_DeleteOccurrence<WithAsyncMethod_CreateOccurrence<WithAsyncMethod_BatchCreateOccurrences<WithAsyncMethod_UpdateOccurrence<WithAsyncMethod_GetOccurrenceNote<WithAsyncMethod_GetNote<WithAsyncMethod_ListNotes<WithAsyncMethod_DeleteNote<WithAsyncMethod_CreateNote<WithAsyncMethod_BatchCreateNotes<WithAsyncMethod_UpdateNote<WithAsyncMethod_ListNoteOccurrences<Service > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::GetOccurrenceRequest* request, ::grafeas::v1::Occurrence* response) { return this->GetOccurrence(context, request, response); }));}
    void SetMessageAllocatorFor_GetOccurrence(
        ::grpc::MessageAllocator< ::grafeas::v1::GetOccurrenceRequest, ::grafeas::v1::Occurrence>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetOccurrenceRequest, ::grafeas::v1::Occurrence>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListOccurrencesRequest, ::grafeas::v1::ListOccurrencesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::ListOccurrencesRequest* request, ::grafeas::v1::ListOccurrencesResponse* response) { return this->ListOccurrences(context, request, response); }));}
    void SetMessageAllocatorFor_ListOccurrences(
        ::grpc::MessageAllocator< ::grafeas::v1::ListOccurrencesRequest, ::grafeas::v1::ListOccurrencesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListOccurrencesRequest, ::grafeas::v1::ListOccurrencesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::DeleteOccurrenceRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::DeleteOccurrenceRequest* request, ::google::protobuf::Empty* response) { return this->DeleteOccurrence(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteOccurrence(
        ::grpc::MessageAllocator< ::grafeas::v1::DeleteOccurrenceRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::DeleteOccurrenceRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::CreateOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::CreateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response) { return this->CreateOccurrence(context, request, response); }));}
    void SetMessageAllocatorFor_CreateOccurrence(
        ::grpc::MessageAllocator< ::grafeas::v1::CreateOccurrenceRequest, ::grafeas::v1::Occurrence>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::CreateOccurrenceRequest, ::grafeas::v1::Occurrence>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::BatchCreateOccurrencesRequest, ::grafeas::v1::BatchCreateOccurrencesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::BatchCreateOccurrencesRequest* request, ::grafeas::v1::BatchCreateOccurrencesResponse* response) { return this->BatchCreateOccurrences(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCreateOccurrences(
        ::grpc::MessageAllocator< ::grafeas::v1::BatchCreateOccurrencesRequest, ::grafeas::v1::BatchCreateOccurrencesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::BatchCreateOccurrencesRequest, ::grafeas::v1::BatchCreateOccurrencesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::UpdateOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::UpdateOccurrenceRequest* request, ::grafeas::v1::Occurrence* response) { return this->UpdateOccurrence(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateOccurrence(
        ::grpc::MessageAllocator< ::grafeas::v1::UpdateOccurrenceRequest, ::grafeas::v1::Occurrence>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::UpdateOccurrenceRequest, ::grafeas::v1::Occurrence>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetOccurrenceNoteRequest, ::grafeas::v1::Note>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::GetOccurrenceNoteRequest* request, ::grafeas::v1::Note* response) { return this->GetOccurrenceNote(context, request, response); }));}
    void SetMessageAllocatorFor_GetOccurrenceNote(
        ::grpc::MessageAllocator< ::grafeas::v1::GetOccurrenceNoteRequest, ::grafeas::v1::Note>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetOccurrenceNoteRequest, ::grafeas::v1::Note>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOccurrenceNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNote() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetNoteRequest, ::grafeas::v1::Note>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::GetNoteRequest* request, ::grafeas::v1::Note* response) { return this->GetNote(context, request, response); }));}
    void SetMessageAllocatorFor_GetNote(
        ::grpc::MessageAllocator< ::grafeas::v1::GetNoteRequest, ::grafeas::v1::Note>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::GetNoteRequest, ::grafeas::v1::Note>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNotes() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListNotesRequest, ::grafeas::v1::ListNotesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::ListNotesRequest* request, ::grafeas::v1::ListNotesResponse* response) { return this->ListNotes(context, request, response); }));}
    void SetMessageAllocatorFor_ListNotes(
        ::grpc::MessageAllocator< ::grafeas::v1::ListNotesRequest, ::grafeas::v1::ListNotesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListNotesRequest, ::grafeas::v1::ListNotesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNotes(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNote() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::DeleteNoteRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::DeleteNoteRequest* request, ::google::protobuf::Empty* response) { return this->DeleteNote(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNote(
        ::grpc::MessageAllocator< ::grafeas::v1::DeleteNoteRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::DeleteNoteRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNote() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::CreateNoteRequest, ::grafeas::v1::Note>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::CreateNoteRequest* request, ::grafeas::v1::Note* response) { return this->CreateNote(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNote(
        ::grpc::MessageAllocator< ::grafeas::v1::CreateNoteRequest, ::grafeas::v1::Note>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::CreateNoteRequest, ::grafeas::v1::Note>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::BatchCreateNotesRequest, ::grafeas::v1::BatchCreateNotesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::BatchCreateNotesRequest* request, ::grafeas::v1::BatchCreateNotesResponse* response) { return this->BatchCreateNotes(context, request, response); }));}
    void SetMessageAllocatorFor_BatchCreateNotes(
        ::grpc::MessageAllocator< ::grafeas::v1::BatchCreateNotesRequest, ::grafeas::v1::BatchCreateNotesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::BatchCreateNotesRequest, ::grafeas::v1::BatchCreateNotesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateNotes(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateNote() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::UpdateNoteRequest, ::grafeas::v1::Note>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::UpdateNoteRequest* request, ::grafeas::v1::Note* response) { return this->UpdateNote(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateNote(
        ::grpc::MessageAllocator< ::grafeas::v1::UpdateNoteRequest, ::grafeas::v1::Note>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::UpdateNoteRequest, ::grafeas::v1::Note>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListNoteOccurrencesRequest, ::grafeas::v1::ListNoteOccurrencesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grafeas::v1::ListNoteOccurrencesRequest* request, ::grafeas::v1::ListNoteOccurrencesResponse* response) { return this->ListNoteOccurrences(context, request, response); }));}
    void SetMessageAllocatorFor_ListNoteOccurrences(
        ::grpc::MessageAllocator< ::grafeas::v1::ListNoteOccurrencesRequest, ::grafeas::v1::ListNoteOccurrencesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::grafeas::v1::ListNoteOccurrencesRequest, ::grafeas::v1::ListNoteOccurrencesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNoteOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_GetOccurrence<WithCallbackMethod_ListOccurrences<WithCallbackMethod_DeleteOccurrence<WithCallbackMethod_CreateOccurrence<WithCallbackMethod_BatchCreateOccurrences<WithCallbackMethod_UpdateOccurrence<WithCallbackMethod_GetOccurrenceNote<WithCallbackMethod_GetNote<WithCallbackMethod_ListNotes<WithCallbackMethod_DeleteNote<WithCallbackMethod_CreateNote<WithCallbackMethod_BatchCreateNotes<WithCallbackMethod_UpdateNote<WithCallbackMethod_ListNoteOccurrences<Service > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNote() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNotes() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNote() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNote() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateNote() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOccurrence(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOccurrences(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteOccurrence(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateOccurrence(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateOccurrences(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateOccurrence(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetOccurrenceNote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNote() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNotes() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNotes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNote() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNote() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchCreateNotes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateNote() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNote(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNoteOccurrences(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOccurrence(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOccurrences(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteOccurrence(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateOccurrence(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCreateOccurrences(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateOccurrence(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateOccurrence(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetOccurrenceNote(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetOccurrenceNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNote() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNote(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNotes() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNotes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNotes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNote() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNote(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNote() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNote(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchCreateNotes(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchCreateNotes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateNote() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateNote(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNote(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNoteOccurrences(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNoteOccurrences(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOccurrence() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::GetOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::GetOccurrenceRequest, ::grafeas::v1::Occurrence>* streamer) {
                       return this->StreamedGetOccurrence(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOccurrence(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::GetOccurrenceRequest,::grafeas::v1::Occurrence>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOccurrences() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::ListOccurrencesRequest, ::grafeas::v1::ListOccurrencesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::ListOccurrencesRequest, ::grafeas::v1::ListOccurrencesResponse>* streamer) {
                       return this->StreamedListOccurrences(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListOccurrencesRequest* /*request*/, ::grafeas::v1::ListOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOccurrences(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::ListOccurrencesRequest,::grafeas::v1::ListOccurrencesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteOccurrence() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::DeleteOccurrenceRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::DeleteOccurrenceRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteOccurrence(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteOccurrenceRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteOccurrence(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::DeleteOccurrenceRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateOccurrence() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::CreateOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::CreateOccurrenceRequest, ::grafeas::v1::Occurrence>* streamer) {
                       return this->StreamedCreateOccurrence(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateOccurrence(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::CreateOccurrenceRequest,::grafeas::v1::Occurrence>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateOccurrences() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::BatchCreateOccurrencesRequest, ::grafeas::v1::BatchCreateOccurrencesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::BatchCreateOccurrencesRequest, ::grafeas::v1::BatchCreateOccurrencesResponse>* streamer) {
                       return this->StreamedBatchCreateOccurrences(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCreateOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateOccurrencesRequest* /*request*/, ::grafeas::v1::BatchCreateOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateOccurrences(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::BatchCreateOccurrencesRequest,::grafeas::v1::BatchCreateOccurrencesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateOccurrence : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateOccurrence() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::UpdateOccurrenceRequest, ::grafeas::v1::Occurrence>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::UpdateOccurrenceRequest, ::grafeas::v1::Occurrence>* streamer) {
                       return this->StreamedUpdateOccurrence(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateOccurrence() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateOccurrence(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateOccurrenceRequest* /*request*/, ::grafeas::v1::Occurrence* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateOccurrence(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::UpdateOccurrenceRequest,::grafeas::v1::Occurrence>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetOccurrenceNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetOccurrenceNote() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::GetOccurrenceNoteRequest, ::grafeas::v1::Note>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::GetOccurrenceNoteRequest, ::grafeas::v1::Note>* streamer) {
                       return this->StreamedGetOccurrenceNote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetOccurrenceNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetOccurrenceNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetOccurrenceNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetOccurrenceNote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::GetOccurrenceNoteRequest,::grafeas::v1::Note>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNote() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::GetNoteRequest, ::grafeas::v1::Note>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::GetNoteRequest, ::grafeas::v1::Note>* streamer) {
                       return this->StreamedGetNote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::GetNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::GetNoteRequest,::grafeas::v1::Note>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNotes() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::ListNotesRequest, ::grafeas::v1::ListNotesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::ListNotesRequest, ::grafeas::v1::ListNotesResponse>* streamer) {
                       return this->StreamedListNotes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNotesRequest* /*request*/, ::grafeas::v1::ListNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNotes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::ListNotesRequest,::grafeas::v1::ListNotesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNote() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::DeleteNoteRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::DeleteNoteRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteNote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::DeleteNoteRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::DeleteNoteRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNote() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::CreateNoteRequest, ::grafeas::v1::Note>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::CreateNoteRequest, ::grafeas::v1::Note>* streamer) {
                       return this->StreamedCreateNote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::CreateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::CreateNoteRequest,::grafeas::v1::Note>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchCreateNotes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchCreateNotes() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::BatchCreateNotesRequest, ::grafeas::v1::BatchCreateNotesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::BatchCreateNotesRequest, ::grafeas::v1::BatchCreateNotesResponse>* streamer) {
                       return this->StreamedBatchCreateNotes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchCreateNotes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchCreateNotes(::grpc::ServerContext* /*context*/, const ::grafeas::v1::BatchCreateNotesRequest* /*request*/, ::grafeas::v1::BatchCreateNotesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchCreateNotes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::BatchCreateNotesRequest,::grafeas::v1::BatchCreateNotesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateNote : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateNote() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::UpdateNoteRequest, ::grafeas::v1::Note>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::UpdateNoteRequest, ::grafeas::v1::Note>* streamer) {
                       return this->StreamedUpdateNote(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateNote() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateNote(::grpc::ServerContext* /*context*/, const ::grafeas::v1::UpdateNoteRequest* /*request*/, ::grafeas::v1::Note* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateNote(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::UpdateNoteRequest,::grafeas::v1::Note>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNoteOccurrences : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNoteOccurrences() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::grafeas::v1::ListNoteOccurrencesRequest, ::grafeas::v1::ListNoteOccurrencesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::grafeas::v1::ListNoteOccurrencesRequest, ::grafeas::v1::ListNoteOccurrencesResponse>* streamer) {
                       return this->StreamedListNoteOccurrences(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNoteOccurrences() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNoteOccurrences(::grpc::ServerContext* /*context*/, const ::grafeas::v1::ListNoteOccurrencesRequest* /*request*/, ::grafeas::v1::ListNoteOccurrencesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNoteOccurrences(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::grafeas::v1::ListNoteOccurrencesRequest,::grafeas::v1::ListNoteOccurrencesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_GetOccurrence<WithStreamedUnaryMethod_ListOccurrences<WithStreamedUnaryMethod_DeleteOccurrence<WithStreamedUnaryMethod_CreateOccurrence<WithStreamedUnaryMethod_BatchCreateOccurrences<WithStreamedUnaryMethod_UpdateOccurrence<WithStreamedUnaryMethod_GetOccurrenceNote<WithStreamedUnaryMethod_GetNote<WithStreamedUnaryMethod_ListNotes<WithStreamedUnaryMethod_DeleteNote<WithStreamedUnaryMethod_CreateNote<WithStreamedUnaryMethod_BatchCreateNotes<WithStreamedUnaryMethod_UpdateNote<WithStreamedUnaryMethod_ListNoteOccurrences<Service > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_GetOccurrence<WithStreamedUnaryMethod_ListOccurrences<WithStreamedUnaryMethod_DeleteOccurrence<WithStreamedUnaryMethod_CreateOccurrence<WithStreamedUnaryMethod_BatchCreateOccurrences<WithStreamedUnaryMethod_UpdateOccurrence<WithStreamedUnaryMethod_GetOccurrenceNote<WithStreamedUnaryMethod_GetNote<WithStreamedUnaryMethod_ListNotes<WithStreamedUnaryMethod_DeleteNote<WithStreamedUnaryMethod_CreateNote<WithStreamedUnaryMethod_BatchCreateNotes<WithStreamedUnaryMethod_UpdateNote<WithStreamedUnaryMethod_ListNoteOccurrences<Service > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace grafeas


#endif  // GRPC_grafeas_2fv1_2fgrafeas_2eproto__INCLUDED
