// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/datacatalog/v1/datacatalog.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdatacatalog_2fv1_2fdatacatalog_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdatacatalog_2fv1_2fdatacatalog_2eproto__INCLUDED

#include "google/cloud/datacatalog/v1/datacatalog.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace datacatalog {
namespace v1 {

// Data Catalog API service allows you to discover, understand, and manage
// your data.
class DataCatalog final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.datacatalog.v1.DataCatalog";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Searches Data Catalog for multiple resources like entries and tags that
    // match a query.
    //
    // This is a [Custom Method]
    // (https://cloud.google.com/apis/design/custom_methods) that doesn't return
    // all information on a resource, only its ID and high level fields. To get
    // more information, you can subsequently call specific get methods.
    //
    // Note: Data Catalog search queries don't guarantee full recall. Results
    // that match your query might not be returned, even in subsequent
    // result pages. Additionally, returned (and not returned) results can vary
    // if you repeat search queries.
    //
    // For more information, see [Data Catalog search syntax]
    // (https://cloud.google.com/data-catalog/docs/how-to/search-reference).
    virtual ::grpc::Status SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>> AsyncSearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>>(AsyncSearchCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>> PrepareAsyncSearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>>(PrepareAsyncSearchCatalogRaw(context, request, cq));
    }
    // Creates an entry group.
    //
    // An entry group contains logically related entries together with [Cloud
    // Identity and Access Management](/data-catalog/docs/concepts/iam) policies.
    // These policies specify users who can create, edit, and view entries
    // within entry groups.
    //
    // Data Catalog automatically creates entry groups with names that start with
    // the `@` symbol for the following resources:
    //
    // * BigQuery entries (`@bigquery`)
    // * Pub/Sub topics (`@pubsub`)
    // * Dataproc Metastore services (`@dataproc_metastore_{SERVICE_NAME_HASH}`)
    //
    // You can create your own entry groups for Cloud Storage fileset entries
    // and custom entries together with the corresponding IAM policies.
    // User-created entry groups can't contain the `@` symbol, it is reserved
    // for automatically created groups.
    //
    // Entry groups, like entries, can be searched.
    //
    // A maximum of 10,000 entry groups may be created per organization across all
    // locations.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncCreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncCreateEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncCreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncCreateEntryGroupRaw(context, request, cq));
    }
    // Gets an entry group.
    virtual ::grpc::Status GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncGetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncGetEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncGetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncGetEntryGroupRaw(context, request, cq));
    }
    // Updates an entry group.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `entry_group.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncUpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncUpdateEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncUpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncUpdateEntryGroupRaw(context, request, cq));
    }
    // Deletes an entry group.
    //
    // You must enable the Data Catalog API in the project
    // identified by the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntryGroupRaw(context, request, cq));
    }
    // Lists entry groups.
    virtual ::grpc::Status ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>> AsyncListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>>(AsyncListEntryGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>> PrepareAsyncListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>>(PrepareAsyncListEntryGroupsRaw(context, request, cq));
    }
    // Creates an entry.
    //
    // You can create entries only with 'FILESET', 'CLUSTER', 'DATA_STREAM',
    // or custom types. Data Catalog automatically creates entries with other
    // types during metadata ingestion from integrated systems.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    //
    // An entry group can have a maximum of 100,000 entries.
    virtual ::grpc::Status CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> AsyncCreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(AsyncCreateEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncCreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncCreateEntryRaw(context, request, cq));
    }
    // Updates an existing entry.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `entry.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> AsyncUpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(AsyncUpdateEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncUpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncUpdateEntryRaw(context, request, cq));
    }
    // Deletes an existing entry.
    //
    // You can delete only the entries created by the
    // [CreateEntry][google.cloud.datacatalog.v1.DataCatalog.CreateEntry]
    // method.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntryRaw(context, request, cq));
    }
    // Gets an entry.
    virtual ::grpc::Status GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> AsyncGetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(AsyncGetEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncGetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncGetEntryRaw(context, request, cq));
    }
    // Gets an entry by its target resource name.
    //
    // The resource name comes from the source Google Cloud Platform service.
    virtual ::grpc::Status LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> AsyncLookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(AsyncLookupEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncLookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncLookupEntryRaw(context, request, cq));
    }
    // Lists entries.
    //
    // Note: Currently, this method can list only custom entries.
    // To get a list of both custom and automatically created entries, use
    // [SearchCatalog][google.cloud.datacatalog.v1.DataCatalog.SearchCatalog].
    virtual ::grpc::Status ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>> AsyncListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>>(AsyncListEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>> PrepareAsyncListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>>(PrepareAsyncListEntriesRaw(context, request, cq));
    }
    // Modifies entry overview, part of the business context of an
    // [Entry][google.cloud.datacatalog.v1.Entry].
    //
    // To call this method, you must have the `datacatalog.entries.updateOverview`
    // IAM permission on the corresponding project.
    virtual ::grpc::Status ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::google::cloud::datacatalog::v1::EntryOverview* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>> AsyncModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>>(AsyncModifyEntryOverviewRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>> PrepareAsyncModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>>(PrepareAsyncModifyEntryOverviewRaw(context, request, cq));
    }
    // Modifies contacts, part of the business context of an
    // [Entry][google.cloud.datacatalog.v1.Entry].
    //
    // To call this method, you must have the `datacatalog.entries.updateContacts`
    // IAM permission on the corresponding project.
    virtual ::grpc::Status ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::google::cloud::datacatalog::v1::Contacts* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>> AsyncModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>>(AsyncModifyEntryContactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>> PrepareAsyncModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>>(PrepareAsyncModifyEntryContactsRaw(context, request, cq));
    }
    // Creates a tag template.
    //
    // You must enable the Data Catalog API in the project identified by the
    // `parent` parameter.
    // For more information, see [Data Catalog resource project]
    // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncCreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncCreateTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncCreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncCreateTagTemplateRaw(context, request, cq));
    }
    // Gets a tag template.
    virtual ::grpc::Status GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncGetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncGetTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncGetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncGetTagTemplateRaw(context, request, cq));
    }
    // Updates a tag template.
    //
    // You can't update template fields with this method. These fields are
    // separate resources with their own create, update, and delete methods.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `tag_template.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncUpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncUpdateTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncUpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncUpdateTagTemplateRaw(context, request, cq));
    }
    // Deletes a tag template and all tags that use it.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagTemplateRaw(context, request, cq));
    }
    // Creates a field in a tag template.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncCreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncCreateTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncCreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncCreateTagTemplateFieldRaw(context, request, cq));
    }
    // Updates a field in a tag template.
    //
    // You can't update the field type with this method.
    //
    // You must enable the Data Catalog API in the project
    // identified by the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncUpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncUpdateTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncUpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncUpdateTagTemplateFieldRaw(context, request, cq));
    }
    // Renames a field in a tag template.
    //
    // You must enable the Data Catalog API in the project identified by the
    // `name` parameter. For more information, see [Data Catalog resource project]
    // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncRenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncRenameTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncRenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncRenameTagTemplateFieldRaw(context, request, cq));
    }
    // Renames an enum value in a tag template.
    //
    // Within a single enum field, enum values must be unique.
    virtual ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncRenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncRenameTagTemplateFieldEnumValueRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncRenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncRenameTagTemplateFieldEnumValueRaw(context, request, cq));
    }
    // Deletes a field in a tag template and all uses of this field from the tags
    // based on this template.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagTemplateFieldRaw(context, request, cq));
    }
    // Creates a tag and assigns it to:
    //
    // * An [Entry][google.cloud.datacatalog.v1.Entry] if the method name is
    //   `projects.locations.entryGroups.entries.tags.create`.
    // * Or [EntryGroup][google.cloud.datacatalog.v1.EntryGroup]if the method
    //   name is `projects.locations.entryGroups.tags.create`.
    //
    // Note: The project identified by the `parent` parameter for the [tag]
    // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.entryGroups.entries.tags/create#path-parameters)
    // and the [tag template]
    // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.tagTemplates/create#path-parameters)
    // used to create the tag must be in the same organization.
    virtual ::grpc::Status CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::google::cloud::datacatalog::v1::Tag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>> AsyncCreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>>(AsyncCreateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>> PrepareAsyncCreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>>(PrepareAsyncCreateTagRaw(context, request, cq));
    }
    // Updates an existing tag.
    virtual ::grpc::Status UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::google::cloud::datacatalog::v1::Tag* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>> AsyncUpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>>(AsyncUpdateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>> PrepareAsyncUpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>>(PrepareAsyncUpdateTagRaw(context, request, cq));
    }
    // Deletes a tag.
    virtual ::grpc::Status DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagRaw(context, request, cq));
    }
    // Lists tags assigned to an [Entry][google.cloud.datacatalog.v1.Entry].
    // The [columns][google.cloud.datacatalog.v1.Tag.column] in the response are
    // lowercased.
    virtual ::grpc::Status ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::google::cloud::datacatalog::v1::ListTagsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>> AsyncListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>>(AsyncListTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>> PrepareAsyncListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>>(PrepareAsyncListTagsRaw(context, request, cq));
    }
    // `ReconcileTags` creates or updates a list of tags on the entry.
    // If the
    // [ReconcileTagsRequest.force_delete_missing][google.cloud.datacatalog.v1.ReconcileTagsRequest.force_delete_missing]
    // parameter is set, the operation deletes tags not included in the input tag
    // list.
    //
    // `ReconcileTags` returns a [long-running operation]
    // [google.longrunning.Operation] resource that can be queried with
    // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
    // to return [ReconcileTagsMetadata]
    // [google.cloud.datacatalog.v1.ReconcileTagsMetadata] and
    // a [ReconcileTagsResponse]
    // [google.cloud.datacatalog.v1.ReconcileTagsResponse] message.
    virtual ::grpc::Status ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncReconcileTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncReconcileTagsRaw(context, request, cq));
    }
    // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as starred by
    // the current user. Starring information is private to each user.
    virtual ::grpc::Status StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::google::cloud::datacatalog::v1::StarEntryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>> AsyncStarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>>(AsyncStarEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>> PrepareAsyncStarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>>(PrepareAsyncStarEntryRaw(context, request, cq));
    }
    // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as NOT starred by
    // the current user. Starring information is private to each user.
    virtual ::grpc::Status UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>> AsyncUnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>>(AsyncUnstarEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>> PrepareAsyncUnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>>(PrepareAsyncUnstarEntryRaw(context, request, cq));
    }
    // Sets an access control policy for a resource. Replaces any existing
    // policy.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method sets policies only within Data Catalog and can't be
    // used to manage policies in BigQuery, Pub/Sub, Dataproc Metastore, and any
    // external Google Cloud Platform resources synced with the Data Catalog.
    //
    // To call this method, you must have the following Google IAM permissions:
    //
    // - `datacatalog.tagTemplates.setIamPolicy` to set policies on tag
    //   templates.
    // - `datacatalog.entryGroups.setIamPolicy` to set policies on entry groups.
    virtual ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    // Gets the access control policy for a resource.
    //
    // May return:
    //
    // * A`NOT_FOUND` error if the resource doesn't exist or you don't have the
    //   permission to view it.
    // * An empty policy if the resource exists but doesn't have a set policy.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method doesn't get policies from Google Cloud Platform
    // resources ingested into Data Catalog.
    //
    // To call this method, you must have the following Google IAM permissions:
    //
    // - `datacatalog.tagTemplates.getIamPolicy` to get policies on tag
    //   templates.
    // - `datacatalog.entryGroups.getIamPolicy` to get policies on entry groups.
    virtual ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    // Gets your permissions on a resource.
    //
    // Returns an empty set of permissions if the resource doesn't exist.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method gets policies only within Data Catalog and can't be
    // used to get policies from BigQuery, Pub/Sub, Dataproc Metastore, and any
    // external Google Cloud Platform resources ingested into Data Catalog.
    //
    // No Google IAM permissions are required to call this method.
    virtual ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    // Imports entries from a source, such as data previously dumped into a
    // Cloud Storage bucket, into Data Catalog. Import of entries
    // is a sync operation that reconciles the state of the third-party system
    // with the Data Catalog.
    //
    // `ImportEntries` accepts source data snapshots of a third-party system.
    // Snapshot should be delivered as a .wire or base65-encoded .txt file
    // containing a sequence of Protocol Buffer messages of
    // [DumpItem][google.cloud.datacatalog.v1.DumpItem] type.
    //
    // `ImportEntries` returns a [long-running operation]
    // [google.longrunning.Operation] resource that can be queried with
    // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
    // to return
    // [ImportEntriesMetadata][google.cloud.datacatalog.v1.ImportEntriesMetadata]
    // and an
    // [ImportEntriesResponse][google.cloud.datacatalog.v1.ImportEntriesResponse]
    // message.
    virtual ::grpc::Status ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportEntriesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Searches Data Catalog for multiple resources like entries and tags that
      // match a query.
      //
      // This is a [Custom Method]
      // (https://cloud.google.com/apis/design/custom_methods) that doesn't return
      // all information on a resource, only its ID and high level fields. To get
      // more information, you can subsequently call specific get methods.
      //
      // Note: Data Catalog search queries don't guarantee full recall. Results
      // that match your query might not be returned, even in subsequent
      // result pages. Additionally, returned (and not returned) results can vary
      // if you repeat search queries.
      //
      // For more information, see [Data Catalog search syntax]
      // (https://cloud.google.com/data-catalog/docs/how-to/search-reference).
      virtual void SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an entry group.
      //
      // An entry group contains logically related entries together with [Cloud
      // Identity and Access Management](/data-catalog/docs/concepts/iam) policies.
      // These policies specify users who can create, edit, and view entries
      // within entry groups.
      //
      // Data Catalog automatically creates entry groups with names that start with
      // the `@` symbol for the following resources:
      //
      // * BigQuery entries (`@bigquery`)
      // * Pub/Sub topics (`@pubsub`)
      // * Dataproc Metastore services (`@dataproc_metastore_{SERVICE_NAME_HASH}`)
      //
      // You can create your own entry groups for Cloud Storage fileset entries
      // and custom entries together with the corresponding IAM policies.
      // User-created entry groups can't contain the `@` symbol, it is reserved
      // for automatically created groups.
      //
      // Entry groups, like entries, can be searched.
      //
      // A maximum of 10,000 entry groups may be created per organization across all
      // locations.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `parent` parameter. For more information, see [Data Catalog resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an entry group.
      virtual void GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an entry group.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `entry_group.name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an entry group.
      //
      // You must enable the Data Catalog API in the project
      // identified by the `name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists entry groups.
      virtual void ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an entry.
      //
      // You can create entries only with 'FILESET', 'CLUSTER', 'DATA_STREAM',
      // or custom types. Data Catalog automatically creates entries with other
      // types during metadata ingestion from integrated systems.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `parent` parameter. For more information, see [Data Catalog resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      //
      // An entry group can have a maximum of 100,000 entries.
      virtual void CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing entry.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `entry.name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an existing entry.
      //
      // You can delete only the entries created by the
      // [CreateEntry][google.cloud.datacatalog.v1.DataCatalog.CreateEntry]
      // method.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an entry.
      virtual void GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an entry by its target resource name.
      //
      // The resource name comes from the source Google Cloud Platform service.
      virtual void LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) = 0;
      virtual void LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists entries.
      //
      // Note: Currently, this method can list only custom entries.
      // To get a list of both custom and automatically created entries, use
      // [SearchCatalog][google.cloud.datacatalog.v1.DataCatalog.SearchCatalog].
      virtual void ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies entry overview, part of the business context of an
      // [Entry][google.cloud.datacatalog.v1.Entry].
      //
      // To call this method, you must have the `datacatalog.entries.updateOverview`
      // IAM permission on the corresponding project.
      virtual void ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies contacts, part of the business context of an
      // [Entry][google.cloud.datacatalog.v1.Entry].
      //
      // To call this method, you must have the `datacatalog.entries.updateContacts`
      // IAM permission on the corresponding project.
      virtual void ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a tag template.
      //
      // You must enable the Data Catalog API in the project identified by the
      // `parent` parameter.
      // For more information, see [Data Catalog resource project]
      // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a tag template.
      virtual void GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a tag template.
      //
      // You can't update template fields with this method. These fields are
      // separate resources with their own create, update, and delete methods.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `tag_template.name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a tag template and all tags that use it.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `name` parameter. For more information, see [Data Catalog resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a field in a tag template.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `parent` parameter. For more information, see [Data Catalog resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates a field in a tag template.
      //
      // You can't update the field type with this method.
      //
      // You must enable the Data Catalog API in the project
      // identified by the `name` parameter. For more information, see [Data Catalog
      // resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Renames a field in a tag template.
      //
      // You must enable the Data Catalog API in the project identified by the
      // `name` parameter. For more information, see [Data Catalog resource project]
      // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Renames an enum value in a tag template.
      //
      // Within a single enum field, enum values must be unique.
      virtual void RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a field in a tag template and all uses of this field from the tags
      // based on this template.
      //
      // You must enable the Data Catalog API in the project identified by
      // the `name` parameter. For more information, see [Data Catalog resource
      // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
      virtual void DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a tag and assigns it to:
      //
      // * An [Entry][google.cloud.datacatalog.v1.Entry] if the method name is
      //   `projects.locations.entryGroups.entries.tags.create`.
      // * Or [EntryGroup][google.cloud.datacatalog.v1.EntryGroup]if the method
      //   name is `projects.locations.entryGroups.tags.create`.
      //
      // Note: The project identified by the `parent` parameter for the [tag]
      // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.entryGroups.entries.tags/create#path-parameters)
      // and the [tag template]
      // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.tagTemplates/create#path-parameters)
      // used to create the tag must be in the same organization.
      virtual void CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing tag.
      virtual void UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a tag.
      virtual void DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists tags assigned to an [Entry][google.cloud.datacatalog.v1.Entry].
      // The [columns][google.cloud.datacatalog.v1.Tag.column] in the response are
      // lowercased.
      virtual void ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // `ReconcileTags` creates or updates a list of tags on the entry.
      // If the
      // [ReconcileTagsRequest.force_delete_missing][google.cloud.datacatalog.v1.ReconcileTagsRequest.force_delete_missing]
      // parameter is set, the operation deletes tags not included in the input tag
      // list.
      //
      // `ReconcileTags` returns a [long-running operation]
      // [google.longrunning.Operation] resource that can be queried with
      // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
      // to return [ReconcileTagsMetadata]
      // [google.cloud.datacatalog.v1.ReconcileTagsMetadata] and
      // a [ReconcileTagsResponse]
      // [google.cloud.datacatalog.v1.ReconcileTagsResponse] message.
      virtual void ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as starred by
      // the current user. Starring information is private to each user.
      virtual void StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as NOT starred by
      // the current user. Starring information is private to each user.
      virtual void UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Sets an access control policy for a resource. Replaces any existing
      // policy.
      //
      // Supported resources are:
      //
      // - Tag templates
      // - Entry groups
      //
      // Note: This method sets policies only within Data Catalog and can't be
      // used to manage policies in BigQuery, Pub/Sub, Dataproc Metastore, and any
      // external Google Cloud Platform resources synced with the Data Catalog.
      //
      // To call this method, you must have the following Google IAM permissions:
      //
      // - `datacatalog.tagTemplates.setIamPolicy` to set policies on tag
      //   templates.
      // - `datacatalog.entryGroups.setIamPolicy` to set policies on entry groups.
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the access control policy for a resource.
      //
      // May return:
      //
      // * A`NOT_FOUND` error if the resource doesn't exist or you don't have the
      //   permission to view it.
      // * An empty policy if the resource exists but doesn't have a set policy.
      //
      // Supported resources are:
      //
      // - Tag templates
      // - Entry groups
      //
      // Note: This method doesn't get policies from Google Cloud Platform
      // resources ingested into Data Catalog.
      //
      // To call this method, you must have the following Google IAM permissions:
      //
      // - `datacatalog.tagTemplates.getIamPolicy` to get policies on tag
      //   templates.
      // - `datacatalog.entryGroups.getIamPolicy` to get policies on entry groups.
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets your permissions on a resource.
      //
      // Returns an empty set of permissions if the resource doesn't exist.
      //
      // Supported resources are:
      //
      // - Tag templates
      // - Entry groups
      //
      // Note: This method gets policies only within Data Catalog and can't be
      // used to get policies from BigQuery, Pub/Sub, Dataproc Metastore, and any
      // external Google Cloud Platform resources ingested into Data Catalog.
      //
      // No Google IAM permissions are required to call this method.
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Imports entries from a source, such as data previously dumped into a
      // Cloud Storage bucket, into Data Catalog. Import of entries
      // is a sync operation that reconciles the state of the third-party system
      // with the Data Catalog.
      //
      // `ImportEntries` accepts source data snapshots of a third-party system.
      // Snapshot should be delivered as a .wire or base65-encoded .txt file
      // containing a sequence of Protocol Buffer messages of
      // [DumpItem][google.cloud.datacatalog.v1.DumpItem] type.
      //
      // `ImportEntries` returns a [long-running operation]
      // [google.longrunning.Operation] resource that can be queried with
      // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
      // to return
      // [ImportEntriesMetadata][google.cloud.datacatalog.v1.ImportEntriesMetadata]
      // and an
      // [ImportEntriesResponse][google.cloud.datacatalog.v1.ImportEntriesResponse]
      // message.
      virtual void ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>* AsyncSearchCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::SearchCatalogResponse>* PrepareAsyncSearchCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncCreateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncCreateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncGetEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncGetEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncUpdateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncUpdateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* AsyncListEntryGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* PrepareAsyncListEntryGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* AsyncCreateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncCreateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* AsyncUpdateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncUpdateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* AsyncGetEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncGetEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* AsyncLookupEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncLookupEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>* AsyncListEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListEntriesResponse>* PrepareAsyncListEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>* AsyncModifyEntryOverviewRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::EntryOverview>* PrepareAsyncModifyEntryOverviewRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>* AsyncModifyEntryContactsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Contacts>* PrepareAsyncModifyEntryContactsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncCreateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncCreateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncGetTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncGetTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncUpdateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncUpdateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncCreateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncCreateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncUpdateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncUpdateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncRenameTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncRenameTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncRenameTagTemplateFieldEnumValueRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncRenameTagTemplateFieldEnumValueRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>* AsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>* PrepareAsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>* AsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::Tag>* PrepareAsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>* AsyncListTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::ListTagsResponse>* PrepareAsyncListTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncReconcileTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncReconcileTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>* AsyncStarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::StarEntryResponse>* PrepareAsyncStarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>* AsyncUnstarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::datacatalog::v1::UnstarEntryResponse>* PrepareAsyncUnstarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>> AsyncSearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>>(AsyncSearchCatalogRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>> PrepareAsyncSearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>>(PrepareAsyncSearchCatalogRaw(context, request, cq));
    }
    ::grpc::Status CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncCreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncCreateEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncCreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncCreateEntryGroupRaw(context, request, cq));
    }
    ::grpc::Status GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncGetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncGetEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncGetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncGetEntryGroupRaw(context, request, cq));
    }
    ::grpc::Status UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::google::cloud::datacatalog::v1::EntryGroup* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> AsyncUpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(AsyncUpdateEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>> PrepareAsyncUpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>>(PrepareAsyncUpdateEntryGroupRaw(context, request, cq));
    }
    ::grpc::Status DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteEntryGroupRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntryGroupRaw(context, request, cq));
    }
    ::grpc::Status ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>> AsyncListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>>(AsyncListEntryGroupsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>> PrepareAsyncListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>>(PrepareAsyncListEntryGroupsRaw(context, request, cq));
    }
    ::grpc::Status CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> AsyncCreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(AsyncCreateEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncCreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncCreateEntryRaw(context, request, cq));
    }
    ::grpc::Status UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> AsyncUpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(AsyncUpdateEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncUpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncUpdateEntryRaw(context, request, cq));
    }
    ::grpc::Status DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteEntryRaw(context, request, cq));
    }
    ::grpc::Status GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> AsyncGetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(AsyncGetEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncGetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncGetEntryRaw(context, request, cq));
    }
    ::grpc::Status LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::google::cloud::datacatalog::v1::Entry* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> AsyncLookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(AsyncLookupEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>> PrepareAsyncLookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>>(PrepareAsyncLookupEntryRaw(context, request, cq));
    }
    ::grpc::Status ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>> AsyncListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>>(AsyncListEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>> PrepareAsyncListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>>(PrepareAsyncListEntriesRaw(context, request, cq));
    }
    ::grpc::Status ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::google::cloud::datacatalog::v1::EntryOverview* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>> AsyncModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>>(AsyncModifyEntryOverviewRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>> PrepareAsyncModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>>(PrepareAsyncModifyEntryOverviewRaw(context, request, cq));
    }
    ::grpc::Status ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::google::cloud::datacatalog::v1::Contacts* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>> AsyncModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>>(AsyncModifyEntryContactsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>> PrepareAsyncModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>>(PrepareAsyncModifyEntryContactsRaw(context, request, cq));
    }
    ::grpc::Status CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncCreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncCreateTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncCreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncCreateTagTemplateRaw(context, request, cq));
    }
    ::grpc::Status GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncGetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncGetTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncGetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncGetTagTemplateRaw(context, request, cq));
    }
    ::grpc::Status UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::google::cloud::datacatalog::v1::TagTemplate* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> AsyncUpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(AsyncUpdateTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>> PrepareAsyncUpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>>(PrepareAsyncUpdateTagTemplateRaw(context, request, cq));
    }
    ::grpc::Status DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTagTemplateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagTemplateRaw(context, request, cq));
    }
    ::grpc::Status CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncCreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncCreateTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncCreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncCreateTagTemplateFieldRaw(context, request, cq));
    }
    ::grpc::Status UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncUpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncUpdateTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncUpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncUpdateTagTemplateFieldRaw(context, request, cq));
    }
    ::grpc::Status RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncRenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncRenameTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncRenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncRenameTagTemplateFieldRaw(context, request, cq));
    }
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::google::cloud::datacatalog::v1::TagTemplateField* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> AsyncRenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(AsyncRenameTagTemplateFieldEnumValueRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>> PrepareAsyncRenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>>(PrepareAsyncRenameTagTemplateFieldEnumValueRaw(context, request, cq));
    }
    ::grpc::Status DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTagTemplateFieldRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagTemplateFieldRaw(context, request, cq));
    }
    ::grpc::Status CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::google::cloud::datacatalog::v1::Tag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>> AsyncCreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>>(AsyncCreateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>> PrepareAsyncCreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>>(PrepareAsyncCreateTagRaw(context, request, cq));
    }
    ::grpc::Status UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::google::cloud::datacatalog::v1::Tag* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>> AsyncUpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>>(AsyncUpdateTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>> PrepareAsyncUpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>>(PrepareAsyncUpdateTagRaw(context, request, cq));
    }
    ::grpc::Status DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTagRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTagRaw(context, request, cq));
    }
    ::grpc::Status ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::google::cloud::datacatalog::v1::ListTagsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>> AsyncListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>>(AsyncListTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>> PrepareAsyncListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>>(PrepareAsyncListTagsRaw(context, request, cq));
    }
    ::grpc::Status ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncReconcileTagsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncReconcileTagsRaw(context, request, cq));
    }
    ::grpc::Status StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::google::cloud::datacatalog::v1::StarEntryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>> AsyncStarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>>(AsyncStarEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>> PrepareAsyncStarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>>(PrepareAsyncStarEntryRaw(context, request, cq));
    }
    ::grpc::Status UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>> AsyncUnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>>(AsyncUnstarEntryRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>> PrepareAsyncUnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>>(PrepareAsyncUnstarEntryRaw(context, request, cq));
    }
    ::grpc::Status SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncSetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncSetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncSetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::google::iam::v1::Policy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> AsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(AsyncGetIamPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>> PrepareAsyncGetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>>(PrepareAsyncGetIamPolicyRaw(context, request, cq));
    }
    ::grpc::Status TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::google::iam::v1::TestIamPermissionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> AsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(AsyncTestIamPermissionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>> PrepareAsyncTestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>>(PrepareAsyncTestIamPermissionsRaw(context, request, cq));
    }
    ::grpc::Status ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportEntriesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportEntriesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchCatalog(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) override;
      void CreateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) override;
      void GetEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntryGroup(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntryGroups(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) override;
      void CreateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) override;
      void UpdateEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) override;
      void GetEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) override;
      void LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, std::function<void(::grpc::Status)>) override;
      void LookupEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response, std::function<void(::grpc::Status)>) override;
      void ModifyEntryOverview(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response, std::function<void(::grpc::Status)>) override;
      void ModifyEntryContacts(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) override;
      void CreateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) override;
      void GetTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, std::function<void(::grpc::Status)>) override;
      void UpdateTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTagTemplate(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) override;
      void CreateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) override;
      void UpdateTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) override;
      void RenameTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, std::function<void(::grpc::Status)>) override;
      void RenameTagTemplateFieldEnumValue(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTagTemplateField(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, std::function<void(::grpc::Status)>) override;
      void CreateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, std::function<void(::grpc::Status)>) override;
      void UpdateTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTag(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ReconcileTags(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response, std::function<void(::grpc::Status)>) override;
      void StarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response, std::function<void(::grpc::Status)>) override;
      void UnstarEntry(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void SetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, std::function<void(::grpc::Status)>) override;
      void GetIamPolicy(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, std::function<void(::grpc::Status)>) override;
      void TestIamPermissions(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportEntries(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>* AsyncSearchCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::SearchCatalogResponse>* PrepareAsyncSearchCatalogRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncCreateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncCreateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncGetEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncGetEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* AsyncUpdateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryGroup>* PrepareAsyncUpdateEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteEntryGroupRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* AsyncListEntryGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* PrepareAsyncListEntryGroupsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* AsyncCreateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncCreateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* AsyncUpdateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncUpdateEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* AsyncGetEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncGetEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* AsyncLookupEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Entry>* PrepareAsyncLookupEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>* AsyncListEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListEntriesResponse>* PrepareAsyncListEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>* AsyncModifyEntryOverviewRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::EntryOverview>* PrepareAsyncModifyEntryOverviewRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>* AsyncModifyEntryContactsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Contacts>* PrepareAsyncModifyEntryContactsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncCreateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncCreateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncGetTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncGetTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* AsyncUpdateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplate>* PrepareAsyncUpdateTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTagTemplateRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncCreateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncCreateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncUpdateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncUpdateTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncRenameTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncRenameTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* AsyncRenameTagTemplateFieldEnumValueRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::TagTemplateField>* PrepareAsyncRenameTagTemplateFieldEnumValueRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTagTemplateFieldRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>* AsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>* PrepareAsyncCreateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>* AsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::Tag>* PrepareAsyncUpdateTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTagRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>* AsyncListTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::ListTagsResponse>* PrepareAsyncListTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncReconcileTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncReconcileTagsRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>* AsyncStarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::StarEntryResponse>* PrepareAsyncStarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>* AsyncUnstarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::datacatalog::v1::UnstarEntryResponse>* PrepareAsyncUnstarEntryRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncSetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::SetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* AsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::Policy>* PrepareAsyncGetIamPolicyRaw(::grpc::ClientContext* context, const ::google::iam::v1::GetIamPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* AsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::iam::v1::TestIamPermissionsResponse>* PrepareAsyncTestIamPermissionsRaw(::grpc::ClientContext* context, const ::google::iam::v1::TestIamPermissionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportEntriesRaw(::grpc::ClientContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_SearchCatalog_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntryGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntryGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEntryGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEntryGroup_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntryGroups_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_LookupEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEntries_;
    const ::grpc::internal::RpcMethod rpcmethod_ModifyEntryOverview_;
    const ::grpc::internal::RpcMethod rpcmethod_ModifyEntryContacts_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTagTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTagTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTagTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTagTemplate_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTagTemplateField_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTagTemplateField_;
    const ::grpc::internal::RpcMethod rpcmethod_RenameTagTemplateField_;
    const ::grpc::internal::RpcMethod rpcmethod_RenameTagTemplateFieldEnumValue_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTagTemplateField_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTag_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateTag_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTag_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTags_;
    const ::grpc::internal::RpcMethod rpcmethod_ReconcileTags_;
    const ::grpc::internal::RpcMethod rpcmethod_StarEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_UnstarEntry_;
    const ::grpc::internal::RpcMethod rpcmethod_SetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetIamPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_TestIamPermissions_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportEntries_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Searches Data Catalog for multiple resources like entries and tags that
    // match a query.
    //
    // This is a [Custom Method]
    // (https://cloud.google.com/apis/design/custom_methods) that doesn't return
    // all information on a resource, only its ID and high level fields. To get
    // more information, you can subsequently call specific get methods.
    //
    // Note: Data Catalog search queries don't guarantee full recall. Results
    // that match your query might not be returned, even in subsequent
    // result pages. Additionally, returned (and not returned) results can vary
    // if you repeat search queries.
    //
    // For more information, see [Data Catalog search syntax]
    // (https://cloud.google.com/data-catalog/docs/how-to/search-reference).
    virtual ::grpc::Status SearchCatalog(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response);
    // Creates an entry group.
    //
    // An entry group contains logically related entries together with [Cloud
    // Identity and Access Management](/data-catalog/docs/concepts/iam) policies.
    // These policies specify users who can create, edit, and view entries
    // within entry groups.
    //
    // Data Catalog automatically creates entry groups with names that start with
    // the `@` symbol for the following resources:
    //
    // * BigQuery entries (`@bigquery`)
    // * Pub/Sub topics (`@pubsub`)
    // * Dataproc Metastore services (`@dataproc_metastore_{SERVICE_NAME_HASH}`)
    //
    // You can create your own entry groups for Cloud Storage fileset entries
    // and custom entries together with the corresponding IAM policies.
    // User-created entry groups can't contain the `@` symbol, it is reserved
    // for automatically created groups.
    //
    // Entry groups, like entries, can be searched.
    //
    // A maximum of 10,000 entry groups may be created per organization across all
    // locations.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateEntryGroup(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response);
    // Gets an entry group.
    virtual ::grpc::Status GetEntryGroup(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response);
    // Updates an entry group.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `entry_group.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response);
    // Deletes an entry group.
    //
    // You must enable the Data Catalog API in the project
    // identified by the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response);
    // Lists entry groups.
    virtual ::grpc::Status ListEntryGroups(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response);
    // Creates an entry.
    //
    // You can create entries only with 'FILESET', 'CLUSTER', 'DATA_STREAM',
    // or custom types. Data Catalog automatically creates entries with other
    // types during metadata ingestion from integrated systems.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    //
    // An entry group can have a maximum of 100,000 entries.
    virtual ::grpc::Status CreateEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response);
    // Updates an existing entry.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `entry.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response);
    // Deletes an existing entry.
    //
    // You can delete only the entries created by the
    // [CreateEntry][google.cloud.datacatalog.v1.DataCatalog.CreateEntry]
    // method.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response);
    // Gets an entry.
    virtual ::grpc::Status GetEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response);
    // Gets an entry by its target resource name.
    //
    // The resource name comes from the source Google Cloud Platform service.
    virtual ::grpc::Status LookupEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response);
    // Lists entries.
    //
    // Note: Currently, this method can list only custom entries.
    // To get a list of both custom and automatically created entries, use
    // [SearchCatalog][google.cloud.datacatalog.v1.DataCatalog.SearchCatalog].
    virtual ::grpc::Status ListEntries(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response);
    // Modifies entry overview, part of the business context of an
    // [Entry][google.cloud.datacatalog.v1.Entry].
    //
    // To call this method, you must have the `datacatalog.entries.updateOverview`
    // IAM permission on the corresponding project.
    virtual ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response);
    // Modifies contacts, part of the business context of an
    // [Entry][google.cloud.datacatalog.v1.Entry].
    //
    // To call this method, you must have the `datacatalog.entries.updateContacts`
    // IAM permission on the corresponding project.
    virtual ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response);
    // Creates a tag template.
    //
    // You must enable the Data Catalog API in the project identified by the
    // `parent` parameter.
    // For more information, see [Data Catalog resource project]
    // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateTagTemplate(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response);
    // Gets a tag template.
    virtual ::grpc::Status GetTagTemplate(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response);
    // Updates a tag template.
    //
    // You can't update template fields with this method. These fields are
    // separate resources with their own create, update, and delete methods.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `tag_template.name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response);
    // Deletes a tag template and all tags that use it.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response);
    // Creates a field in a tag template.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `parent` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response);
    // Updates a field in a tag template.
    //
    // You can't update the field type with this method.
    //
    // You must enable the Data Catalog API in the project
    // identified by the `name` parameter. For more information, see [Data Catalog
    // resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response);
    // Renames a field in a tag template.
    //
    // You must enable the Data Catalog API in the project identified by the
    // `name` parameter. For more information, see [Data Catalog resource project]
    // (https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response);
    // Renames an enum value in a tag template.
    //
    // Within a single enum field, enum values must be unique.
    virtual ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response);
    // Deletes a field in a tag template and all uses of this field from the tags
    // based on this template.
    //
    // You must enable the Data Catalog API in the project identified by
    // the `name` parameter. For more information, see [Data Catalog resource
    // project](https://cloud.google.com/data-catalog/docs/concepts/resource-project).
    virtual ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response);
    // Creates a tag and assigns it to:
    //
    // * An [Entry][google.cloud.datacatalog.v1.Entry] if the method name is
    //   `projects.locations.entryGroups.entries.tags.create`.
    // * Or [EntryGroup][google.cloud.datacatalog.v1.EntryGroup]if the method
    //   name is `projects.locations.entryGroups.tags.create`.
    //
    // Note: The project identified by the `parent` parameter for the [tag]
    // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.entryGroups.entries.tags/create#path-parameters)
    // and the [tag template]
    // (https://cloud.google.com/data-catalog/docs/reference/rest/v1/projects.locations.tagTemplates/create#path-parameters)
    // used to create the tag must be in the same organization.
    virtual ::grpc::Status CreateTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response);
    // Updates an existing tag.
    virtual ::grpc::Status UpdateTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response);
    // Deletes a tag.
    virtual ::grpc::Status DeleteTag(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response);
    // Lists tags assigned to an [Entry][google.cloud.datacatalog.v1.Entry].
    // The [columns][google.cloud.datacatalog.v1.Tag.column] in the response are
    // lowercased.
    virtual ::grpc::Status ListTags(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response);
    // `ReconcileTags` creates or updates a list of tags on the entry.
    // If the
    // [ReconcileTagsRequest.force_delete_missing][google.cloud.datacatalog.v1.ReconcileTagsRequest.force_delete_missing]
    // parameter is set, the operation deletes tags not included in the input tag
    // list.
    //
    // `ReconcileTags` returns a [long-running operation]
    // [google.longrunning.Operation] resource that can be queried with
    // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
    // to return [ReconcileTagsMetadata]
    // [google.cloud.datacatalog.v1.ReconcileTagsMetadata] and
    // a [ReconcileTagsResponse]
    // [google.cloud.datacatalog.v1.ReconcileTagsResponse] message.
    virtual ::grpc::Status ReconcileTags(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response);
    // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as starred by
    // the current user. Starring information is private to each user.
    virtual ::grpc::Status StarEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response);
    // Marks an [Entry][google.cloud.datacatalog.v1.Entry] as NOT starred by
    // the current user. Starring information is private to each user.
    virtual ::grpc::Status UnstarEntry(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response);
    // Sets an access control policy for a resource. Replaces any existing
    // policy.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method sets policies only within Data Catalog and can't be
    // used to manage policies in BigQuery, Pub/Sub, Dataproc Metastore, and any
    // external Google Cloud Platform resources synced with the Data Catalog.
    //
    // To call this method, you must have the following Google IAM permissions:
    //
    // - `datacatalog.tagTemplates.setIamPolicy` to set policies on tag
    //   templates.
    // - `datacatalog.entryGroups.setIamPolicy` to set policies on entry groups.
    virtual ::grpc::Status SetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets the access control policy for a resource.
    //
    // May return:
    //
    // * A`NOT_FOUND` error if the resource doesn't exist or you don't have the
    //   permission to view it.
    // * An empty policy if the resource exists but doesn't have a set policy.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method doesn't get policies from Google Cloud Platform
    // resources ingested into Data Catalog.
    //
    // To call this method, you must have the following Google IAM permissions:
    //
    // - `datacatalog.tagTemplates.getIamPolicy` to get policies on tag
    //   templates.
    // - `datacatalog.entryGroups.getIamPolicy` to get policies on entry groups.
    virtual ::grpc::Status GetIamPolicy(::grpc::ServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response);
    // Gets your permissions on a resource.
    //
    // Returns an empty set of permissions if the resource doesn't exist.
    //
    // Supported resources are:
    //
    // - Tag templates
    // - Entry groups
    //
    // Note: This method gets policies only within Data Catalog and can't be
    // used to get policies from BigQuery, Pub/Sub, Dataproc Metastore, and any
    // external Google Cloud Platform resources ingested into Data Catalog.
    //
    // No Google IAM permissions are required to call this method.
    virtual ::grpc::Status TestIamPermissions(::grpc::ServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response);
    // Imports entries from a source, such as data previously dumped into a
    // Cloud Storage bucket, into Data Catalog. Import of entries
    // is a sync operation that reconciles the state of the third-party system
    // with the Data Catalog.
    //
    // `ImportEntries` accepts source data snapshots of a third-party system.
    // Snapshot should be delivered as a .wire or base65-encoded .txt file
    // containing a sequence of Protocol Buffer messages of
    // [DumpItem][google.cloud.datacatalog.v1.DumpItem] type.
    //
    // `ImportEntries` returns a [long-running operation]
    // [google.longrunning.Operation] resource that can be queried with
    // [Operations.GetOperation][google.longrunning.Operations.GetOperation]
    // to return
    // [ImportEntriesMetadata][google.cloud.datacatalog.v1.ImportEntriesMetadata]
    // and an
    // [ImportEntriesResponse][google.cloud.datacatalog.v1.ImportEntriesResponse]
    // message.
    virtual ::grpc::Status ImportEntries(::grpc::ServerContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCatalog(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::SearchCatalogResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntryGroup(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::EntryGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntryGroup(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::EntryGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntryGroup(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::EntryGroup>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntryGroup(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntryGroups(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEntry() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Entry>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Entry>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEntry() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Entry>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_LookupEntry() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Entry>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEntries() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntries(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ListEntriesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyEntryOverview(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::EntryOverview>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyEntryContacts(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Contacts>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagTemplate(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTagTemplate(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTagTemplate(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplate>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagTemplate(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagTemplateField(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplateField>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTagTemplateField(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplateField>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTagTemplateField(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplateField>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTagTemplateFieldEnumValue(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::TagTemplateField>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagTemplateField(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTag() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Tag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateTag() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::Tag>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTag() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTag(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTags() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTags(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::ListTagsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReconcileTags(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StarEntry() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStarEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::StarEntryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUnstarEntry(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::datacatalog::v1::UnstarEntryResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::SetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::google::iam::v1::GetIamPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::Policy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::google::iam::v1::TestIamPermissionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::iam::v1::TestIamPermissionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportEntries() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportEntries(::grpc::ServerContext* context, ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_SearchCatalog<WithAsyncMethod_CreateEntryGroup<WithAsyncMethod_GetEntryGroup<WithAsyncMethod_UpdateEntryGroup<WithAsyncMethod_DeleteEntryGroup<WithAsyncMethod_ListEntryGroups<WithAsyncMethod_CreateEntry<WithAsyncMethod_UpdateEntry<WithAsyncMethod_DeleteEntry<WithAsyncMethod_GetEntry<WithAsyncMethod_LookupEntry<WithAsyncMethod_ListEntries<WithAsyncMethod_ModifyEntryOverview<WithAsyncMethod_ModifyEntryContacts<WithAsyncMethod_CreateTagTemplate<WithAsyncMethod_GetTagTemplate<WithAsyncMethod_UpdateTagTemplate<WithAsyncMethod_DeleteTagTemplate<WithAsyncMethod_CreateTagTemplateField<WithAsyncMethod_UpdateTagTemplateField<WithAsyncMethod_RenameTagTemplateField<WithAsyncMethod_RenameTagTemplateFieldEnumValue<WithAsyncMethod_DeleteTagTemplateField<WithAsyncMethod_CreateTag<WithAsyncMethod_UpdateTag<WithAsyncMethod_DeleteTag<WithAsyncMethod_ListTags<WithAsyncMethod_ReconcileTags<WithAsyncMethod_StarEntry<WithAsyncMethod_UnstarEntry<WithAsyncMethod_SetIamPolicy<WithAsyncMethod_GetIamPolicy<WithAsyncMethod_TestIamPermissions<WithAsyncMethod_ImportEntries<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::SearchCatalogRequest, ::google::cloud::datacatalog::v1::SearchCatalogResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* request, ::google::cloud::datacatalog::v1::SearchCatalogResponse* response) { return this->SearchCatalog(context, request, response); }));}
    void SetMessageAllocatorFor_SearchCatalog(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::SearchCatalogRequest, ::google::cloud::datacatalog::v1::SearchCatalogResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::SearchCatalogRequest, ::google::cloud::datacatalog::v1::SearchCatalogResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response) { return this->CreateEntryGroup(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEntryGroup(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response) { return this->GetEntryGroup(context, request, response); }));}
    void SetMessageAllocatorFor_GetEntryGroup(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::GetEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* request, ::google::cloud::datacatalog::v1::EntryGroup* response) { return this->UpdateEntryGroup(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEntryGroup(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* request, ::google::protobuf::Empty* response) { return this->DeleteEntryGroup(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEntryGroup(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListEntryGroupsRequest, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* request, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* response) { return this->ListEntryGroups(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntryGroups(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ListEntryGroupsRequest, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListEntryGroupsRequest, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntryGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEntry() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response) { return this->CreateEntry(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateEntryRequest, ::google::cloud::datacatalog::v1::Entry>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateEntryRequest, ::google::cloud::datacatalog::v1::Entry>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response) { return this->UpdateEntry(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateEntryRequest, ::google::cloud::datacatalog::v1::Entry>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateEntryRequest, ::google::cloud::datacatalog::v1::Entry>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteEntryRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* request, ::google::protobuf::Empty* response) { return this->DeleteEntry(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteEntryRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteEntryRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEntry() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::GetEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response) { return this->GetEntry(context, request, response); }));}
    void SetMessageAllocatorFor_GetEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::GetEntryRequest, ::google::cloud::datacatalog::v1::Entry>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetEntryRequest, ::google::cloud::datacatalog::v1::Entry>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_LookupEntry() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::LookupEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::LookupEntryRequest* request, ::google::cloud::datacatalog::v1::Entry* response) { return this->LookupEntry(context, request, response); }));}
    void SetMessageAllocatorFor_LookupEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::LookupEntryRequest, ::google::cloud::datacatalog::v1::Entry>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::LookupEntryRequest, ::google::cloud::datacatalog::v1::Entry>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEntries() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListEntriesRequest, ::google::cloud::datacatalog::v1::ListEntriesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ListEntriesRequest* request, ::google::cloud::datacatalog::v1::ListEntriesResponse* response) { return this->ListEntries(context, request, response); }));}
    void SetMessageAllocatorFor_ListEntries(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ListEntriesRequest, ::google::cloud::datacatalog::v1::ListEntriesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListEntriesRequest, ::google::cloud::datacatalog::v1::ListEntriesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest, ::google::cloud::datacatalog::v1::EntryOverview>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* request, ::google::cloud::datacatalog::v1::EntryOverview* response) { return this->ModifyEntryOverview(context, request, response); }));}
    void SetMessageAllocatorFor_ModifyEntryOverview(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest, ::google::cloud::datacatalog::v1::EntryOverview>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest, ::google::cloud::datacatalog::v1::EntryOverview>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyEntryOverview(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest, ::google::cloud::datacatalog::v1::Contacts>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* request, ::google::cloud::datacatalog::v1::Contacts* response) { return this->ModifyEntryContacts(context, request, response); }));}
    void SetMessageAllocatorFor_ModifyEntryContacts(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest, ::google::cloud::datacatalog::v1::Contacts>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest, ::google::cloud::datacatalog::v1::Contacts>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyEntryContacts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response) { return this->CreateTagTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTagTemplate(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response) { return this->GetTagTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_GetTagTemplate(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::GetTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::GetTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* request, ::google::cloud::datacatalog::v1::TagTemplate* response) { return this->UpdateTagTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTagTemplate(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTagTemplate(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTagTemplate(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response) { return this->CreateTagTemplateField(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTagTemplateField(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response) { return this->UpdateTagTemplateField(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTagTemplateField(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response) { return this->RenameTagTemplateField(context, request, response); }));}
    void SetMessageAllocatorFor_RenameTagTemplateField(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* request, ::google::cloud::datacatalog::v1::TagTemplateField* response) { return this->RenameTagTemplateFieldEnumValue(context, request, response); }));}
    void SetMessageAllocatorFor_RenameTagTemplateFieldEnumValue(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest, ::google::cloud::datacatalog::v1::TagTemplateField>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTagTemplateFieldEnumValue(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTagTemplateField(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTagTemplateField(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTag() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagRequest, ::google::cloud::datacatalog::v1::Tag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::CreateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response) { return this->CreateTag(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::CreateTagRequest, ::google::cloud::datacatalog::v1::Tag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::CreateTagRequest, ::google::cloud::datacatalog::v1::Tag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateTag() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagRequest, ::google::cloud::datacatalog::v1::Tag>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UpdateTagRequest* request, ::google::cloud::datacatalog::v1::Tag* response) { return this->UpdateTag(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UpdateTagRequest, ::google::cloud::datacatalog::v1::Tag>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UpdateTagRequest, ::google::cloud::datacatalog::v1::Tag>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTag() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::DeleteTagRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTag(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTag(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::DeleteTagRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::DeleteTagRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTag(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTags() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListTagsRequest, ::google::cloud::datacatalog::v1::ListTagsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ListTagsRequest* request, ::google::cloud::datacatalog::v1::ListTagsResponse* response) { return this->ListTags(context, request, response); }));}
    void SetMessageAllocatorFor_ListTags(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ListTagsRequest, ::google::cloud::datacatalog::v1::ListTagsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ListTagsRequest, ::google::cloud::datacatalog::v1::ListTagsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTags(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ReconcileTagsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* request, ::google::longrunning::Operation* response) { return this->ReconcileTags(context, request, response); }));}
    void SetMessageAllocatorFor_ReconcileTags(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ReconcileTagsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ReconcileTagsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReconcileTags(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StarEntry() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::StarEntryRequest, ::google::cloud::datacatalog::v1::StarEntryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::StarEntryRequest* request, ::google::cloud::datacatalog::v1::StarEntryResponse* response) { return this->StarEntry(context, request, response); }));}
    void SetMessageAllocatorFor_StarEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::StarEntryRequest, ::google::cloud::datacatalog::v1::StarEntryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::StarEntryRequest, ::google::cloud::datacatalog::v1::StarEntryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StarEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UnstarEntryRequest, ::google::cloud::datacatalog::v1::UnstarEntryResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* request, ::google::cloud::datacatalog::v1::UnstarEntryResponse* response) { return this->UnstarEntry(context, request, response); }));}
    void SetMessageAllocatorFor_UnstarEntry(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::UnstarEntryRequest, ::google::cloud::datacatalog::v1::UnstarEntryResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::UnstarEntryRequest, ::google::cloud::datacatalog::v1::UnstarEntryResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UnstarEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::SetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->SetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_SetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::GetIamPolicyRequest* request, ::google::iam::v1::Policy* response) { return this->GetIamPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetIamPolicy(
        ::grpc::MessageAllocator< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::iam::v1::TestIamPermissionsRequest* request, ::google::iam::v1::TestIamPermissionsResponse* response) { return this->TestIamPermissions(context, request, response); }));}
    void SetMessageAllocatorFor_TestIamPermissions(
        ::grpc::MessageAllocator< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportEntries() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ImportEntriesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* request, ::google::longrunning::Operation* response) { return this->ImportEntries(context, request, response); }));}
    void SetMessageAllocatorFor_ImportEntries(
        ::grpc::MessageAllocator< ::google::cloud::datacatalog::v1::ImportEntriesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::datacatalog::v1::ImportEntriesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_SearchCatalog<WithCallbackMethod_CreateEntryGroup<WithCallbackMethod_GetEntryGroup<WithCallbackMethod_UpdateEntryGroup<WithCallbackMethod_DeleteEntryGroup<WithCallbackMethod_ListEntryGroups<WithCallbackMethod_CreateEntry<WithCallbackMethod_UpdateEntry<WithCallbackMethod_DeleteEntry<WithCallbackMethod_GetEntry<WithCallbackMethod_LookupEntry<WithCallbackMethod_ListEntries<WithCallbackMethod_ModifyEntryOverview<WithCallbackMethod_ModifyEntryContacts<WithCallbackMethod_CreateTagTemplate<WithCallbackMethod_GetTagTemplate<WithCallbackMethod_UpdateTagTemplate<WithCallbackMethod_DeleteTagTemplate<WithCallbackMethod_CreateTagTemplateField<WithCallbackMethod_UpdateTagTemplateField<WithCallbackMethod_RenameTagTemplateField<WithCallbackMethod_RenameTagTemplateFieldEnumValue<WithCallbackMethod_DeleteTagTemplateField<WithCallbackMethod_CreateTag<WithCallbackMethod_UpdateTag<WithCallbackMethod_DeleteTag<WithCallbackMethod_ListTags<WithCallbackMethod_ReconcileTags<WithCallbackMethod_StarEntry<WithCallbackMethod_UnstarEntry<WithCallbackMethod_SetIamPolicy<WithCallbackMethod_GetIamPolicy<WithCallbackMethod_TestIamPermissions<WithCallbackMethod_ImportEntries<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEntry() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEntry() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_LookupEntry() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEntries() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTag() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateTag() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTag() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTags() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StarEntry() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportEntries() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchCatalog(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntryGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntryGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntryGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntryGroup(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntryGroups(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEntry() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEntry() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_LookupEntry() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEntries() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEntries(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyEntryOverview(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestModifyEntryContacts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTagTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTagTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagTemplate(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTagTemplateField(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTagTemplateField(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTagTemplateField(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRenameTagTemplateFieldEnumValue(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTagTemplateField(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTag() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateTag() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTag() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTag(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTags() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTags(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestReconcileTags(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StarEntry() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStarEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUnstarEntry(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetIamPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestTestIamPermissions(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportEntries() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportEntries(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchCatalog(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchCatalog(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEntryGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEntryGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEntryGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEntryGroup(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntryGroup(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntryGroups(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntryGroups(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEntry() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEntry() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_LookupEntry() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->LookupEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEntries() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEntries(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ModifyEntryOverview(context, request, response); }));
    }
    ~WithRawCallbackMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyEntryOverview(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ModifyEntryContacts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ModifyEntryContacts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTagTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTagTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTagTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTagTemplate(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagTemplate(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTagTemplateField(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTagTemplateField(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RenameTagTemplateField(context, request, response); }));
    }
    ~WithRawCallbackMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RenameTagTemplateFieldEnumValue(context, request, response); }));
    }
    ~WithRawCallbackMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RenameTagTemplateFieldEnumValue(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTagTemplateField(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTagTemplateField(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTag() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateTag() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTag() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTag(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTag(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTags() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTags(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTags(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ReconcileTags(context, request, response); }));
    }
    ~WithRawCallbackMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ReconcileTags(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StarEntry() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StarEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StarEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UnstarEntry(context, request, response); }));
    }
    ~WithRawCallbackMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UnstarEntry(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetIamPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetIamPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->TestIamPermissions(context, request, response); }));
    }
    ~WithRawCallbackMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* TestIamPermissions(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportEntries() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportEntries(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportEntries(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchCatalog : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchCatalog() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::SearchCatalogRequest, ::google::cloud::datacatalog::v1::SearchCatalogResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::SearchCatalogRequest, ::google::cloud::datacatalog::v1::SearchCatalogResponse>* streamer) {
                       return this->StreamedSearchCatalog(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchCatalog() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchCatalog(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::SearchCatalogRequest* /*request*/, ::google::cloud::datacatalog::v1::SearchCatalogResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchCatalog(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::SearchCatalogRequest,::google::cloud::datacatalog::v1::SearchCatalogResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntryGroup() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* streamer) {
                       return this->StreamedCreateEntryGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntryGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateEntryGroupRequest,::google::cloud::datacatalog::v1::EntryGroup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntryGroup() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::GetEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::GetEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* streamer) {
                       return this->StreamedGetEntryGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntryGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::GetEntryGroupRequest,::google::cloud::datacatalog::v1::EntryGroup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEntryGroup() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest, ::google::cloud::datacatalog::v1::EntryGroup>* streamer) {
                       return this->StreamedUpdateEntryGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryGroup* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEntryGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateEntryGroupRequest,::google::cloud::datacatalog::v1::EntryGroup>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEntryGroup : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEntryGroup() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteEntryGroup(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEntryGroup() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEntryGroup(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEntryGroup(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteEntryGroupRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntryGroups : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntryGroups() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ListEntryGroupsRequest, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ListEntryGroupsRequest, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* streamer) {
                       return this->StreamedListEntryGroups(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntryGroups() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntryGroups(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntryGroupsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntryGroupsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntryGroups(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ListEntryGroupsRequest,::google::cloud::datacatalog::v1::ListEntryGroupsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEntry() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateEntryRequest, ::google::cloud::datacatalog::v1::Entry>* streamer) {
                       return this->StreamedCreateEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateEntryRequest,::google::cloud::datacatalog::v1::Entry>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateEntry() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateEntryRequest, ::google::cloud::datacatalog::v1::Entry>* streamer) {
                       return this->StreamedUpdateEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateEntryRequest,::google::cloud::datacatalog::v1::Entry>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEntry() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteEntryRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteEntryRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteEntryRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteEntryRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEntry() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::GetEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::GetEntryRequest, ::google::cloud::datacatalog::v1::Entry>* streamer) {
                       return this->StreamedGetEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::GetEntryRequest,::google::cloud::datacatalog::v1::Entry>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_LookupEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_LookupEntry() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::LookupEntryRequest, ::google::cloud::datacatalog::v1::Entry>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::LookupEntryRequest, ::google::cloud::datacatalog::v1::Entry>* streamer) {
                       return this->StreamedLookupEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_LookupEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status LookupEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::LookupEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::Entry* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedLookupEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::LookupEntryRequest,::google::cloud::datacatalog::v1::Entry>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEntries() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ListEntriesRequest, ::google::cloud::datacatalog::v1::ListEntriesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ListEntriesRequest, ::google::cloud::datacatalog::v1::ListEntriesResponse>* streamer) {
                       return this->StreamedListEntries(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListEntriesRequest* /*request*/, ::google::cloud::datacatalog::v1::ListEntriesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEntries(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ListEntriesRequest,::google::cloud::datacatalog::v1::ListEntriesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ModifyEntryOverview : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ModifyEntryOverview() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest, ::google::cloud::datacatalog::v1::EntryOverview>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest, ::google::cloud::datacatalog::v1::EntryOverview>* streamer) {
                       return this->StreamedModifyEntryOverview(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ModifyEntryOverview() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ModifyEntryOverview(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest* /*request*/, ::google::cloud::datacatalog::v1::EntryOverview* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedModifyEntryOverview(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ModifyEntryOverviewRequest,::google::cloud::datacatalog::v1::EntryOverview>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ModifyEntryContacts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ModifyEntryContacts() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest, ::google::cloud::datacatalog::v1::Contacts>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest, ::google::cloud::datacatalog::v1::Contacts>* streamer) {
                       return this->StreamedModifyEntryContacts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ModifyEntryContacts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ModifyEntryContacts(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest* /*request*/, ::google::cloud::datacatalog::v1::Contacts* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedModifyEntryContacts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ModifyEntryContactsRequest,::google::cloud::datacatalog::v1::Contacts>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTagTemplate() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* streamer) {
                       return this->StreamedCreateTagTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTagTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateTagTemplateRequest,::google::cloud::datacatalog::v1::TagTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTagTemplate() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::GetTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::GetTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* streamer) {
                       return this->StreamedGetTagTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::GetTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTagTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::GetTagTemplateRequest,::google::cloud::datacatalog::v1::TagTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTagTemplate() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest, ::google::cloud::datacatalog::v1::TagTemplate>* streamer) {
                       return this->StreamedUpdateTagTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplate* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTagTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateTagTemplateRequest,::google::cloud::datacatalog::v1::TagTemplate>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTagTemplate : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTagTemplate() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTagTemplate(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTagTemplate() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTagTemplate(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTagTemplate(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteTagTemplateRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTagTemplateField() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* streamer) {
                       return this->StreamedCreateTagTemplateField(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTagTemplateField(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateTagTemplateFieldRequest,::google::cloud::datacatalog::v1::TagTemplateField>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTagTemplateField() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* streamer) {
                       return this->StreamedUpdateTagTemplateField(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTagTemplateField(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateTagTemplateFieldRequest,::google::cloud::datacatalog::v1::TagTemplateField>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RenameTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RenameTagTemplateField() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* streamer) {
                       return this->StreamedRenameTagTemplateField(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RenameTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RenameTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRenameTagTemplateField(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldRequest,::google::cloud::datacatalog::v1::TagTemplateField>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RenameTagTemplateFieldEnumValue : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RenameTagTemplateFieldEnumValue() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest, ::google::cloud::datacatalog::v1::TagTemplateField>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest, ::google::cloud::datacatalog::v1::TagTemplateField>* streamer) {
                       return this->StreamedRenameTagTemplateFieldEnumValue(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RenameTagTemplateFieldEnumValue() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RenameTagTemplateFieldEnumValue(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest* /*request*/, ::google::cloud::datacatalog::v1::TagTemplateField* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRenameTagTemplateFieldEnumValue(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::RenameTagTemplateFieldEnumValueRequest,::google::cloud::datacatalog::v1::TagTemplateField>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTagTemplateField : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTagTemplateField() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTagTemplateField(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTagTemplateField() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTagTemplateField(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTagTemplateField(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteTagTemplateFieldRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTag() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::CreateTagRequest, ::google::cloud::datacatalog::v1::Tag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::CreateTagRequest, ::google::cloud::datacatalog::v1::Tag>* streamer) {
                       return this->StreamedCreateTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::CreateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::CreateTagRequest,::google::cloud::datacatalog::v1::Tag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateTag() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UpdateTagRequest, ::google::cloud::datacatalog::v1::Tag>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UpdateTagRequest, ::google::cloud::datacatalog::v1::Tag>* streamer) {
                       return this->StreamedUpdateTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UpdateTagRequest* /*request*/, ::google::cloud::datacatalog::v1::Tag* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UpdateTagRequest,::google::cloud::datacatalog::v1::Tag>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTag : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTag() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::DeleteTagRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::DeleteTagRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTag(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTag() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTag(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::DeleteTagRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTag(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::DeleteTagRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTags() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ListTagsRequest, ::google::cloud::datacatalog::v1::ListTagsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ListTagsRequest, ::google::cloud::datacatalog::v1::ListTagsResponse>* streamer) {
                       return this->StreamedListTags(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ListTagsRequest* /*request*/, ::google::cloud::datacatalog::v1::ListTagsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTags(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ListTagsRequest,::google::cloud::datacatalog::v1::ListTagsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ReconcileTags : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ReconcileTags() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ReconcileTagsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ReconcileTagsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedReconcileTags(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ReconcileTags() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ReconcileTags(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ReconcileTagsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedReconcileTags(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ReconcileTagsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StarEntry() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::StarEntryRequest, ::google::cloud::datacatalog::v1::StarEntryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::StarEntryRequest, ::google::cloud::datacatalog::v1::StarEntryResponse>* streamer) {
                       return this->StreamedStarEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::StarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::StarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStarEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::StarEntryRequest,::google::cloud::datacatalog::v1::StarEntryResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UnstarEntry : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UnstarEntry() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::UnstarEntryRequest, ::google::cloud::datacatalog::v1::UnstarEntryResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::UnstarEntryRequest, ::google::cloud::datacatalog::v1::UnstarEntryResponse>* streamer) {
                       return this->StreamedUnstarEntry(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UnstarEntry() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UnstarEntry(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::UnstarEntryRequest* /*request*/, ::google::cloud::datacatalog::v1::UnstarEntryResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUnstarEntry(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::UnstarEntryRequest,::google::cloud::datacatalog::v1::UnstarEntryResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::SetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedSetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::SetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::SetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetIamPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetIamPolicy() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::GetIamPolicyRequest, ::google::iam::v1::Policy>* streamer) {
                       return this->StreamedGetIamPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetIamPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetIamPolicy(::grpc::ServerContext* /*context*/, const ::google::iam::v1::GetIamPolicyRequest* /*request*/, ::google::iam::v1::Policy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetIamPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::GetIamPolicyRequest,::google::iam::v1::Policy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_TestIamPermissions : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_TestIamPermissions() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::iam::v1::TestIamPermissionsRequest, ::google::iam::v1::TestIamPermissionsResponse>* streamer) {
                       return this->StreamedTestIamPermissions(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_TestIamPermissions() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status TestIamPermissions(::grpc::ServerContext* /*context*/, const ::google::iam::v1::TestIamPermissionsRequest* /*request*/, ::google::iam::v1::TestIamPermissionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedTestIamPermissions(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::iam::v1::TestIamPermissionsRequest,::google::iam::v1::TestIamPermissionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportEntries : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportEntries() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::datacatalog::v1::ImportEntriesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::datacatalog::v1::ImportEntriesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportEntries(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportEntries() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportEntries(::grpc::ServerContext* /*context*/, const ::google::cloud::datacatalog::v1::ImportEntriesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportEntries(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::datacatalog::v1::ImportEntriesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_SearchCatalog<WithStreamedUnaryMethod_CreateEntryGroup<WithStreamedUnaryMethod_GetEntryGroup<WithStreamedUnaryMethod_UpdateEntryGroup<WithStreamedUnaryMethod_DeleteEntryGroup<WithStreamedUnaryMethod_ListEntryGroups<WithStreamedUnaryMethod_CreateEntry<WithStreamedUnaryMethod_UpdateEntry<WithStreamedUnaryMethod_DeleteEntry<WithStreamedUnaryMethod_GetEntry<WithStreamedUnaryMethod_LookupEntry<WithStreamedUnaryMethod_ListEntries<WithStreamedUnaryMethod_ModifyEntryOverview<WithStreamedUnaryMethod_ModifyEntryContacts<WithStreamedUnaryMethod_CreateTagTemplate<WithStreamedUnaryMethod_GetTagTemplate<WithStreamedUnaryMethod_UpdateTagTemplate<WithStreamedUnaryMethod_DeleteTagTemplate<WithStreamedUnaryMethod_CreateTagTemplateField<WithStreamedUnaryMethod_UpdateTagTemplateField<WithStreamedUnaryMethod_RenameTagTemplateField<WithStreamedUnaryMethod_RenameTagTemplateFieldEnumValue<WithStreamedUnaryMethod_DeleteTagTemplateField<WithStreamedUnaryMethod_CreateTag<WithStreamedUnaryMethod_UpdateTag<WithStreamedUnaryMethod_DeleteTag<WithStreamedUnaryMethod_ListTags<WithStreamedUnaryMethod_ReconcileTags<WithStreamedUnaryMethod_StarEntry<WithStreamedUnaryMethod_UnstarEntry<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_ImportEntries<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_SearchCatalog<WithStreamedUnaryMethod_CreateEntryGroup<WithStreamedUnaryMethod_GetEntryGroup<WithStreamedUnaryMethod_UpdateEntryGroup<WithStreamedUnaryMethod_DeleteEntryGroup<WithStreamedUnaryMethod_ListEntryGroups<WithStreamedUnaryMethod_CreateEntry<WithStreamedUnaryMethod_UpdateEntry<WithStreamedUnaryMethod_DeleteEntry<WithStreamedUnaryMethod_GetEntry<WithStreamedUnaryMethod_LookupEntry<WithStreamedUnaryMethod_ListEntries<WithStreamedUnaryMethod_ModifyEntryOverview<WithStreamedUnaryMethod_ModifyEntryContacts<WithStreamedUnaryMethod_CreateTagTemplate<WithStreamedUnaryMethod_GetTagTemplate<WithStreamedUnaryMethod_UpdateTagTemplate<WithStreamedUnaryMethod_DeleteTagTemplate<WithStreamedUnaryMethod_CreateTagTemplateField<WithStreamedUnaryMethod_UpdateTagTemplateField<WithStreamedUnaryMethod_RenameTagTemplateField<WithStreamedUnaryMethod_RenameTagTemplateFieldEnumValue<WithStreamedUnaryMethod_DeleteTagTemplateField<WithStreamedUnaryMethod_CreateTag<WithStreamedUnaryMethod_UpdateTag<WithStreamedUnaryMethod_DeleteTag<WithStreamedUnaryMethod_ListTags<WithStreamedUnaryMethod_ReconcileTags<WithStreamedUnaryMethod_StarEntry<WithStreamedUnaryMethod_UnstarEntry<WithStreamedUnaryMethod_SetIamPolicy<WithStreamedUnaryMethod_GetIamPolicy<WithStreamedUnaryMethod_TestIamPermissions<WithStreamedUnaryMethod_ImportEntries<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace datacatalog
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fdatacatalog_2fv1_2fdatacatalog_2eproto__INCLUDED
