// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/vmwareengine/v1/vmwareengine.proto
// Original file comments:
// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED

#include "google/cloud/vmwareengine/v1/vmwareengine.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>

namespace google {
namespace cloud {
namespace vmwareengine {
namespace v1 {

// VMwareEngine manages VMware's private clusters in the Cloud.
class VmwareEngine final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.vmwareengine.v1.VmwareEngine";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists `PrivateCloud` resources in a given project and location.
    virtual ::grpc::Status ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> AsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(AsyncListPrivateCloudsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> PrepareAsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(PrepareAsyncListPrivateCloudsRaw(context, request, cq));
    }
    // Retrieves a `PrivateCloud` resource by its resource name.
    virtual ::grpc::Status GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>> AsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>>(AsyncGetPrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>> PrepareAsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>>(PrepareAsyncGetPrivateCloudRaw(context, request, cq));
    }
    // Creates a new `PrivateCloud` resource in a given project and location.
    // Private clouds can only be created in zones, regional private clouds are
    // not supported.
    //
    // Creating a private cloud also creates a [management
    // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
    // for that private cloud.
    virtual ::grpc::Status CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateCloudRaw(context, request, cq));
    }
    // Modifies a `PrivateCloud` resource. Only the following fields can be
    // updated: `description`.
    // Only fields specified in `updateMask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    // Schedules a `PrivateCloud` resource for deletion.
    //
    // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
    // set to `DELETED` and `expireTime` set to the time when deletion is final
    // and can no longer be reversed. The delete operation is marked as done
    // as soon as the `PrivateCloud` is successfully scheduled for deletion
    // (this also applies when `delayHours` is set to zero), and the operation is
    // not kept in pending state until `PrivateCloud` is purged.
    // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
    // the `expireTime` elapses. When `expireTime` is reached, deletion is final
    // and all private cloud resources are irreversibly removed and billing stops.
    // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
    // `PrivateCloud` can be polled using standard `GET` method for the whole
    // period of deletion and purging. It will not be returned only
    // when it is completely purged.
    virtual ::grpc::Status DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateCloudRaw(context, request, cq));
    }
    // Restores a private cloud that was previously scheduled for deletion by
    // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
    // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
    // the time when deletion can no longer be reversed.
    virtual ::grpc::Status UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    // Lists `Cluster` resources in a given private cloud.
    virtual ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    // Retrieves a `Cluster` resource by its resource name.
    virtual ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::google::cloud::vmwareengine::v1::Cluster* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    // Creates a new cluster in a given private cloud.
    // Creating a new cluster provides additional nodes for
    // use in the parent private cloud and requires sufficient [node
    // quota](https://cloud.google.com/vmware-engine/quotas).
    virtual ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    // Modifies a `Cluster` resource. Only the following fields can be updated:
    // `node_type_configs.*.node_count`. Only fields specified in `updateMask` are
    // applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
    // gracefully shut down any workloads running on the cluster before deletion.
    // You cannot delete the management cluster of a private cloud using this
    // method.
    virtual ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    // Lists subnets in a given private cloud.
    virtual ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    // Gets details of a single subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::google::cloud::vmwareengine::v1::Subnet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    // Updates the parameters of a single subnet. Only fields specified in
    // `update_mask` are applied.
    //
    // *Note*: This API is synchronous and always returns a successful
    // `google.longrunning.Operation` (LRO). The returned LRO will only have
    // `done` and `response` fields.
    virtual ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    // Lists node types
    virtual ::grpc::Status ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> AsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(AsyncListNodeTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> PrepareAsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(PrepareAsyncListNodeTypesRaw(context, request, cq));
    }
    // Gets details of a single `NodeType`.
    virtual ::grpc::Status GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::google::cloud::vmwareengine::v1::NodeType* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>> AsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>>(AsyncGetNodeTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>> PrepareAsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>>(PrepareAsyncGetNodeTypeRaw(context, request, cq));
    }
    // Gets details of credentials for NSX appliance.
    virtual ::grpc::Status ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowNsxCredentialsRaw(context, request, cq));
    }
    // Gets details of credentials for Vcenter appliance.
    virtual ::grpc::Status ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    // Resets credentials of the NSX appliance.
    virtual ::grpc::Status ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResetNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResetNsxCredentialsRaw(context, request, cq));
    }
    // Resets credentials of the Vcenter appliance.
    virtual ::grpc::Status ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    // Creates a new HCX activation key in a given private cloud.
    virtual ::grpc::Status CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    // Lists `HcxActivationKey` resources in a given private cloud.
    virtual ::grpc::Status ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> AsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(AsyncListHcxActivationKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> PrepareAsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(PrepareAsyncListHcxActivationKeysRaw(context, request, cq));
    }
    // Retrieves a `HcxActivationKey` resource by its resource name.
    virtual ::grpc::Status GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>> AsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(AsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>> PrepareAsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(PrepareAsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    // Retrieves a `NetworkPolicy` resource by its resource name.
    virtual ::grpc::Status GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>> AsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(AsyncGetNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>> PrepareAsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(PrepareAsyncGetNetworkPolicyRaw(context, request, cq));
    }
    // Lists `NetworkPolicy` resources in a specified project and location.
    virtual ::grpc::Status ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> AsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(AsyncListNetworkPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> PrepareAsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(PrepareAsyncListNetworkPoliciesRaw(context, request, cq));
    }
    // Creates a new network policy in a given VMware Engine network of a
    // project and location (region). A new network policy cannot be created if
    // another network policy already exists in the same scope.
    virtual ::grpc::Status CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    // Modifies a `NetworkPolicy` resource. Only the following fields can be
    // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
    // Only fields specified in `updateMask` are applied. When updating a network
    // policy, the external IP network service can only be disabled if there are
    // no external IP addresses present in the scope of the policy. Also, a
    // `NetworkService` cannot be updated when `NetworkService.state` is set
    // to `RECONCILING`.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
    // when `NetworkService.state` is set to `RECONCILING` for either its external
    // IP or internet access service.
    virtual ::grpc::Status DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    // Creates a new VMware Engine network that can be used by a private cloud.
    virtual ::grpc::Status CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    // Modifies a VMware Engine network resource. Only the following fields can be
    // updated: `description`. Only fields specified in `updateMask` are
    // applied.
    virtual ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
    // Engine network after all resources that refer to it are deleted. For
    // example, a private cloud, a network peering, and a network policy can all
    // refer to the same VMware Engine network.
    virtual ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
    // resource contains details of the VMware Engine network, such as its VMware
    // Engine network type, peered networks in a service project, and state
    // (for example, `CREATING`, `ACTIVE`, `DELETING`).
    virtual ::grpc::Status GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> AsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(AsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> PrepareAsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(PrepareAsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    // Lists `VmwareEngineNetwork` resources in a given project and location.
    virtual ::grpc::Status ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> AsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(AsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> PrepareAsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(PrepareAsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    // Creates a new private connection that can be used for accessing private
    // Clouds.
    virtual ::grpc::Status CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    // Retrieves a `PrivateConnection` resource by its resource name. The resource
    // contains details of the private connection, such as connected
    // network, routing mode and state.
    virtual ::grpc::Status GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>> AsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>>(AsyncGetPrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>> PrepareAsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>>(PrepareAsyncGetPrivateConnectionRaw(context, request, cq));
    }
    // Lists `PrivateConnection` resources in a given project and location.
    virtual ::grpc::Status ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> AsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(AsyncListPrivateConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> PrepareAsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(PrepareAsyncListPrivateConnectionsRaw(context, request, cq));
    }
    // Modifies a `PrivateConnection` resource. Only `description` and
    // `routing_mode` fields can be updated. Only fields specified in `updateMask`
    // are applied.
    virtual ::grpc::Status UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    // Deletes a `PrivateConnection` resource. When a private connection is
    // deleted for a VMware Engine network, the connected network becomes
    // inaccessible to that VMware Engine network.
    virtual ::grpc::Status DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    // Lists the private connection routes exchanged over a peering connection.
    virtual ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> AsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(AsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> PrepareAsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(PrepareAsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists `PrivateCloud` resources in a given project and location.
      virtual void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `PrivateCloud` resource by its resource name.
      virtual void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `PrivateCloud` resource in a given project and location.
      // Private clouds can only be created in zones, regional private clouds are
      // not supported.
      //
      // Creating a private cloud also creates a [management
      // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
      // for that private cloud.
      virtual void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `PrivateCloud` resource. Only the following fields can be
      // updated: `description`.
      // Only fields specified in `updateMask` are applied.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Schedules a `PrivateCloud` resource for deletion.
      //
      // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
      // set to `DELETED` and `expireTime` set to the time when deletion is final
      // and can no longer be reversed. The delete operation is marked as done
      // as soon as the `PrivateCloud` is successfully scheduled for deletion
      // (this also applies when `delayHours` is set to zero), and the operation is
      // not kept in pending state until `PrivateCloud` is purged.
      // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
      // the `expireTime` elapses. When `expireTime` is reached, deletion is final
      // and all private cloud resources are irreversibly removed and billing stops.
      // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
      // `PrivateCloud` can be polled using standard `GET` method for the whole
      // period of deletion and purging. It will not be returned only
      // when it is completely purged.
      virtual void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Restores a private cloud that was previously scheduled for deletion by
      // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
      // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
      // the time when deletion can no longer be reversed.
      virtual void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `Cluster` resources in a given private cloud.
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `Cluster` resource by its resource name.
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new cluster in a given private cloud.
      // Creating a new cluster provides additional nodes for
      // use in the parent private cloud and requires sufficient [node
      // quota](https://cloud.google.com/vmware-engine/quotas).
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `Cluster` resource. Only the following fields can be updated:
      // `node_type_configs.*.node_count`. Only fields specified in `updateMask` are
      // applied.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
      // gracefully shut down any workloads running on the cluster before deletion.
      // You cannot delete the management cluster of a private cloud using this
      // method.
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists subnets in a given private cloud.
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single subnet.
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the parameters of a single subnet. Only fields specified in
      // `update_mask` are applied.
      //
      // *Note*: This API is synchronous and always returns a successful
      // `google.longrunning.Operation` (LRO). The returned LRO will only have
      // `done` and `response` fields.
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists node types
      virtual void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single `NodeType`.
      virtual void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of credentials for NSX appliance.
      virtual void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of credentials for Vcenter appliance.
      virtual void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets credentials of the NSX appliance.
      virtual void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Resets credentials of the Vcenter appliance.
      virtual void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new HCX activation key in a given private cloud.
      virtual void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `HcxActivationKey` resources in a given private cloud.
      virtual void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `HcxActivationKey` resource by its resource name.
      virtual void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `NetworkPolicy` resource by its resource name.
      virtual void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `NetworkPolicy` resources in a specified project and location.
      virtual void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new network policy in a given VMware Engine network of a
      // project and location (region). A new network policy cannot be created if
      // another network policy already exists in the same scope.
      virtual void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `NetworkPolicy` resource. Only the following fields can be
      // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
      // Only fields specified in `updateMask` are applied. When updating a network
      // policy, the external IP network service can only be disabled if there are
      // no external IP addresses present in the scope of the policy. Also, a
      // `NetworkService` cannot be updated when `NetworkService.state` is set
      // to `RECONCILING`.
      //
      // During operation processing, the resource is temporarily in the `ACTIVE`
      // state before the operation fully completes. For that period of time, you
      // can't update the resource. Use the operation status to determine when the
      // processing fully completes.
      virtual void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
      // when `NetworkService.state` is set to `RECONCILING` for either its external
      // IP or internet access service.
      virtual void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new VMware Engine network that can be used by a private cloud.
      virtual void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a VMware Engine network resource. Only the following fields can be
      // updated: `description`. Only fields specified in `updateMask` are
      // applied.
      virtual void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
      // Engine network after all resources that refer to it are deleted. For
      // example, a private cloud, a network peering, and a network policy can all
      // refer to the same VMware Engine network.
      virtual void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
      // resource contains details of the VMware Engine network, such as its VMware
      // Engine network type, peered networks in a service project, and state
      // (for example, `CREATING`, `ACTIVE`, `DELETING`).
      virtual void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `VmwareEngineNetwork` resources in a given project and location.
      virtual void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new private connection that can be used for accessing private
      // Clouds.
      virtual void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves a `PrivateConnection` resource by its resource name. The resource
      // contains details of the private connection, such as connected
      // network, routing mode and state.
      virtual void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists `PrivateConnection` resources in a given project and location.
      virtual void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Modifies a `PrivateConnection` resource. Only `description` and
      // `routing_mode` fields can be updated. Only fields specified in `updateMask`
      // are applied.
      virtual void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a `PrivateConnection` resource. When a private connection is
      // deleted for a VMware Engine network, the connected network becomes
      // inaccessible to that VMware Engine network.
      virtual void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the private connection routes exchanged over a peering connection.
      virtual void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* AsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* PrepareAsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>* AsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateCloud>* PrepareAsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* AsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* PrepareAsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>* AsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NodeType>* PrepareAsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* AsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* PrepareAsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>* AsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::HcxActivationKey>* PrepareAsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>* AsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::NetworkPolicy>* PrepareAsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* AsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* PrepareAsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* AsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* PrepareAsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* AsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* PrepareAsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>* AsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::PrivateConnection>* PrepareAsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* AsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* PrepareAsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* AsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* PrepareAsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> AsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(AsyncListPrivateCloudsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>> PrepareAsyncListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>>(PrepareAsyncListPrivateCloudsRaw(context, request, cq));
    }
    ::grpc::Status GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>> AsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>>(AsyncGetPrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>> PrepareAsyncGetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>>(PrepareAsyncGetPrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeletePrivateCloudRaw(context, request, cq));
    }
    ::grpc::Status ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>> AsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(AsyncListClustersRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>> PrepareAsyncListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>>(PrepareAsyncListClustersRaw(context, request, cq));
    }
    ::grpc::Status GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::google::cloud::vmwareengine::v1::Cluster* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>> AsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>>(AsyncGetClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>> PrepareAsyncGetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>>(PrepareAsyncGetClusterRaw(context, request, cq));
    }
    ::grpc::Status CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClusterRaw(context, request, cq));
    }
    ::grpc::Status UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateClusterRaw(context, request, cq));
    }
    ::grpc::Status DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClusterRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClusterRaw(context, request, cq));
    }
    ::grpc::Status ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> AsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(AsyncListSubnetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>> PrepareAsyncListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>>(PrepareAsyncListSubnetsRaw(context, request, cq));
    }
    ::grpc::Status GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::google::cloud::vmwareengine::v1::Subnet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>> AsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>>(AsyncGetSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>> PrepareAsyncGetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>>(PrepareAsyncGetSubnetRaw(context, request, cq));
    }
    ::grpc::Status UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateSubnetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateSubnetRaw(context, request, cq));
    }
    ::grpc::Status ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> AsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(AsyncListNodeTypesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>> PrepareAsyncListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>>(PrepareAsyncListNodeTypesRaw(context, request, cq));
    }
    ::grpc::Status GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::google::cloud::vmwareengine::v1::NodeType* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>> AsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>>(AsyncGetNodeTypeRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>> PrepareAsyncGetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>>(PrepareAsyncGetNodeTypeRaw(context, request, cq));
    }
    ::grpc::Status ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowNsxCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::google::cloud::vmwareengine::v1::Credentials* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> AsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(AsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>> PrepareAsyncShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>>(PrepareAsyncShowVcenterCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResetNsxCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResetNsxCredentialsRaw(context, request, cq));
    }
    ::grpc::Status ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncResetVcenterCredentialsRaw(context, request, cq));
    }
    ::grpc::Status CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateHcxActivationKeyRaw(context, request, cq));
    }
    ::grpc::Status ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> AsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(AsyncListHcxActivationKeysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>> PrepareAsyncListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>>(PrepareAsyncListHcxActivationKeysRaw(context, request, cq));
    }
    ::grpc::Status GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>> AsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(AsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>> PrepareAsyncGetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>>(PrepareAsyncGetHcxActivationKeyRaw(context, request, cq));
    }
    ::grpc::Status GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>> AsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(AsyncGetNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>> PrepareAsyncGetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>>(PrepareAsyncGetNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> AsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(AsyncListNetworkPoliciesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>> PrepareAsyncListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>>(PrepareAsyncListNetworkPoliciesRaw(context, request, cq));
    }
    ::grpc::Status CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteNetworkPolicyRaw(context, request, cq));
    }
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> AsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(AsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>> PrepareAsyncGetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>>(PrepareAsyncGetVmwareEngineNetworkRaw(context, request, cq));
    }
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> AsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(AsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>> PrepareAsyncListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>>(PrepareAsyncListVmwareEngineNetworksRaw(context, request, cq));
    }
    ::grpc::Status CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreatePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>> AsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>>(AsyncGetPrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>> PrepareAsyncGetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>>(PrepareAsyncGetPrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> AsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(AsyncListPrivateConnectionsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>> PrepareAsyncListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>>(PrepareAsyncListPrivateConnectionsRaw(context, request, cq));
    }
    ::grpc::Status UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeletePrivateConnectionRaw(context, request, cq));
    }
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> AsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(AsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>> PrepareAsyncListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>>(PrepareAsyncListPrivateConnectionPeeringRoutesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateClouds(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, std::function<void(::grpc::Status)>) override;
      void GetPrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeletePrivateCloud(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClusters(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, std::function<void(::grpc::Status)>) override;
      void GetCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteCluster(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSubnets(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, std::function<void(::grpc::Status)>) override;
      void GetSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateSubnet(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNodeTypes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, std::function<void(::grpc::Status)>) override;
      void GetNodeType(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) override;
      void ShowNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, std::function<void(::grpc::Status)>) override;
      void ShowVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetNsxCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ResetVcenterCredentials(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListHcxActivationKeys(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, std::function<void(::grpc::Status)>) override;
      void GetHcxActivationKey(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, std::function<void(::grpc::Status)>) override;
      void GetNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListNetworkPolicies(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteNetworkPolicy(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, std::function<void(::grpc::Status)>) override;
      void GetVmwareEngineNetwork(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVmwareEngineNetworks(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, std::function<void(::grpc::Status)>) override;
      void GetPrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateConnections(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeletePrivateConnection(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListPrivateConnectionPeeringRoutes(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* AsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* PrepareAsyncListPrivateCloudsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>* AsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateCloud>* PrepareAsyncGetPrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeletePrivateCloudRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>* AsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListClustersResponse>* PrepareAsyncListClustersRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>* AsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Cluster>* PrepareAsyncGetClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClusterRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* AsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* PrepareAsyncListSubnetsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>* AsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Subnet>* PrepareAsyncGetSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateSubnetRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* AsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* PrepareAsyncListNodeTypesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>* AsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NodeType>* PrepareAsyncGetNodeTypeRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* AsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::Credentials>* PrepareAsyncShowVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResetNsxCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncResetVcenterCredentialsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* AsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* PrepareAsyncListHcxActivationKeysRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>* AsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::HcxActivationKey>* PrepareAsyncGetHcxActivationKeyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>* AsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::NetworkPolicy>* PrepareAsyncGetNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* AsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* PrepareAsyncListNetworkPoliciesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteNetworkPolicyRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* AsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* PrepareAsyncGetVmwareEngineNetworkRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* AsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* PrepareAsyncListVmwareEngineNetworksRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>* AsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::PrivateConnection>* PrepareAsyncGetPrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* AsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* PrepareAsyncListPrivateConnectionsRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeletePrivateConnectionRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* AsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* PrepareAsyncListPrivateConnectionPeeringRoutesRaw(::grpc::ClientContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateClouds_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeletePrivateCloud_;
    const ::grpc::internal::RpcMethod rpcmethod_ListClusters_;
    const ::grpc::internal::RpcMethod rpcmethod_GetCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteCluster_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSubnets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSubnet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNodeTypes_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNodeType_;
    const ::grpc::internal::RpcMethod rpcmethod_ShowNsxCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ShowVcenterCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetNsxCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_ResetVcenterCredentials_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateHcxActivationKey_;
    const ::grpc::internal::RpcMethod rpcmethod_ListHcxActivationKeys_;
    const ::grpc::internal::RpcMethod rpcmethod_GetHcxActivationKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListNetworkPolicies_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteNetworkPolicy_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVmwareEngineNetwork_;
    const ::grpc::internal::RpcMethod rpcmethod_ListVmwareEngineNetworks_;
    const ::grpc::internal::RpcMethod rpcmethod_CreatePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateConnections_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePrivateConnection_;
    const ::grpc::internal::RpcMethod rpcmethod_ListPrivateConnectionPeeringRoutes_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists `PrivateCloud` resources in a given project and location.
    virtual ::grpc::Status ListPrivateClouds(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response);
    // Retrieves a `PrivateCloud` resource by its resource name.
    virtual ::grpc::Status GetPrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response);
    // Creates a new `PrivateCloud` resource in a given project and location.
    // Private clouds can only be created in zones, regional private clouds are
    // not supported.
    //
    // Creating a private cloud also creates a [management
    // cluster](https://cloud.google.com/vmware-engine/docs/concepts-vmware-components)
    // for that private cloud.
    virtual ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `PrivateCloud` resource. Only the following fields can be
    // updated: `description`.
    // Only fields specified in `updateMask` are applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Schedules a `PrivateCloud` resource for deletion.
    //
    // A `PrivateCloud` resource scheduled for deletion has `PrivateCloud.state`
    // set to `DELETED` and `expireTime` set to the time when deletion is final
    // and can no longer be reversed. The delete operation is marked as done
    // as soon as the `PrivateCloud` is successfully scheduled for deletion
    // (this also applies when `delayHours` is set to zero), and the operation is
    // not kept in pending state until `PrivateCloud` is purged.
    // `PrivateCloud` can be restored using `UndeletePrivateCloud` method before
    // the `expireTime` elapses. When `expireTime` is reached, deletion is final
    // and all private cloud resources are irreversibly removed and billing stops.
    // During the final removal process, `PrivateCloud.state` is set to `PURGING`.
    // `PrivateCloud` can be polled using standard `GET` method for the whole
    // period of deletion and purging. It will not be returned only
    // when it is completely purged.
    virtual ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Restores a private cloud that was previously scheduled for deletion by
    // `DeletePrivateCloud`. A `PrivateCloud` resource scheduled for deletion has
    // `PrivateCloud.state` set to `DELETED` and `PrivateCloud.expireTime` set to
    // the time when deletion can no longer be reversed.
    virtual ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response);
    // Lists `Cluster` resources in a given private cloud.
    virtual ::grpc::Status ListClusters(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response);
    // Retrieves a `Cluster` resource by its resource name.
    virtual ::grpc::Status GetCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response);
    // Creates a new cluster in a given private cloud.
    // Creating a new cluster provides additional nodes for
    // use in the parent private cloud and requires sufficient [node
    // quota](https://cloud.google.com/vmware-engine/quotas).
    virtual ::grpc::Status CreateCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `Cluster` resource. Only the following fields can be updated:
    // `node_type_configs.*.node_count`. Only fields specified in `updateMask` are
    // applied.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `Cluster` resource. To avoid unintended data loss, migrate or
    // gracefully shut down any workloads running on the cluster before deletion.
    // You cannot delete the management cluster of a private cloud using this
    // method.
    virtual ::grpc::Status DeleteCluster(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response);
    // Lists subnets in a given private cloud.
    virtual ::grpc::Status ListSubnets(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response);
    // Gets details of a single subnet.
    virtual ::grpc::Status GetSubnet(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response);
    // Updates the parameters of a single subnet. Only fields specified in
    // `update_mask` are applied.
    //
    // *Note*: This API is synchronous and always returns a successful
    // `google.longrunning.Operation` (LRO). The returned LRO will only have
    // `done` and `response` fields.
    virtual ::grpc::Status UpdateSubnet(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response);
    // Lists node types
    virtual ::grpc::Status ListNodeTypes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response);
    // Gets details of a single `NodeType`.
    virtual ::grpc::Status GetNodeType(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response);
    // Gets details of credentials for NSX appliance.
    virtual ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response);
    // Gets details of credentials for Vcenter appliance.
    virtual ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response);
    // Resets credentials of the NSX appliance.
    virtual ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response);
    // Resets credentials of the Vcenter appliance.
    virtual ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response);
    // Creates a new HCX activation key in a given private cloud.
    virtual ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response);
    // Lists `HcxActivationKey` resources in a given private cloud.
    virtual ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response);
    // Retrieves a `HcxActivationKey` resource by its resource name.
    virtual ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response);
    // Retrieves a `NetworkPolicy` resource by its resource name.
    virtual ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response);
    // Lists `NetworkPolicy` resources in a specified project and location.
    virtual ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response);
    // Creates a new network policy in a given VMware Engine network of a
    // project and location (region). A new network policy cannot be created if
    // another network policy already exists in the same scope.
    virtual ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Modifies a `NetworkPolicy` resource. Only the following fields can be
    // updated: `internet_access`, `external_ip`, `edge_services_cidr`.
    // Only fields specified in `updateMask` are applied. When updating a network
    // policy, the external IP network service can only be disabled if there are
    // no external IP addresses present in the scope of the policy. Also, a
    // `NetworkService` cannot be updated when `NetworkService.state` is set
    // to `RECONCILING`.
    //
    // During operation processing, the resource is temporarily in the `ACTIVE`
    // state before the operation fully completes. For that period of time, you
    // can't update the resource. Use the operation status to determine when the
    // processing fully completes.
    virtual ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `NetworkPolicy` resource. A network policy cannot be deleted
    // when `NetworkService.state` is set to `RECONCILING` for either its external
    // IP or internet access service.
    virtual ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response);
    // Creates a new VMware Engine network that can be used by a private cloud.
    virtual ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Modifies a VMware Engine network resource. Only the following fields can be
    // updated: `description`. Only fields specified in `updateMask` are
    // applied.
    virtual ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `VmwareEngineNetwork` resource. You can only delete a VMware
    // Engine network after all resources that refer to it are deleted. For
    // example, a private cloud, a network peering, and a network policy can all
    // refer to the same VMware Engine network.
    virtual ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a `VmwareEngineNetwork` resource by its resource name. The
    // resource contains details of the VMware Engine network, such as its VMware
    // Engine network type, peered networks in a service project, and state
    // (for example, `CREATING`, `ACTIVE`, `DELETING`).
    virtual ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response);
    // Lists `VmwareEngineNetwork` resources in a given project and location.
    virtual ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response);
    // Creates a new private connection that can be used for accessing private
    // Clouds.
    virtual ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Retrieves a `PrivateConnection` resource by its resource name. The resource
    // contains details of the private connection, such as connected
    // network, routing mode and state.
    virtual ::grpc::Status GetPrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response);
    // Lists `PrivateConnection` resources in a given project and location.
    virtual ::grpc::Status ListPrivateConnections(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response);
    // Modifies a `PrivateConnection` resource. Only `description` and
    // `routing_mode` fields can be updated. Only fields specified in `updateMask`
    // are applied.
    virtual ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Deletes a `PrivateConnection` resource. When a private connection is
    // deleted for a VMware Engine network, the connected network becomes
    // inaccessible to that VMware Engine network.
    virtual ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response);
    // Lists the private connection routes exchanged over a peering connection.
    virtual ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateClouds(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::PrivateCloud>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeletePrivateCloud(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClusters() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListClustersResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetCluster() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Cluster>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateCluster() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSubnets() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSubnet() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Subnet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodeTypes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNodeType() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeType(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::NodeType>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowNsxCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Credentials>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowVcenterCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::Credentials>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetNsxCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetVcenterCredentials(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHcxActivationKey(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHcxActivationKeys(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHcxActivationKey(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::HcxActivationKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::NetworkPolicy>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPolicies(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(26);
    }
    ~WithAsyncMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodAsync(27);
    }
    ~WithAsyncMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPolicy(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(28);
    }
    ~WithAsyncMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(29);
    }
    ~WithAsyncMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(30);
    }
    ~WithAsyncMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodAsync(31);
    }
    ~WithAsyncMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVmwareEngineNetwork(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodAsync(32);
    }
    ~WithAsyncMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVmwareEngineNetworks(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(33);
    }
    ~WithAsyncMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodAsync(34);
    }
    ~WithAsyncMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::PrivateConnection>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodAsync(35);
    }
    ~WithAsyncMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnections(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(36);
    }
    ~WithAsyncMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodAsync(37);
    }
    ~WithAsyncMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateConnection(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodAsync(38);
    }
    ~WithAsyncMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListPrivateClouds<WithAsyncMethod_GetPrivateCloud<WithAsyncMethod_CreatePrivateCloud<WithAsyncMethod_UpdatePrivateCloud<WithAsyncMethod_DeletePrivateCloud<WithAsyncMethod_UndeletePrivateCloud<WithAsyncMethod_ListClusters<WithAsyncMethod_GetCluster<WithAsyncMethod_CreateCluster<WithAsyncMethod_UpdateCluster<WithAsyncMethod_DeleteCluster<WithAsyncMethod_ListSubnets<WithAsyncMethod_GetSubnet<WithAsyncMethod_UpdateSubnet<WithAsyncMethod_ListNodeTypes<WithAsyncMethod_GetNodeType<WithAsyncMethod_ShowNsxCredentials<WithAsyncMethod_ShowVcenterCredentials<WithAsyncMethod_ResetNsxCredentials<WithAsyncMethod_ResetVcenterCredentials<WithAsyncMethod_CreateHcxActivationKey<WithAsyncMethod_ListHcxActivationKeys<WithAsyncMethod_GetHcxActivationKey<WithAsyncMethod_GetNetworkPolicy<WithAsyncMethod_ListNetworkPolicies<WithAsyncMethod_CreateNetworkPolicy<WithAsyncMethod_UpdateNetworkPolicy<WithAsyncMethod_DeleteNetworkPolicy<WithAsyncMethod_CreateVmwareEngineNetwork<WithAsyncMethod_UpdateVmwareEngineNetwork<WithAsyncMethod_DeleteVmwareEngineNetwork<WithAsyncMethod_GetVmwareEngineNetwork<WithAsyncMethod_ListVmwareEngineNetworks<WithAsyncMethod_CreatePrivateConnection<WithAsyncMethod_GetPrivateConnection<WithAsyncMethod_ListPrivateConnections<WithAsyncMethod_UpdatePrivateConnection<WithAsyncMethod_DeletePrivateConnection<WithAsyncMethod_ListPrivateConnectionPeeringRoutes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* response) { return this->ListPrivateClouds(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateClouds(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateClouds(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* request, ::google::cloud::vmwareengine::v1::PrivateCloud* response) { return this->GetPrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_GetPrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->CreatePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->DeletePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* request, ::google::longrunning::Operation* response) { return this->UndeletePrivateCloud(context, request, response); }));}
    void SetMessageAllocatorFor_UndeletePrivateCloud(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListClustersRequest* request, ::google::cloud::vmwareengine::v1::ListClustersResponse* response) { return this->ListClusters(context, request, response); }));}
    void SetMessageAllocatorFor_ListClusters(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetClusterRequest* request, ::google::cloud::vmwareengine::v1::Cluster* response) { return this->GetCluster(context, request, response); }));}
    void SetMessageAllocatorFor_GetCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* request, ::google::longrunning::Operation* response) { return this->CreateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_CreateCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* request, ::google::longrunning::Operation* response) { return this->UpdateCluster(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* request, ::google::longrunning::Operation* response) { return this->DeleteCluster(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteCluster(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* request, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* response) { return this->ListSubnets(context, request, response); }));}
    void SetMessageAllocatorFor_ListSubnets(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* request, ::google::cloud::vmwareengine::v1::Subnet* response) { return this->GetSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_GetSubnet(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* request, ::google::longrunning::Operation* response) { return this->UpdateSubnet(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSubnet(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* request, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* response) { return this->ListNodeTypes(context, request, response); }));}
    void SetMessageAllocatorFor_ListNodeTypes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodeTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNodeType() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* request, ::google::cloud::vmwareengine::v1::NodeType* response) { return this->GetNodeType(context, request, response); }));}
    void SetMessageAllocatorFor_GetNodeType(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeType(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response) { return this->ShowNsxCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ShowNsxCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* request, ::google::cloud::vmwareengine::v1::Credentials* response) { return this->ShowVcenterCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ShowVcenterCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* request, ::google::longrunning::Operation* response) { return this->ResetNsxCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ResetNsxCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* request, ::google::longrunning::Operation* response) { return this->ResetVcenterCredentials(context, request, response); }));}
    void SetMessageAllocatorFor_ResetVcenterCredentials(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* request, ::google::longrunning::Operation* response) { return this->CreateHcxActivationKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateHcxActivationKey(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* request, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* response) { return this->ListHcxActivationKeys(context, request, response); }));}
    void SetMessageAllocatorFor_ListHcxActivationKeys(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHcxActivationKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* request, ::google::cloud::vmwareengine::v1::HcxActivationKey* response) { return this->GetHcxActivationKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetHcxActivationKey(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* request, ::google::cloud::vmwareengine::v1::NetworkPolicy* response) { return this->GetNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_GetNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* request, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* response) { return this->ListNetworkPolicies(context, request, response); }));}
    void SetMessageAllocatorFor_ListNetworkPolicies(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->CreateNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->UpdateNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(26);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* request, ::google::longrunning::Operation* response) { return this->DeleteNetworkPolicy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteNetworkPolicy(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(27);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->CreateVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_CreateVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(28);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->UpdateVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(29);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* request, ::google::longrunning::Operation* response) { return this->DeleteVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(30);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* request, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* response) { return this->GetVmwareEngineNetwork(context, request, response); }));}
    void SetMessageAllocatorFor_GetVmwareEngineNetwork(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(31);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* request, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* response) { return this->ListVmwareEngineNetworks(context, request, response); }));}
    void SetMessageAllocatorFor_ListVmwareEngineNetworks(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(32);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVmwareEngineNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->CreatePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_CreatePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(33);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* request, ::google::cloud::vmwareengine::v1::PrivateConnection* response) { return this->GetPrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_GetPrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(34);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* response) { return this->ListPrivateConnections(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateConnections(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(35);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(36);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* request, ::google::longrunning::Operation* response) { return this->DeletePrivateConnection(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePrivateConnection(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(37);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* request, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* response) { return this->ListPrivateConnectionPeeringRoutes(context, request, response); }));}
    void SetMessageAllocatorFor_ListPrivateConnectionPeeringRoutes(
        ::grpc::MessageAllocator< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(38);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnectionPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListPrivateClouds<WithCallbackMethod_GetPrivateCloud<WithCallbackMethod_CreatePrivateCloud<WithCallbackMethod_UpdatePrivateCloud<WithCallbackMethod_DeletePrivateCloud<WithCallbackMethod_UndeletePrivateCloud<WithCallbackMethod_ListClusters<WithCallbackMethod_GetCluster<WithCallbackMethod_CreateCluster<WithCallbackMethod_UpdateCluster<WithCallbackMethod_DeleteCluster<WithCallbackMethod_ListSubnets<WithCallbackMethod_GetSubnet<WithCallbackMethod_UpdateSubnet<WithCallbackMethod_ListNodeTypes<WithCallbackMethod_GetNodeType<WithCallbackMethod_ShowNsxCredentials<WithCallbackMethod_ShowVcenterCredentials<WithCallbackMethod_ResetNsxCredentials<WithCallbackMethod_ResetVcenterCredentials<WithCallbackMethod_CreateHcxActivationKey<WithCallbackMethod_ListHcxActivationKeys<WithCallbackMethod_GetHcxActivationKey<WithCallbackMethod_GetNetworkPolicy<WithCallbackMethod_ListNetworkPolicies<WithCallbackMethod_CreateNetworkPolicy<WithCallbackMethod_UpdateNetworkPolicy<WithCallbackMethod_DeleteNetworkPolicy<WithCallbackMethod_CreateVmwareEngineNetwork<WithCallbackMethod_UpdateVmwareEngineNetwork<WithCallbackMethod_DeleteVmwareEngineNetwork<WithCallbackMethod_GetVmwareEngineNetwork<WithCallbackMethod_ListVmwareEngineNetworks<WithCallbackMethod_CreatePrivateConnection<WithCallbackMethod_GetPrivateConnection<WithCallbackMethod_ListPrivateConnections<WithCallbackMethod_UpdatePrivateConnection<WithCallbackMethod_DeletePrivateConnection<WithCallbackMethod_ListPrivateConnectionPeeringRoutes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClusters() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetCluster() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateCluster() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSubnets() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSubnet() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNodeType() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(26);
    }
    ~WithGenericMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodGeneric(27);
    }
    ~WithGenericMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(28);
    }
    ~WithGenericMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(29);
    }
    ~WithGenericMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(30);
    }
    ~WithGenericMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodGeneric(31);
    }
    ~WithGenericMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodGeneric(32);
    }
    ~WithGenericMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(33);
    }
    ~WithGenericMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(34);
    }
    ~WithGenericMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodGeneric(35);
    }
    ~WithGenericMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(36);
    }
    ~WithGenericMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodGeneric(37);
    }
    ~WithGenericMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodGeneric(38);
    }
    ~WithGenericMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateClouds(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClusters() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClusters(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetCluster() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteCluster(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSubnets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSubnet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNodeTypes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNodeType() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNodeType(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowNsxCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestShowVcenterCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetNsxCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestResetVcenterCredentials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateHcxActivationKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListHcxActivationKeys(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetHcxActivationKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListNetworkPolicies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(26);
    }
    ~WithRawMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(26, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodRaw(27);
    }
    ~WithRawMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteNetworkPolicy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(27, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(28);
    }
    ~WithRawMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(28, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(29);
    }
    ~WithRawMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(29, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(30);
    }
    ~WithRawMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(30, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRaw(31);
    }
    ~WithRawMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(31, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodRaw(32);
    }
    ~WithRawMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVmwareEngineNetworks(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(32, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(33);
    }
    ~WithRawMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreatePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(33, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodRaw(34);
    }
    ~WithRawMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(34, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodRaw(35);
    }
    ~WithRawMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnections(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(35, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(36);
    }
    ~WithRawMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(36, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodRaw(37);
    }
    ~WithRawMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePrivateConnection(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(37, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodRaw(38);
    }
    ~WithRawMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(38, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateClouds(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateClouds(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeletePrivateCloud(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeletePrivateCloud(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClusters() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClusters(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClusters(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetCluster() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateCluster() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteCluster(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteCluster(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSubnets() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSubnets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSubnets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSubnet() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSubnet(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSubnet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNodeTypes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNodeTypes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNodeType() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNodeType(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNodeType(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ShowNsxCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ShowVcenterCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ShowVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetNsxCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetNsxCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ResetVcenterCredentials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ResetVcenterCredentials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateHcxActivationKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListHcxActivationKeys(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListHcxActivationKeys(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetHcxActivationKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetHcxActivationKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListNetworkPolicies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListNetworkPolicies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(26,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodRawCallback(27,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteNetworkPolicy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteNetworkPolicy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(28,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(29,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(30,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodRawCallback(31,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVmwareEngineNetwork(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVmwareEngineNetwork(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodRawCallback(32,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVmwareEngineNetworks(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVmwareEngineNetworks(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(33,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreatePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(34,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodRawCallback(35,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateConnections(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnections(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(36,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodRawCallback(37,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePrivateConnection(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePrivateConnection(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodRawCallback(38,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListPrivateConnectionPeeringRoutes(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListPrivateConnectionPeeringRoutes(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateClouds : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateClouds() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* streamer) {
                       return this->StreamedListPrivateClouds(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateClouds() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateClouds(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateClouds(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateCloudsRequest,::google::cloud::vmwareengine::v1::ListPrivateCloudsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest, ::google::cloud::vmwareengine::v1::PrivateCloud>* streamer) {
                       return this->StreamedGetPrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateCloud* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetPrivateCloudRequest,::google::cloud::vmwareengine::v1::PrivateCloud>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreatePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdatePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeletePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeletePrivateCloud : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeletePrivateCloud() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeletePrivateCloud(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeletePrivateCloud() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeletePrivateCloud(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeletePrivateCloud(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UndeletePrivateCloudRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClusters : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClusters() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListClustersRequest, ::google::cloud::vmwareengine::v1::ListClustersResponse>* streamer) {
                       return this->StreamedListClusters(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClusters() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClusters(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListClustersRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListClustersResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClusters(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListClustersRequest,::google::cloud::vmwareengine::v1::ListClustersResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetCluster() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetClusterRequest, ::google::cloud::vmwareengine::v1::Cluster>* streamer) {
                       return this->StreamedGetCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetClusterRequest* /*request*/, ::google::cloud::vmwareengine::v1::Cluster* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetClusterRequest,::google::cloud::vmwareengine::v1::Cluster>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateCluster() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateCluster() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteCluster : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteCluster() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteClusterRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteCluster(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteCluster() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteCluster(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteClusterRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteCluster(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteClusterRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSubnets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSubnets() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListSubnetsRequest, ::google::cloud::vmwareengine::v1::ListSubnetsResponse>* streamer) {
                       return this->StreamedListSubnets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSubnets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSubnets(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListSubnetsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListSubnetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSubnets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListSubnetsRequest,::google::cloud::vmwareengine::v1::ListSubnetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSubnet() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetSubnetRequest, ::google::cloud::vmwareengine::v1::Subnet>* streamer) {
                       return this->StreamedGetSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetSubnetRequest* /*request*/, ::google::cloud::vmwareengine::v1::Subnet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetSubnetRequest,::google::cloud::vmwareengine::v1::Subnet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSubnet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSubnet() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateSubnetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateSubnet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSubnet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSubnet(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateSubnetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSubnet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateSubnetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNodeTypes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNodeTypes() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNodeTypesRequest, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* streamer) {
                       return this->StreamedListNodeTypes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNodeTypes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNodeTypes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNodeTypesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNodeTypesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNodeTypes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNodeTypesRequest,::google::cloud::vmwareengine::v1::ListNodeTypesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNodeType : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNodeType() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNodeTypeRequest, ::google::cloud::vmwareengine::v1::NodeType>* streamer) {
                       return this->StreamedGetNodeType(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNodeType() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNodeType(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNodeTypeRequest* /*request*/, ::google::cloud::vmwareengine::v1::NodeType* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNodeType(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNodeTypeRequest,::google::cloud::vmwareengine::v1::NodeType>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ShowNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ShowNsxCredentials() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* streamer) {
                       return this->StreamedShowNsxCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ShowNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ShowNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedShowNsxCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ShowNsxCredentialsRequest,::google::cloud::vmwareengine::v1::Credentials>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ShowVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ShowVcenterCredentials() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest, ::google::cloud::vmwareengine::v1::Credentials>* streamer) {
                       return this->StreamedShowVcenterCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ShowVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ShowVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest* /*request*/, ::google::cloud::vmwareengine::v1::Credentials* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedShowVcenterCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ShowVcenterCredentialsRequest,::google::cloud::vmwareengine::v1::Credentials>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetNsxCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetNsxCredentials() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResetNsxCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetNsxCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetNsxCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetNsxCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ResetNsxCredentialsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ResetVcenterCredentials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ResetVcenterCredentials() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedResetVcenterCredentials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ResetVcenterCredentials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ResetVcenterCredentials(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedResetVcenterCredentials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ResetVcenterCredentialsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateHcxActivationKey() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateHcxActivationKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateHcxActivationKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateHcxActivationKeyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListHcxActivationKeys : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListHcxActivationKeys() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* streamer) {
                       return this->StreamedListHcxActivationKeys(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListHcxActivationKeys() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListHcxActivationKeys(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListHcxActivationKeys(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListHcxActivationKeysRequest,::google::cloud::vmwareengine::v1::ListHcxActivationKeysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetHcxActivationKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetHcxActivationKey() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest, ::google::cloud::vmwareengine::v1::HcxActivationKey>* streamer) {
                       return this->StreamedGetHcxActivationKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetHcxActivationKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetHcxActivationKey(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest* /*request*/, ::google::cloud::vmwareengine::v1::HcxActivationKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetHcxActivationKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetHcxActivationKeyRequest,::google::cloud::vmwareengine::v1::HcxActivationKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest, ::google::cloud::vmwareengine::v1::NetworkPolicy>* streamer) {
                       return this->StreamedGetNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest* /*request*/, ::google::cloud::vmwareengine::v1::NetworkPolicy* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetNetworkPolicyRequest,::google::cloud::vmwareengine::v1::NetworkPolicy>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListNetworkPolicies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListNetworkPolicies() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* streamer) {
                       return this->StreamedListNetworkPolicies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListNetworkPolicies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListNetworkPolicies(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListNetworkPolicies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListNetworkPoliciesRequest,::google::cloud::vmwareengine::v1::ListNetworkPoliciesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(26,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteNetworkPolicy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteNetworkPolicy() {
      ::grpc::Service::MarkMethodStreamed(27,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteNetworkPolicy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteNetworkPolicy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteNetworkPolicy(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteNetworkPolicy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteNetworkPolicyRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(28,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreateVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(29,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdateVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(30,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeleteVmwareEngineNetworkRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVmwareEngineNetwork : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVmwareEngineNetwork() {
      ::grpc::Service::MarkMethodStreamed(31,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* streamer) {
                       return this->StreamedGetVmwareEngineNetwork(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVmwareEngineNetwork() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVmwareEngineNetwork(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest* /*request*/, ::google::cloud::vmwareengine::v1::VmwareEngineNetwork* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVmwareEngineNetwork(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetVmwareEngineNetworkRequest,::google::cloud::vmwareengine::v1::VmwareEngineNetwork>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVmwareEngineNetworks : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVmwareEngineNetworks() {
      ::grpc::Service::MarkMethodStreamed(32,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* streamer) {
                       return this->StreamedListVmwareEngineNetworks(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVmwareEngineNetworks() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVmwareEngineNetworks(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVmwareEngineNetworks(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksRequest,::google::cloud::vmwareengine::v1::ListVmwareEngineNetworksResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreatePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(33,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreatePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreatePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::CreatePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(34,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest, ::google::cloud::vmwareengine::v1::PrivateConnection>* streamer) {
                       return this->StreamedGetPrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest* /*request*/, ::google::cloud::vmwareengine::v1::PrivateConnection* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::GetPrivateConnectionRequest,::google::cloud::vmwareengine::v1::PrivateConnection>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateConnections : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateConnections() {
      ::grpc::Service::MarkMethodStreamed(35,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* streamer) {
                       return this->StreamedListPrivateConnections(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateConnections() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateConnections(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateConnections(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateConnectionsRequest,::google::cloud::vmwareengine::v1::ListPrivateConnectionsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(36,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::UpdatePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePrivateConnection : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePrivateConnection() {
      ::grpc::Service::MarkMethodStreamed(37,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeletePrivateConnection(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePrivateConnection() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePrivateConnection(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePrivateConnection(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::DeletePrivateConnectionRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes() {
      ::grpc::Service::MarkMethodStreamed(38,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* streamer) {
                       return this->StreamedListPrivateConnectionPeeringRoutes(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListPrivateConnectionPeeringRoutes(::grpc::ServerContext* /*context*/, const ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest* /*request*/, ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListPrivateConnectionPeeringRoutes(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesRequest,::google::cloud::vmwareengine::v1::ListPrivateConnectionPeeringRoutesResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListPrivateClouds<WithStreamedUnaryMethod_GetPrivateCloud<WithStreamedUnaryMethod_CreatePrivateCloud<WithStreamedUnaryMethod_UpdatePrivateCloud<WithStreamedUnaryMethod_DeletePrivateCloud<WithStreamedUnaryMethod_UndeletePrivateCloud<WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_ListNodeTypes<WithStreamedUnaryMethod_GetNodeType<WithStreamedUnaryMethod_ShowNsxCredentials<WithStreamedUnaryMethod_ShowVcenterCredentials<WithStreamedUnaryMethod_ResetNsxCredentials<WithStreamedUnaryMethod_ResetVcenterCredentials<WithStreamedUnaryMethod_CreateHcxActivationKey<WithStreamedUnaryMethod_ListHcxActivationKeys<WithStreamedUnaryMethod_GetHcxActivationKey<WithStreamedUnaryMethod_GetNetworkPolicy<WithStreamedUnaryMethod_ListNetworkPolicies<WithStreamedUnaryMethod_CreateNetworkPolicy<WithStreamedUnaryMethod_UpdateNetworkPolicy<WithStreamedUnaryMethod_DeleteNetworkPolicy<WithStreamedUnaryMethod_CreateVmwareEngineNetwork<WithStreamedUnaryMethod_UpdateVmwareEngineNetwork<WithStreamedUnaryMethod_DeleteVmwareEngineNetwork<WithStreamedUnaryMethod_GetVmwareEngineNetwork<WithStreamedUnaryMethod_ListVmwareEngineNetworks<WithStreamedUnaryMethod_CreatePrivateConnection<WithStreamedUnaryMethod_GetPrivateConnection<WithStreamedUnaryMethod_ListPrivateConnections<WithStreamedUnaryMethod_UpdatePrivateConnection<WithStreamedUnaryMethod_DeletePrivateConnection<WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListPrivateClouds<WithStreamedUnaryMethod_GetPrivateCloud<WithStreamedUnaryMethod_CreatePrivateCloud<WithStreamedUnaryMethod_UpdatePrivateCloud<WithStreamedUnaryMethod_DeletePrivateCloud<WithStreamedUnaryMethod_UndeletePrivateCloud<WithStreamedUnaryMethod_ListClusters<WithStreamedUnaryMethod_GetCluster<WithStreamedUnaryMethod_CreateCluster<WithStreamedUnaryMethod_UpdateCluster<WithStreamedUnaryMethod_DeleteCluster<WithStreamedUnaryMethod_ListSubnets<WithStreamedUnaryMethod_GetSubnet<WithStreamedUnaryMethod_UpdateSubnet<WithStreamedUnaryMethod_ListNodeTypes<WithStreamedUnaryMethod_GetNodeType<WithStreamedUnaryMethod_ShowNsxCredentials<WithStreamedUnaryMethod_ShowVcenterCredentials<WithStreamedUnaryMethod_ResetNsxCredentials<WithStreamedUnaryMethod_ResetVcenterCredentials<WithStreamedUnaryMethod_CreateHcxActivationKey<WithStreamedUnaryMethod_ListHcxActivationKeys<WithStreamedUnaryMethod_GetHcxActivationKey<WithStreamedUnaryMethod_GetNetworkPolicy<WithStreamedUnaryMethod_ListNetworkPolicies<WithStreamedUnaryMethod_CreateNetworkPolicy<WithStreamedUnaryMethod_UpdateNetworkPolicy<WithStreamedUnaryMethod_DeleteNetworkPolicy<WithStreamedUnaryMethod_CreateVmwareEngineNetwork<WithStreamedUnaryMethod_UpdateVmwareEngineNetwork<WithStreamedUnaryMethod_DeleteVmwareEngineNetwork<WithStreamedUnaryMethod_GetVmwareEngineNetwork<WithStreamedUnaryMethod_ListVmwareEngineNetworks<WithStreamedUnaryMethod_CreatePrivateConnection<WithStreamedUnaryMethod_GetPrivateConnection<WithStreamedUnaryMethod_ListPrivateConnections<WithStreamedUnaryMethod_UpdatePrivateConnection<WithStreamedUnaryMethod_DeletePrivateConnection<WithStreamedUnaryMethod_ListPrivateConnectionPeeringRoutes<Service > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace vmwareengine
}  // namespace cloud
}  // namespace google


#endif  // GRPC_google_2fcloud_2fvmwareengine_2fv1_2fvmwareengine_2eproto__INCLUDED
